/* global define */
define('WS.Data/Adapter/IMetaData', function () {
   'use strict';

   /**
    * Интерфейс адаптера для работы с метаданными
    * @interface WS.Data/Adapter/IMetaData
    * @public
    * @author Мальцев Алексей
    */

   return /** @lends WS.Data/Adapter/IMetaData.prototype */{
      '[WS.Data/Adapter/IMetaData]': true,

      /**
       * Возвращает описание метаданных
       * @return {Array.<WS.Data/Format/Field>}
       */
      getMetaDataDescriptor: function () {
         throw new Error('Method must be implemented');
      },

      /**
       * Возвращает значение из метаданных по имени
       * @param {String} name Поле метаданных
       * @return {*}
       */
      getMetaData: function (name) {
         throw new Error('Method must be implemented');
      },

      /**
       * Сохраняет значение в метаданных с указанным именем
       * @param {String} name Поле метаданных
       * @param {*} value Значение
       */
      setMetaData: function (name, value) {
         throw new Error('Method must be implemented');
      }
   };
});
