/* global define, require */
define('WS.Data/Chain/Enumerable', [
   'WS.Data/Chain/Abstract'
], function (
   Abstract
) {
   'use strict';

   /**
    * Цепочка по IEnumerable.
    * @class WS.Data/Chain/Enumerable
    * @extends WS.Data/Chain/Abstract
    * @public
    * @author Мальцев Алексей
    */

   var Enumerable = Abstract.extend(/** @lends WS.Data/Chain/Enumerable.prototype */{
      '[WS.Data/Chain/Enumerable]': true,

      constructor: function Enumerable(source) {
         if (!source || !source['[WS.Data/Collection/IEnumerable]']) {
            throw new TypeError('Source must implement WS.Data/Collection/IEnumerable');
         }
         Enumerable.superclass.constructor.call(this, source);
      },

      //region WS.Data/Collection/IEnumerable

      getEnumerator: function () {
         return this._source.getEnumerator();
      },

      each: function (callback, context) {
         return this._source.each(callback, context);
      },

      //endregion WS.Data/Collection/IEnumerable

      //region WS.Data/Chain/Abstract

      toObject: function () {
         if (this._source['[WS.Data/Entity/IObject]']) {
            //implements WS.Data/Entity/IObject
            var result = {};
            this.each(function(key, value) {
               result[key] = value;
            });
            return result;
         }
         return Enumerable.superclass.toObject.call(this);
      }

      //endregion WS.Data/Chain/Abstract
   });

   return Enumerable;
});
