/* global define */
define('WS.Data/Collection/LoadableList', [
   'WS.Data/Collection/List',
   'WS.Data/Collection/IBind',
   'WS.Data/Query/IQueryable',
   'WS.Data/Collection/ISourceLoadable',
   'WS.Data/Collection/LoadableListMixin'
], function (
   List,
   IBindCollection,
   IQueryable,
   ISourceLoadable,
   LoadableListMixin
) {
   'use strict';

   /**
    * Список, загружаемый через источник данных
    * @class WS.Data/Collection/LoadableList
    * @extends WS.Data/Collection/List
    * @implements WS.Data/Collection/IBind
    * @implements WS.Data/Query/IQueryable
    * @implements WS.Data/Collection/ISourceLoadable
    * @mixes WS.Data/Collection/LoadableListMixin
    * @deprecated
    * @author Мальцев Алексей
    */

   var LoadableList = List.extend([IBindCollection, IQueryable, ISourceLoadable, LoadableListMixin], /** @lends WS.Data/Collection/LoadableList.prototype */{
      '[WS.Data/Collection/LoadableList]': true
   });

   return LoadableList;
});
