/* global define */
define('WS.Data/Entity/VersionableMixin', [
], function (
) {
   'use strict';

   /**
    * Миксин, позволяющий клонировать объекты.
    * @mixin WS.Data/Entity/VersionableMixin
    * @public
    * @author Мальцев Алексей
    */

   var VersionableMixin = /**@lends WS.Data/Entity/VersionableMixin.prototype  */{
      '[WS.Data/Entity/VersionableMixin]': true,

      //region WS.Data/Entity/IVersionable
      _version: 0,

      getVersion: function() {
         return this._version;
      },

      _nextVersion: function() {
         this._version++;
         if (this['[WS.Data/Entity/ManyToManyMixin]']) {
            //mixes WS.Data/Entity/ManyToManyMixin
            this._getMediator().belongsTo(this, function(parent) {
               if (parent &&
                  parent['[WS.Data/Entity/IVersionable]']//implements WS.Data/Entity/IVersionable
               ) {
                  parent._nextVersion();
               }
            });
         }
      }

      //endregion WS.Data/Entity/IVersionable
   };

   return VersionableMixin;
});
