/* global define */
define('WS.Data/Format/DictionaryField', [
   'WS.Data/Format/Field'
], function (
   Field
) {
   'use strict';

   /**
    * Формат поля со словарём (абстрактный класс)
    * @class WS.Data/Format/DictionaryField
    * @extends WS.Data/Format/Field
    * @public
    * @author Мальцев Алексей
    */

   var DictionaryField = Field.extend(/** @lends WS.Data/Format/DictionaryField.prototype */{
      '[WS.Data/Format/DictionaryField]': true,

      /**
       * @cfg {Array.<String>} Словарь возможных значений
       * @name WS.Data/Format/DictionaryField#dictionary
       * @see getDictionary
       */
      _$dictionary: null,

      /**
       * @cfg {Array.<String>} Локализованный словарь возможных значений
       * @name WS.Data/Format/DictionaryField#localeDictionary
       * @see getDictionary
       */
      _$localeDictionary: null,

      //region Public methods

      /**
       * Возвращает словарь возможных значений
       * @return {Array.<String>}
       * @see dictionary
       */
      getDictionary: function () {
         return this._$dictionary;
      },

      /**
       * Возвращает словарь возможных значений
       * @return {Array.<String>}
       * @see dictionary
       */
      getLocaleDictionary: function () {
         return this._$localeDictionary;
      }

      //endregion Public methods

   });

   return DictionaryField;
});
