/* global define */
define('WS.Data/Mediator/IReceiver', function () {
   'use strict';

   /**
    * Интерфейс сущности, взаимодействующей с посредником
    * @interface WS.Data/Mediator/IReceiver
    * @author Мальцев Алексей
    */

   return /** @lends WS.Data/Mediator/IReceiver.prototype */{
      '[WS.Data/Mediator/IReceiver]': true,

      /**
       * Принимает уведомление от посредника об изменении отношений
       * @param {Object} which Объект, уведомивший об изменении отношений
       * @param {Array.<String>} route Маршрут до объекта
       */
      relationChanged: function (which, route) {
         throw new Error('Method must be implemented');
      }
   };
});
