/* global define */
define('WS.Data/Source/Provider/IAbstract', function () {
   'use strict';

   /**
    * Интерфейс абстрактного провайдера
    * @interface WS.Data/Source/Provider/IAbstract
    * @public
    * @author Мальцев Алексей
    */

   return /** @lends WS.Data/Source/Provider/IAbstract.prototype */{
      '[WS.Data/Source/Provider/IAbstract]': true,

      /**
       * Вызывает удаленный сервис
       * @param {String} name Имя сервиса
       * @param {Object|Array} [args] Аргументы вызова
       * @return {Core/Deferred} Асинхронный результат операции
       */
      call: function(name, args) {
         throw new Error('Method must be implemented');
      }
   };
});
