define('Core/ClientsGlobalConfig', [
   'Core/AbstractConfig',
   'Core/constants'
], function(
   AbstractConfig,
   _const
) {
   /**
    * Класс для взаимодействия с параметрами глобальной конфигурации Клиента
    * В качестве основного хранилища выступает бизнес-логика.
    * Все операции отражаются на глобальном контексте.
    *
    * @author Бегунов А.В.
    * @class Core/ClientsGlobalConfig
    * @extends Core/AbstractConfig
    * @public
    * @singleton
    */
   var ClientsGlobalConfig = new (AbstractConfig.extend(/** @lends Core/ClientsGlobalConfig.prototype */{
      _getObjectName: function() {
         return 'ГлобальныеПараметрыКлиента';
      },
      _isConfigSupport: function() {
         return _const.isNodePlatform || _const.globalConfigSupport;
      }
   }))();

   return ClientsGlobalConfig;
});