define('Core/SessionStorage', [
   'Core/UserInfo'
], function (UserInfo) {
   var saveSSTimeout;
   var storage;
   // На тот случай, если у нас нет sessionStorage, то храним просто все в объекте
   var fStorage = {
      getItem: function() {},
      setItem: function() {},
      removeItem: function() {}
   };
   try {
      storage = (typeof window !== 'undefined' && sessionStorage) || fStorage;
   } catch (err) {
      storage = fStorage
   }
   var sessionName = 'wsss';
   var ss = storage.getItem(sessionName);

   if (ss) {
      try {
         ss = JSON.parse(ss) || {};
      } catch(e) {
         ss = {};
      }
   } else {
      ss = {};
   }

   if (!UserInfo.isValid(ss.user)) {
      //если изменились пользователи или клиент, то чистим
      clearSS();
      /*
       * Для совместимости при переходе с пользователя на 3.17.210 на пользователя на 3.17.150
       * дублируем юзера в поле sid
       * удалить в 3.17.300
       */
      ss.user = ss.sid = UserInfo.getCurrent();
   }

   function clearSS() {
      storage.removeItem(sessionName);
      ss = {};
   }

   function saveSS(withoutTimer) {
       if (withoutTimer) {
           setItem(sessionName, JSON.stringify(ss));
       } else if (!saveSSTimeout) {
           saveSSTimeout = setTimeout(function() {
               setItem(sessionName, JSON.stringify(ss));
               saveSSTimeout = null;
           }, 100);
       }
   }
   function setItem(key, item) {
       try {
          storage.setItem(key, item);
       } catch (err) {
          // ignore
       }
   }

   /**
    * class Core/SessionStorage
    * singleton
    * @public
    */
   var SessionStorage = /** @lends Core/SessionStorage.prototype */{
      get: function(key) {
         return ss[key];
      },
      set: function(key, value, withoutTimer) {
         if (!key) return;
         if (value == null && typeof key == 'object' && Object.prototype.toString.call(key) == '[object Object]') {
            // Обходимся без нашего helpers
            for (var k in key) {
               if (key.hasOwnProperty(k)) {
                  ss[k] = key[k];
               }
            }
         } else {
            ss[key] = value;
         }

         saveSS(withoutTimer);
      },
      remove: function(key) {
         delete ss[key];
         saveSS();
      },
      toObject: function() {
         return ss;
      }
   };

   return SessionStorage;
});