define('Core/helpers/Array/flatten', function () {

    /**
     * Модуль, в котором описана функция <b>flatten(arr)</b>.
     *
     * "Выравнивает" вложенные массивы (любого уровня вложенности), склеивая в одноуровневый массив.
     *
     *
     *
     * @param {Array} arr
     * @returns {Array}
     * @example
     * <pre>
     * flatten([1, [2], [3, [[4]]]]) => [1, 2, 3, 4]
     * </pre>
     */
    return function flatten(arr) {
        var result = [], i, ln = arr.length;
        for (i = 0; i !== ln; i++) {
            if (Array.isArray(arr[i])) {
                result = result.concat(flatten(arr[i]));
            } else {
                result.push(arr[i]);
            }
        }
        return result;
    };
});