define('Core/helpers/Function/memoize', function () {

    /**
    *
    * Модуль, в котором описана функция <b>memoize(func, cachedFuncName)</b>.
    *
    * @class Core/helpers/Function/memoize
    * @public
    * @author Мальцев А.А.
    */
    return function (func, cachedFuncName) {
        var wrapFn = function () {
            var res = func.call(this),
                cached = function () {
                    return res;
                },
                self = this;

            cached.reset = function () {
                self[cachedFuncName] = wrapFn;
                res = undefined;
            };

            this[cachedFuncName] = cached;
            return res;
        };
        wrapFn.reset = function () {};
        wrapFn.wrappedFunction = func;

        return wrapFn;
    };
});