define('Core/helpers/Function/runDelayed', ['Core/detection'], function() {
   /**
    * Модуль, в котором описана функция <b>runDelayed(fn)</b>.
    *
    * Метод Вызывает функцию асинхронно, через requestAnimationFrame, или на крайний случай setTimeout
    *
    * <h2>Параметры функции</h2>
    * <ul>
    *     <li><b>fn</b> {Function} - исходная функция, вызов которой нужно асинхронно.</li>
    * </ul>
    *
    * @class Core/helpers/Function/runDelayed
    * @public
    * @author Мальцев А.А.
    */
   return function runDelayed(fn) {
      var win = typeof window !== 'undefined' ? window : null;
      /*Это Дико тупит в ие
      if (win && win.setImmediate && detection.isIE) {
         // В IE используем его собственный setImmediate
         // https://developer.mozilla.org/ru/docs/Web/API/Window/setImmediate
         win.setImmediate(fn);
      } else */if (win && win.requestAnimationFrame) {
         win.requestAnimationFrame(fn);
      } else {
         setTimeout(fn, 0);
      }
   }

});