define('Core/helpers/Hcontrol/configStorage', [
    'Core/helpers/random-helpers'
], function (
    randomHelpers
) {
    /**
     *
     * Модуль работы с хранилищем настроек контролов.
     * @class Core/helpers/Hcontrol/configStorage
     * @public
     * @author Шипин А.А.
     */

   var
       clientConfigAttrPrefix = 'cfg-',
       configStorage = {};

   var configStorages = /** @lends Core/helpers/Hcontrol/configStorage.prototype */{
       /**
        *
        * @param key
        * @param value
        */
       setValue: function (key, value) {
           configStorage[key] = value;
       },
       /**
        *
        * @param json
        * @returns {string|*}
        */
       pushValue: function (json) {
           var id;
           id = randomHelpers.randomId(clientConfigAttrPrefix);
           configStorages.setValue(id, json);
           return id;
       },
       /**
        *
        * @param cfgObject
        */
       merge: function (cfgObject) {
           for (var prop in cfgObject) {
               if (cfgObject.hasOwnProperty(prop)) {
                   configStorages.setValue(prop, cfgObject[prop]);
                   if (configStorages.hasKey(prop) === undefined) {
                       configStorages.deleteKey(prop);
                   }
               }
           }
       },
       /**
        *
        * @param Key
        */
       deleteString: function (Key) {
           if (Key && Key.indexOf(clientConfigAttrPrefix) === 0) {
               configStorages.deleteKey(Key);
           }
       },
       /**
        *
        * @param key
        */
       deleteKey: function (key) {
           delete configStorage[key];
       },
       /**
        *
        */
       clear: function () {
           configStorage = {};
       },
       /**
        *
        * @param key
        * @returns {*|{}}
        */
       getValue: function (key) {
           return configStorage[key] || {};
       },
       /**
        *
        * @param key
        * @returns {*|undefined}
        */
       hasKey: function (key) {
           return configStorage[key] || undefined;
       },
       /**
        *
        * @returns {{}}
        */
       getData: function () {
           return configStorage;
       }
   };

   return configStorages;
});
