define('Core/helpers/String/escapeTagsFromStr', function () {

    /**
     * Модуль, в котором описана функция <b>escapeTagsFromStr(str, tags)</b>, которая удаляет указанные тэги из строки.
     *
     * <h2>Параметры функции</h2>
     * <ul>
     *    <li>{String} str Строка для преобразования.</li>
     *    <li>{Array|String} tags Массив тэгов, которые необходимо убрать из строки.</li>
     * </ul>
     *
     * @class Core/helpers/String/escapeTagsFromStr
     * @public
     * @author Мальцев А.А.
     */
    //SBIS3.CORE.FieldLabel, SBIS3.CORE.FieldLink, SBIS3.CORE.FilterButton, SBIS3.CORE.RequestHistoryPlugin, SBIS3.CORE.HierarchyViewAbstract,
    // SBIS3.CORE.Infobox, SBIS3.CORE.LoadingIndicator, SBIS3.CORE.Menu, SBIS3.CORE.NavigationPanel, SBIS3.CORE.SimpleDialogAbstract, SBIS3.CORE.TabButtons, SBIS3.CORE.TableView, Deprecated/Controls/TableView/plugins/AtPlaceEdit-plugin

    return function () {
        var reCache = {};

        return function (str, tags) {
            var tagString, re;
            if (typeof tags == 'string')
                tags = [tags];
            if (typeof str == 'string' && tags instanceof Array) {
                tagString = tags.join('|');
                re = reCache[tagString] || (reCache[tagString] = new RegExp('<(?=\/*(?:' + tagString + '))[^>]+>', 'ig'));
                re.lastIndex = 0;
                str = str.replace(re, '');
            }
            return str;
        }
    }();

});