define('Core/helpers/URLHelpers', ['Core/cookie'], function(cookie) {
   'use strict';

    /**
     * @class Core/helpers/URLHelpers
     * @public
     * @author Крайнов Д.О.
     * @deprecated
     */
   var URLHelpers = /** @lends Core/helpers/URLHelpers.prototype */{
      getCookie: cookie.get,

      setCookie: cookie.set,

      getQueryParam: function(name) {
         var
            req = this._getReq(),
            regExp = new RegExp('[?&]' + name + '=([^&]*)');
         return req ? req.query[name] : this._parseString(location.search, regExp);
      },
      _parseString: function(string, regExp) {
         var match = regExp.exec(string);
         return match && decodeURI(match[1]);
      },
      getQuery: function() {
         var req = this._getReq();
         return req ? req.query : location.search.substr(1);
      },
      setQueryParam: function(name, value) {
         var
            queryArray = location.search.substr(1).split('&'),
            existingParam = false,
            queryParam;
         if (queryArray.length) {
            queryArray = queryArray.map(function(elem) {
               queryParam = elem.split('=');
               if (queryParam[0] === name) {
                  queryParam[1] = value;
                  existingParam = true;
                  return queryParam.join('=');
               }
               return elem;
            });
            if (!existingParam) {
               queryArray.push(name + '=' + value);
            }
         }
         //TODO: Лепит лишние &
         history.pushState(history.state, '', location.pathname + '?' + queryArray.join('&') + location.hash);
      },
      removeQueryParam: function(name) {
         var queryArray = location.search.substr(1).split('&');
         if (queryArray.length) {
            queryArray = queryArray.filter(function(elem) {
               return elem.split('=')[0] !== name;
            });
            history.pushState(history.state, '', location.pathname + '?' + queryArray.join('&') + location.hash);
         }
      },
      getUserAgent: function() {
         var req = this._getReq();
         return req ? req.headers['user-agent'] : navigator.userAgent;
      },
      getOriginalUrl: function() {
         var req = this._getReq();
         return req ? req.originalUrl : (location.pathname + location.search);
      },
      getHostName: function() {
         var req = this._getReq();
         return req ? req.hostname : location.hostname;
      },
      getPath: function() {
         var req = this._getReq();
         return req ? req.path : location.pathname;
      },
      getHashParam: function(name) {
         var result = "";
         if (window) {
            var
               hash = decodeURI(location.hash),
               reg = new RegExp("(?:#|&)" + name + "=(?:[^&]+$|[^&]+(?=&))", "");
            result = hash.match(reg);
         }
         return result ? (result[0].replace(/^./, "").replace(name + "=", "")).replace(/:a:/g, "&") : undefined;
      },
      _getReq: function() {
         return process && process.domain && process.domain.req;
      }
   };
   return URLHelpers;
});