define('Core/helpers/additional-helpers',[
   'Core/Deferred',
   'Core/deprecated',
   'Core/helpers/getType',
   'Core/helpers/openFile',
   'Core/helpers/vital/processImagePath',
   'Core/EventBus',
   'Core/IoC'
], function(Deferred, cDeprecated, getType, openFile, processImagePath){

   var helperDeprecator = cDeprecated.callNextWrapper;
   var getHelpersDeprecatorWrapper = function (helperName, newName) {
      return function () {
         cDeprecated.showInfoLog('Хелпер Core/helpers/additional-helpers::' + helperName + ' помечен как deprecated и будет удален в 3.17.110. Подключите явно ' + (newName ? newName : 'Deprecated/helpers/additional-helpers') + ', чтобы им пользоваться');
      }
   };
    /**
     * @class Core/helpers/additional-helpers
     * @deprecated
     * @public
     * @author Мальцев А.А.
     * @deprecated
     */
   var addHelpers = /** @lends  Core/helpers/additional-helpers.prototype */{
      callbackWrapper: helperDeprecator(Deferred.callbackWrapper, function() {
         cDeprecated.showInfoLog('Хелпер $ws.helpers.callbackWrapper помечен как deprecated и будет удален в 3.18. Подключите явно Core/Deferred и используйте соответсвующий метод');
      }),
      processImagePath: processImagePath,

      type: helperDeprecator(getType, getHelpersDeprecatorWrapper('type', 'Core/helpers/getType')),

      /**
       * Открывает файл с помощью СБИС.Плагин через расширение FileLink.
       * @example
       * <pre>
       * helpers.openFile('C:\update.txt').addCallback(
       *    function() {
       *        helpers.alert('Файл успешно открыт!');
       *    })
       *    .addErrback(function() {
       *        helpers.alert('При открытии файла произошла ошибка.');
       *    });
       * </pre>
       * @param {String} fileName Имя открываемого файла.
       * @param {String} pluginMode Отображения информационного окна плагина (в случае ошибки) (только 1 раз: runOnce, всегда: always)
       * @returns {Deferred} Деферред с результатом выполнения функции.
       */
      openFile: helperDeprecator(openFile, getHelpersDeprecatorWrapper('openFile', 'Core/helpers/openFile'))
   };

   return addHelpers;
});