define('Core/helpers/collection-helpers',[
   'Core/deprecated',
   'Core/helpers/Array/uniq',
   'Core/helpers/Object/isEqual',
   'Core/helpers/Object/find',
   'Core/helpers/Object/findKey',
   'Core/helpers/Array/findIndex',
   'Core/helpers/Array/flatten',
   'Deprecated/helpers/collection-helpers'
], function(
   cDeprecated,
   arrayUniq,
   objectIsEqual,
   objectFind,
   objectFindKey,
   arrayFindIndex,
   flatten,
   deprecatedHelpers
) {

   var helperDeprecator = cDeprecated.callNextWrapper;
   var getHelpersDeprecatorWrapper = function (helperName, newName) {
      return function () {
         cDeprecated.showInfoLog('Хелпер Core/helpers/collection-helpers::' + helperName + ' помечен как deprecated и будет удален в 3.18.' + (newName ? ' Подключите явно ' + newName + ', чтобы им пользоваться' : ''));
      }
   };
    /**
     * @class Core/helpers/collection-helpers
     * @deprecated
     * @public
     * @author Мальцев А.А.
     * @deprecated
     */
   var collectionHelpers = /** @lends  Core/helpers/collection-helpers.prototype */{
      forEach: helperDeprecator(deprecatedHelpers.forEach, getHelpersDeprecatorWrapper('forEach')),
      map: helperDeprecator(deprecatedHelpers.map, getHelpersDeprecatorWrapper('map')),
      uniqueArray: helperDeprecator(arrayUniq, getHelpersDeprecatorWrapper('uniqueArray', 'Core/helpers/Array/uniq')),
      filter: helperDeprecator(deprecatedHelpers.filter, getHelpersDeprecatorWrapper('filter')),
     /**
      *
      * @param obj
      * @param iterateCallback
      * @param context
      * @returns {{}}
      */
      filterObj: helperDeprecator(deprecatedHelpers.filterObj, getHelpersDeprecatorWrapper('filterObj')),
      find: helperDeprecator(objectFind, getHelpersDeprecatorWrapper('find', 'Core/helpers/Object/find')),
      findIdx: helperDeprecator(function(obj, predicate, context, defaultResult) {
         if (defaultResult === undefined) {
            defaultResult = -1;
         }
         if (Array.isArray(obj)) {
             var index = arrayFindIndex.call(this, obj, predicate, context);
             return index === -1 ? defaultResult : index;
         }
         return objectFindKey.call(this, obj, predicate, context, defaultResult);
      }, getHelpersDeprecatorWrapper('findIdx', 'Core/helpers/Object/findKey или Core/helpers/Array/findIndex')),
      flatten: flatten,
      reduce: helperDeprecator(deprecatedHelpers.reduce, getHelpersDeprecatorWrapper('reduce')),
      isEqualObject: helperDeprecator(objectIsEqual, getHelpersDeprecatorWrapper('isEqualObject', 'Core/helpers/Object/isEqual')),
      objectsDiff: helperDeprecator(deprecatedHelpers.objectsDiff, getHelpersDeprecatorWrapper('objectsDiff')),
     /**
      * Возвращает количество свойств в объекте.
      * @param {Object} obj Объект, у которого хотим узнать кол-во свойств.
      * @returns {Number} Количество свойств объекта.
      */
      countOfProperties: helperDeprecator(deprecatedHelpers.countOfProperties, getHelpersDeprecatorWrapper('countOfProperties')),
     /**
      * Выбирает из объекта указанные свойства, возвращает объект с выбранными свойствами.
      * @param {Object} obj Объект, из которого выбираются свойства.
      * @param {String[]} propNames Свойства, которые нужно выбрать - массив имён.
      * @returns {Object} Объект, содержащий указанные свойства. Если какого-то свойства нет в объекте obj, то его не будет и в результате.
      */
      pick: helperDeprecator(deprecatedHelpers.pick, getHelpersDeprecatorWrapper('pick')),
      isEqualValues: helperDeprecator(deprecatedHelpers.isEqualValues, getHelpersDeprecatorWrapper('isEqualValues', 'Array.prototype.some или Core/helpers/Object/isEqual')),
      isPlainObject: deprecatedHelpers.isPlainObject,
      isPlainArray: deprecatedHelpers.isPlainArray
   };

   return collectionHelpers;
});