define('Core/helpers/dom&controls-helpers', [
   'Core/constants',
   'Core/core-extend-initializer',
   'Core/deprecated',
   'Deprecated/helpers/dom&controls-helpers',
   'Core/helpers/Hcontrol/replaceContainer',
   'Core/helpers/Hcontrol/getElementCachedDim',
   'Core/helpers/Hcontrol/setElementCachedSize',
   'Core/helpers/Hcontrol/focusControl',
   'Core/helpers/Hcontrol/doAutofocus',
   'Core/helpers/Hcontrol/isElementVisible',
   'Core/helpers/Hcontrol/getChildContainers',
   'Core/helpers/Hcontrol/isScrollable',
   'Core/helpers/Hcontrol/hasScrollbar',
   'Core/helpers/Hcontrol/mergeAttributes',
   'Core/helpers/Hcontrol/trackElement',
   'Core/helpers/Hcontrol/getScrollWidth',
   'Core/Deferred',
   'Core/compatibility',
   'Core/EventBus',
   'Core/IoC'
], function(
   constants,
   coreInitializer,
   cDeprecated,
   deprecatedHelpers,
   replaceContainer,
   getElementCachedDim,
   setElementCachedSize,
   focusControl,
   doAutofocus,
   isElementVisible,
   getChildContainers,
   isScrollable,
   hasScrollbar,
   mergeAttributes,
   trackElement,
   getScrollWidth
){

   var helperDeprecator = cDeprecated.callNextWrapper;
   var getHelpersDeprecatorWrapper = function (helperName, newName) {
      return function () {
         cDeprecated.showInfoLog('Хелпер Core/helpers/dom&controls-helpers::' + helperName + ' помечен как deprecated и будет удален в 3.18.' + (newName ? ' Подключите явно ' + newName + ', чтобы им пользоваться' : ''));
      }
   };

   /**
   * @class Core/helpers/dom&controls-helpers
   * @deprecated
   * @public
   * @author Мальцев А.А.
   * @deprecated
   */
   var domHelpers = /** @lends  Core/helpers/dom&controls-helpers.prototype */{

      findControlsInContainer: helperDeprecator(deprecatedHelpers.findControlsInContainer, getHelpersDeprecatorWrapper('findControlsInContainer')),

      clearContainer: helperDeprecator(deprecatedHelpers.clearContainer, getHelpersDeprecatorWrapper('clearContainer')),

      detectCommonDataContainer: helperDeprecator(deprecatedHelpers.detectCommonDataContainer, getHelpersDeprecatorWrapper('detectCommonDataContainer')),

      getTagName: helperDeprecator(deprecatedHelpers.getTagName, getHelpersDeprecatorWrapper('getTagName')),

      getScrollOffset: helperDeprecator(deprecatedHelpers.getScrollOffset, getHelpersDeprecatorWrapper('getScrollOffset')),

      isScrollable: isScrollable,

      hasScrollbar: hasScrollbar,

      hasVerticalScrollbar: hasScrollbar.vertical,

      hasHorizontalScrollbar: hasScrollbar.horizontal,
       /**
        *
        */
      getNonControlSize: helperDeprecator(deprecatedHelpers.getNonControlSize, getHelpersDeprecatorWrapper('getNonControlSize')),

      getScrollWidth: getScrollWidth,

      /**
       * Переводит координаты относительно экрана в координаты относительно документа.
       * @param {{top: number, left: number}} pos
       * @return {{top: number, left: number}}
       */
      //MOVE_TO КРАЙНОВ
      screenPosToOffset: function(pos) {
         var
            body = document.body,
            docElem = document.documentElement,
            scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
            scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
            clientTop = docElem.clientTop || body.clientTop || 0,
            clientLeft = docElem.clientLeft || body.clientLeft || 0,
            top = pos.top + scrollTop - clientTop,
            left = pos.left + scrollLeft - clientLeft;

         return { top: Math.round(top), left: Math.round(left) };
      },

      /**
       * Переводит координаты относительно документа в координаты относительно экрана.
       * @param {{top: number, left: number}} pos
       * @return {{top: number, left: number}}
       */
      //MOVE_TO КРАЙНОВ
      offsetPosToScreen: function(pos) {
         var
            body = document.body,
            docElem = document.documentElement,
            scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop,
            scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft,
            clientTop = docElem.clientTop || body.clientTop || 0,
            clientLeft = docElem.clientLeft || body.clientLeft || 0,
            top = pos.top - scrollTop + clientTop,
            left = pos.left - scrollLeft + clientLeft;

         return { top: Math.round(top), left: Math.round(left) };
      },

      /**
       * Вычисляет координаты элемента с учетом скроллинга
       * @param elem Элемент, координаты которого надо вычислить.
       * @return {Object} Координаты элемента в виде объекта { top: , left: }
       */
      //MOVE_TO КРАЙНОВ
      getOffsetRect: function(elem) {
         return domHelpers.screenPosToOffset(elem.getBoundingClientRect());
      },

      insertCss: helperDeprecator(deprecatedHelpers.insertCss, getHelpersDeprecatorWrapper('insertCss')),

      contains: helperDeprecator(deprecatedHelpers.contains, getHelpersDeprecatorWrapper('contains')),

      getTextSelection: helperDeprecator(deprecatedHelpers.getTextSelection, getHelpersDeprecatorWrapper('getTextSelection')),

      clearSelection: helperDeprecator(deprecatedHelpers.clearSelection, getHelpersDeprecatorWrapper('clearSelection')),
      /**
       * Располагает элемент так, чтобы он полностью помещался в окне (координаты - абсолютные, скролл учитывается
       * @param {Object} offset Объект с координатами top и left.
       * @param {Number} width Ширина объекта.
       * @param {Number} [height] Высота объекта. Если не передать, не будет переносить вниз.
       * @returns {Object} Объект с координатами top и left (тот же самый объект, что и offset).
       */
      //MOVE_TO КРАЙНОВ
      positionInWindow: function (offset, width, height) {
         var scrollTop = constants.$win.scrollTop(),
            scrollLeft = constants.$win.scrollLeft(),
            maxWidth = constants.$win.width(),
            maxHeight = constants.$win.height();

         offset.top -= scrollTop;
         offset.left -= scrollLeft;

         if (offset.left + width > maxWidth) {
            offset.left = maxWidth - width;
         }
         if (offset.left < 0) {
            offset.left = 0;
         }
         if (height !== undefined && offset.top + height > maxHeight) {
            offset.top = maxHeight - height;
         }
         if (offset.top < 0) {
            offset.top = 0;
         }

         offset.top += scrollTop;
         offset.left += scrollLeft;

         return offset;
      },

      replaceContainer: replaceContainer,

      getChildContainers: getChildContainers,
      /**
       * Метод для поиска контейнеров дочерних компонентов 1ой вложенности
       * @param {jQuery} root корневой элемент, в котором осуществляется поиск
       * @returns {Array} массив найденных элементов
       * @protected
       */
      //MOVE_TO ШИПИН
      getNestedComponents: function (root) {
         var
            topParent = root.get(0),
            components,
            deadCollection = [];

         if (topParent.id) {
            components = topParent.querySelectorAll('[data-pid="' + topParent.id + '"]');
            for (var i = 0, l = components.length; i < l; i++) {
               deadCollection.push(components[i]);
            }
         }
         else {
            deadCollection = domHelpers.getChildContainers(root, '[data-component]');
         }

         return deadCollection;
      },

      //MOVE_TO КРАЙНОВ
      isElementVisible: isElementVisible,

      ieFixInnerHTML: helperDeprecator(deprecatedHelpers.ieFixInnerHTML, getHelpersDeprecatorWrapper('ieFixInnerHTML')),
   
      getDefaultInstanceData: helperDeprecator(coreInitializer.call, getHelpersDeprecatorWrapper('getDefaultInstanceData', 'Core/core-extend-initializer.call')),
   
      mergeOptionsToDefaultOptions: helperDeprecator(coreInitializer.getInstanceOptionsByDefaults, getHelpersDeprecatorWrapper('mergeOptionsToDefaultOptions', 'Core/core-extend-initializer.getInstanceOptionsByDefaults')),
      
      resolveOptions: helperDeprecator(coreInitializer.getInstanceOptions, getHelpersDeprecatorWrapper('resolveOptions', 'Core/core-extend-initializer.getInstanceOptions')),


      getTextWidth: helperDeprecator(deprecatedHelpers.getTextWidth, getHelpersDeprecatorWrapper('getTextWidth')),

      mergeAttributes: mergeAttributes,

      parseMargins: helperDeprecator(deprecatedHelpers.parseMargins, getHelpersDeprecatorWrapper('parseMargins')),
      /**
       * Кроссбраузерно считает высоту страницы
       * @returns {Number}
       */
      //MOVE_TO КРАЙНОВ
      getDocumentHeight: function() {
         return Math.max(
            document.body.scrollHeight, document.documentElement.scrollHeight,
            document.body.offsetHeight, document.documentElement.offsetHeight,
            document.body.clientHeight, document.documentElement.clientHeight
         );
      },
       /**
        *
        */
      addXmlLog: helperDeprecator(deprecatedHelpers.addXmlLog, getHelpersDeprecatorWrapper('addXmlLog')),
      //HTMLView, AreaAbstract, Control/Grid, Control/Tabs

      setElementCachedSize: setElementCachedSize,
     //dt_layout, AreaAbstract

      getElementCachedDim: getElementCachedDim,
      /**
       * Метод проверяет, является ли один контрол дочерним для другого.
       * @param {Lib/Control/Control} parent потенциальный родитель.
       * @param {Lib/Control/Control} child  потенциальный ребёнок
       * @returns {Boolean} Признак того, что элемент является дочерним.
       */
      //MOVE_TO ШИПИН
      isChildControl: function(parent, child) {
         while (child && child !== parent) {
            child = child.getParent() || child.getOpener && child.getOpener();
         }
         return child === parent;
      },
      /**
       * Принудительно обновляет позиции элементов, отслеживаемых функцией helpers.trackElement.
       * Может потребоваться в редких случаях, когда меняются параметры body  типа overflow-y, в результате чего пропадает прокрутка у body,
       * и требуется исправить координаты элементов, абсолютно спозиционированных в body.
       * Такое происходит при показе первой панели в стеке панелей, и при скрытии последней панели из стека, и тогда, чтобы
       * не ждать обновления позиций по таймеру, чтобы элементы не "прыгали", стек панелей вызывает эту функцию.
       */
      //MOVE_TO КРАЙНОВ (отдельный хелпер)
      updateTrackedElements: function () {
         throw new Error("Хелпер updateTrackedElements был удалён.");
      },

      doAutofocus: doAutofocus,
      _findAutofocus: doAutofocus.findAutofocus,

      focusControl: focusControl,

      trackElement: trackElement
   };

   return domHelpers;
});
