define('Core/helpers/functional-helpers', [
   'Core/deprecated',
   'Core/helpers/Object/getPropertyType',
   'Core/core-debug',
   'Core/helpers/Function/memoize',
   'Core/helpers/Function/forAliveOnly',
   'Core/helpers/setSessionStorageValue',
   'Core/helpers/getSessionStorageValue',
   'Deprecated/helpers/functional-helpers'
], function(cDeprecated, getPropertyType, cDebug, memoize, forAliveOnly, setSessionStorageValue, getSessionStorageValue,deprecatedHelpers){

   var helperDeprecator = cDeprecated.callNextWrapper;
   var getHelpersDeprecatorWrapper = function (helperName, newName) {
      return function () {
         cDeprecated.showInfoLog('Хелпер Core/helpers/functional-helpers::' + helperName + ' помечен как deprecated и будет удален в 3.18.' + (newName ? ' Подключите явно ' + newName + ', чтобы им пользоваться' : ''));
      };
   };
    /**
     * @class Core/helpers/functional-helpers
     * @public
     * @author Мальцев А.А.
     * @deprecated
     */
   return /** @lends  Core/helpers/functional-helpers.prototype */{
      methodCaller: helperDeprecator(deprecatedHelpers.methodCaller, getHelpersDeprecatorWrapper('methodCaller')),
      constant: helperDeprecator(deprecatedHelpers.constant, getHelpersDeprecatorWrapper('constant')),
      nop: helperDeprecator(deprecatedHelpers.nop, getHelpersDeprecatorWrapper('nop')),

      memoize: memoize,

      forAliveOnly: forAliveOnly,

      getLocalStorageValue: helperDeprecator(getSessionStorageValue, getHelpersDeprecatorWrapper('getLocalStorageValue', 'Core/LocalStorageNative::getItem(key)')),

      setLocalStorageValue: helperDeprecator(setSessionStorageValue, getHelpersDeprecatorWrapper('setLocalStorageValue', 'Core/LocalStorageNative::setItem(value)')),

      hasFunctionProperty: helperDeprecator(function(object, property) {
         return getPropertyType(object, property) === 'function';
      }, getHelpersDeprecatorWrapper('hasFunctionProperty', 'Core/helpers/Object/getPropertyType')),

      compareValues: helperDeprecator(deprecatedHelpers.compareValues, getHelpersDeprecatorWrapper('compareValues')),

      checkAssertion: cDebug.checkAssertion
   };
});