define('Core/helpers/getModuleNameWithPlugin', [
   'Core/constants'
], function(
   constants
) {
   'use strict';

   /**
    * Возвращает имя модуля с указанием плагина 'js!', если он требуется
    *
    * @class Core/helpers/getModuleNameWithPlugin
    * @param {String} name Имя модуля
    * @author Мальцев А.А.
    */
   return function getModuleNameWithPlugin(name) {
      name = String(name);

      if (name.startsWith('js!')) {
         return name;
      }

      var baseName = name.split('/')[0];
      if (
         (constants.jsModules && baseName in constants.jsModules) ||
         (constants.jsCoreModules && baseName in constants.jsCoreModules)
      ) {
         return 'js!' + name;
      }

      return name;
   };
});
