define('Core/polyfill', (function() {
   var isServerSide = typeof window === 'undefined',
      isClientSide = !isServerSide,
      polyfills = [];

   if (isServerSide || !Function.prototype.bind) {
      polyfills.push('Core/polyfill/Function/bind');
   }
   if (isServerSide || !Object.getPrototypeOf) {
      polyfills.push('Core/polyfill/Object/getPrototypeOf');
   }
   if (isServerSide || !Object.keys) {
      polyfills.push('Core/polyfill/Object/keys');
   }
   if (isServerSide || !Object.create) {
      polyfills.push('Core/polyfill/Object/create');
   }
   if (isServerSide || !Object.assign) {
      polyfills.push('Core/polyfill/Object/assign');
   }
   if (isServerSide || !Array.isArray) {
      polyfills.push('Core/polyfill/Array/isArray');
   }
   if (isClientSide && !Array.prototype.find) {
      polyfills.push('Core/polyfill/Array/find');
   }
   if (isServerSide || !String.fromCodePoint) {
      polyfills.push('Core/polyfill/String/fromCodePoint');
   }
   if (isServerSide || !String.prototype.startsWith) {
      polyfills.push('Core/polyfill/String/startsWith');
   }
   if (isServerSide || !String.prototype.trim) {
      polyfills.push('Core/polyfill/String/trim');
   }
   if (isClientSide && !Element.prototype.matches) {
      polyfills.push('Core/polyfill/Element/matches');
   }
   if (isClientSide && !Element.prototype.closest) {
      polyfills.push('Core/polyfill/Element/closest');
   }
   return polyfills;
})(), function(){});