define('Core/vdom/Utils/FocusHelper', [
   'View/Runner/expressions/attr'
], function(attr) {

   function closest(target, root) {
      while (target) {
         if (target === root) return true;
         target = target.parentElement;
      }
      return false;
   }
   function prepareAttrsForFocus(attributes, opts) {
      if (!attributes){
         return;
      }
      var prefix = '';
      if (attr.checkAttr(attributes) || attr.checkAttr(opts)){
         prefix = 'attr:';
      }

      attributes[prefix+'ws-creates-context'] = 'true';
      attributes[prefix+'ws-delegates-tabfocus'] = 'true';
      if (opts[prefix+'ws-tab-cycling'] === 'true') {
         attributes[prefix+'ws-tab-cycling'] = 'true';
      }
      if (opts[prefix+'ws-autofocus'] === 'true') {
         attributes[prefix+'ws-autofocus'] = 'true';
      }
      if (opts[prefix+'ws-no-focus'] === 'true') {
         attributes[prefix+'ws-no-focus'] = 'true';
      }

      if (opts.hasOwnProperty(prefix+'tabindex')) {
         attributes[prefix+'tabindex'] = opts[prefix+'tabindex'] + '';
      }
   }

   // поправляет табиндекс для атрибутов, предназначенных для элемента, образующего контекст табиндексов
   // табиндекс должен быть по умолчанию 0, табиндекса не может не быть вообще
   function prepareTabindex(attrs) {
      if (attrs['ws-creates-context'] === 'true') {
         if (attrs.tabindex === '' || attrs.tabindex === undefined) {
            attrs.tabindex = '0';
         }
      }
   }

   /**
    * Функция нужна для патчинга корневых элементов при маутинге
    * Вызывается только из createControl!
    * @param dom
    * @param cfg
    */
   function patchDom(dom, cfg){
      dom = dom[0]?dom[0]:dom;
      prepareAttrsForFocus(dom.attributes, cfg);
   }
   return {
      closest: closest,
      prepareAttrsForFocus: prepareAttrsForFocus,
      prepareTabindex: prepareTabindex,
      patchDom: patchDom
   };
});