define('Deprecated/ClassMapper', [
], function() {
   var _mapping = {};
   return {
      setClassMapping: function(classSpec, mapTo) {
         if (typeof classSpec === 'string') {
            _mapping[classSpec] = mapTo;
         } else if (classSpec && typeof classSpec === 'object') {
            for (var spec in classSpec) {
               if (classSpec.hasOwnProperty(spec)) {
                  _mapping[spec] = classSpec[spec];
               }
            }
         }
      },
      getClassMapping: function(classSpec) {
         return _mapping[classSpec] || classSpec;
      },
      resetClassMapping: function(classSpec) {
         delete _mapping[classSpec];
      },
      restoreDefaultClassMapping: function() {
         _mapping = {};
      }
   };
});
