/**
 * Модуль "Компонент Информационное собщение".
 *
 * @description
 */
define("Deprecated/Controls/DialogAlert/DialogAlert", ["Deprecated/Controls/SimpleDialogAbstract/SimpleDialogAbstract"], function( SimpleDialogAbstract) {

   "use strict";

   /**
    * Информационное сообщение
    *
    * @class Deprecated/Controls/DialogAlert/DialogAlert
    * @extends Deprecated/Controls/SimpleDialogAbstract/SimpleDialogAbstract
    * @author Крайнов Д.О.
    * @public
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.InformationPopup}.
    */
   var DialogAlert = SimpleDialogAbstract.extend(/** @lends Deprecated/Controls/DialogAlert/DialogAlert.prototype */{
      $protected : {
         _options : {
            /**
             * @cfg {String} Тип окна сообщения
             * Окна разных типов отличаются внешним видом.
             * Возможные варианты окон:
             * <ol>
             *    <li>'info' - информационное, предназначено для вывода сообщения пользователю;</li>
             *    <li>'alert' - предупреждающее,</li>
             *    <li>'error' - предназначено для отображения сообщения о возникшей ошибке.</li>
             * </ol>
             */
            type : "info",
             /**
              * @typedef {String} RenderStyle
              * @variant asLink В виде ссылки.
              * @variant classic Обычная кнопка.
              */
             /**
              * @typedef {Array} DialogAlertButtons
              * @property {Number} tabindex Табиндекс кнопки.
              * @property {String} height Высота кнопки.
              * @property {String} width Ширина кнопки.
              * @property {String} name Имя кнопки.
              * @property {RenderStyle} renderStyle Отображение кнопки.
              * @property {Boolean} isDefault Является ли кнопкой по умолчанию.
              * @property {String} caption Текст на кнопке.
              * @property {Function} handlers Обработчик клика по кнопке.
              */
             /**
              * @cfg {DialogAlertButtons[]} Массив кнопок с настройками
              * @example
              * <pre>
              *     <options name="buttons" type="array">
              *        <options>
              *           <option name="tabindex">1</option>
              *           <option name="height">24</option>
              *           <option name="width">100</option>
              *           <option name="name">Удалить</option>
              *           <option name="renderStyle">classic</option>
              *           <option name="isDefault">true</option>
              *           <option name="caption">Удалить</option>
              *           <option name="handlers" type="function">js!SBIS3.Demo.MyDialog:prototype.myOnActivatedHandler2</option>
              *        </options>
              *        <options>
              *           <option name="tabindex">2</option>
              *           <option name="height">24</option>
              *           <option name="width">100</option>
              *           <option name="name">Отмена</option>
              *           <option name="renderStyle">classic</option>
              *           <option name="isDefault">false</option>
              *           <option name="caption">Отмена</option>
              *           <option name="handlers" type="function">js!SBIS3.Demo.MyDialog:prototype.myOnActivatedHandler1</option>
              *        </options>
              *     </options>
              * </pre>
              */
            buttons : [
               {
                  tabindex : 1,
                  width : "100%",
                  height : "100%",
                  name : "simpleDialogOk",
                  renderStyle: "classic",
                  isDefault : true,
                  caption : "OK",
                  handlers: {
                     onActivated  : function(){
                        this.getParent().close();
                     }
                  }
               }
            ]
         }
      },
      $constructor : function(){
         this._window.addClass("ws-smp-dlg-" + (this._options.type || "info"));
      }
   });

   return DialogAlert;

});