Нужна для осуществления выбора записи/записей из диалога выбора.

Диалог строится на основе любого из компонентов из пространства имен {@link https://wi.sbis.ru/docs/3-8-0/$ws/proto/ SBIS3.CORE} или их наследников, которые можно использовать для отображения данных в списках.
Такими компонентами могут быть, например, {@link SBIS3.CORE.TableView}, {@link SBIS3.CORE.TreeView} или {@link SBIS3.CORE.HierarchyView}.
Как правило, на диалоге размещают только один контрол для отображения списка значений. Если их больше, то выбор производится только из того, который первым объявлен в вёрстке диалога.

Основное назначение всплывающей панели заключается в отображении диалога выбора значений для поля связи {@link SBIS3.CORE.FieldLink}. Диалог открывается при клике на кнопку:    
![](/FloatAreaSelector-01.png)    
По нажатию Enter или Ctrl + Enter отмеченные записи (или в случае их отсутствия - текущая запись) передаются в поле связи.

Для работы в режиме множественного выбора необходимо установить опцию {@link multiSelect} в значение true. Значения для выбора выделяются флагами:    
![](/FloatAreaSelector-02.png)    
В режиме единичного выбора выбирается только одно значение. Выбор происходит при клике на требуемое значение в списке.

Создание и настройка диалога выбора значений рассмотрены в Примере 1 данного описания.

Всплывающая панель может быть использована для организации диалога выбора значений и для других контролов. В этом случае существует одна особенность: подтверждение выбранных значений производится по кнопке,
которую прикладной разработчик должен дополнительно разместить на всплывающей панели. Использование кнопки рассмотрено в Примере 2 данного описания.


Пример 1. Создание и настройка диалога выбора значений для контрола {@link SBIS3.CORE.FieldLink}.

1. Создадим два компонента:
   * для поля связи - компонент SBIS3.Demo.FieldLink; в нем создадим поле связи, для которого используем контрол {@link SBIS3.CORE.FieldLink};
   * для организации диалога выбора - компонент SBIS3.Demo.TableView; в нем создадим табличное представление данных, для которого используем контрол {@link SBIS3.CORE.TableView}.

2. В XHTML-файле компонента SBIS3.Demo.FieldLink опишем созданное поле связи, в которое будут выбираться значения из табличного представления данных:

   <pre class="brush:xml">
      <component data-component="SBIS3.CORE.FieldLink" name="MyFieldLink" style="width:500px;">
         <options name="dictionaries" type="array"> <!-- Описываем справочник, который будет использован для выбора значений в поле связи; всплывающая панель FloatAreaSelector используется полем связи для открытия справочника -->
            <options>
               <option name="formatMethod">Пользователь.Список</option>
               <option name="keyField">@Пользователь</option>
               <option name="name">Справочник</option>
               <option name="objectName">Пользователь</option>
               <option name="selectionType">all</option>
               <option name="template">js!SBIS3.Demo.TableView</option> <!-- Указываем имя шаблона диалога выбора, в качестве которого будет выступать созданный компонент SBIS3.Demo.TableView -->  
               <option name="editMode">newDialog</option>
            </options>
         </options>
         <option name="title">Фамилия</option> <!-- Определим текст кнопки - ссылки поля связи, по клику на которую будет показан справочник -->
         <option name="multiSelect">true</option> <!-- Устанавливаем режим множественного выбора в поле связи -->
         <option name="linkedDisplayField">Фамилия</option> <!-- Определяем отображаемое поле выбранной записи; его значение будет отображено в поле связи -->  
      </component>
   </pre> 
   
3. В XHTML-файле компонента SBIS3.Demo.TableView опишем созданное табличное представление данных:

   <pre class="brush:xml">
      <component data-component="SBIS3.CORE.TableView" name="ТаблицаЗначений" style="width:300px;">
         <options name="display">
            <options name="columns" type="array"> <!-- Описываем колонки, которые будут отображены в табличном представлении данных -->
               <options>
                  <option name="field">Фамилия</option>
                  <option name="title">Фамилия</option>
               </options>
               ...
            </options>
            <option name="useDrawingLines">true</option> <!-- Задаем отображение линий в табличном представлении -->
            <option name="emptyHtml">Нет данных для выбора</option> <!-- Устанавливаем текст, который будет отображен при отсутствии записей -->
            <option name="constantRecordsPerPage">true</option> <!-- Устанавливаем, что количество записей, запрашиваемых с БЛ, будет браться из опции recordsPerPage -->
			<option name="recordsPerPage">8</option> <!-- Определяем количество записей при построении представления данных -->
            <option name="usePaging">parts</option> <!-- Настраиваем режим постраничной навигации -->
         </options>
         <options name="dataSource"> <!-- Настраиваем источник данных, из которого будут выбираться записи для табличного представления -->
            <options name="readerParams">
               <option name="nameApplication">ControlDemo</option>
               <option name="nameService">ControlDemo</option>
               <option name="linkedObject">Пользователь</option>
               <option name="createMethodName">Создать</option>
               <option name="updateMethodName">Записать</option>
               <option name="readMethodName">Прочитать</option>
               <option name="destroyMethodName">Удалить</option>
               <option name="queryName">Список</option>
               <option name="format">Пользователь.Список</option>
            </options>
         </options>
      </component>
   </pre>   

   
Создание поля связи и диалога выбора значений для него завершено.

   
Пример 2. Организация диалога выбора значений для контрола {@link SBIS3.CORE.FieldString}.

1. Создадим новый компонент SBIS3.Demo.FieldString. В компонент добавим строку ввода, в которую будем выбирать данные из табличного представления. Для создания строки ввода будет использован контрол {@link SBIS3.CORE.FieldString}.
   В XHTML-файле компонента опишем созданную строку ввода:
   
   <pre class="brush:xml">
      <component data-component="SBIS3.CORE.FieldString" style="width:300px;height:20px;" name="ПолеВвода"> 
         <option name="tooltip">ФИО исполнителя или название рабочей зоны</option> <!-- Определим текст всплывающей подсказки -->
         <option name="tooltipInside">true</option> <!-- Установим отображение текста всплывающей подсказки внутри поля -->
      </component>
   </pre>

2. Для отображения списка значений для выбора используем созданное в Примере 1 табличное представление данных. Для подтверждения выбранных значений в компонент SBIS3.Demo.TableView добавим кнопку {@link SBIS3.CORE.Button}.
   Созданный диалог выбора значений будет описан примерно следующим образом:
   
   <pre class="brush:xml">
      <component data-component="SBIS3.CORE.Button" style="width:100px;" name="MyButton" class="demo-TableView__MyButton"> <!-- Кнопка для подтверждения выбранных значений -->
         <option name="caption">Выбрать</option>
      </component>
      <component data-component="SBIS3.CORE.TableView" name="ТаблицаЗначений" style="width:300px;"> <!-- Табличное представление для выбора значений -->
         ...
      </component>
   </pre> 
   
3. В JS-модуле компонента SBIS3.Demo.TableView для добавленной кнопки опишем необходимые действия, которые будут произведены по клику.   
   Подтверждение выбранных значений, закрытие всплывающей панели и передача значений в контрол производят с помощью команды close:   

   <pre>
      init: function() {
         moduleClass.superclass.init.call(this);
         var self = this,
            MyTableView = this.getChildControlByName('ТаблицаЗначений');  // Получаем экземпляр класса MyTableView
         
         this.getChildControlByName('MyButton').subscribe('onActivated', function() {
            self.sendCommand('close', MyTableView.getSelection());   // Закрытие всплывающей панели и отправка выбранных значений по событию 'onActivated'
         });
      }
   </pre> 
   

4. По клику на кнопку на всплывающей панели выбранные записи будут переданы в событие onAfterClose. В обработчике на событие мы можем производить их обработку и установке значений внутри контрола FieldString.
   В JS-модуле компонента SBIS3.Demo.FieldString опишем работу диалога выбора значений с созданной строкой ввода: 
   
   <pre>       
      init: function() {
         moduleClass.superclass.init.call(this);
         var self = this,
            myString = this.getChildControlByName('ПолеВвода');  // Создаем экземпляр класса поля выбора  
                                                             			
         myString.subscribe('onClick', function() { // Открываем диалог выбора значений по событию 'onClick' - при клике на контрол 
            new $ws.proto.FloatAreaSelector({
               name: 'MyFloatArea',
               template: 'js!SBIS3.Demo.TableView',   // В качестве шаблона для отображения списка значений для выбора используем созданный компонент SBIS3.Demo.TableView
               autoHide: true,  // Всплывающая панель диалога может автоматически скрываться
               target: this.getContainer(),   // Контрол будет прижиматься к углам текущего контейнера
               direction: 'bottom',           // Всплывающая панель будет выезжать вниз
               multiSelect: true,             // Устанавливаем режим множественного выбора
               handlers: {
                  onAfterClose: function(eventObject, records) {    // Описываем обработчик на событие 'onAfterClose' - после того, как панель закроется
                     if (records !== undefined) {
                        myString  // Здесь разработчиком прикладных решений будет описана передача выбранных значений в поле FieldString
                     }
                  }
               }
            }),
         });
      }
   </pre>

Организация диалога выбора значений для поля ввода завершена.   
	   
	   
	   

