define('Deprecated/Controls/FieldDate/FieldDate',
      [
   'Core/helpers/Hcontrol/isElementVisible',
   "Core/helpers/date-helpers",
   "Core/constants",
   "Deprecated/Controls/FieldFormatAbstract/FieldFormatAbstract",
   "Deprecated/Controls/FieldAbstract/FieldAbstract",
   "Core/compatibility",
   "Core/detection",
   "is!browser?cdn!jquery-ui/1.8.9/jquery-ui-1.8.5.2.custom.min.js",
   "is!browser?cdn!css!jquery-ui/1.8.9/jquery-ui-1.8.5.custom.css",
   "browser!Deprecated/Controls/FieldDate/resources/ext/jquery.ui.datepicker-local",
   "i18n!Deprecated/Controls/FieldDate/FieldDate"
],
      function(isElementVisible, dateHelpers, cConstants, FieldFormatAbstract, FieldAbstract ) {
   'use strict';

   // Есть копипаста в FieldMonth
   var
      datePart = '[0-9]{4}-[0-9]{2}-[0-9]{2}',
      timePart = '[0-9]{2}:[0-9]{2}:[0-9]{2}(\\.[0-9]{1,9})?([+-][0-9]{2}([:-][0-9]{2})?)?',
      summary = '^' + datePart + '$|^(' + datePart + ' )?' + timePart + '$',
      sqlDateRegExp = new RegExp(summary),
      types = {
         y : 'FullYear',
         m : 'Month',
         d : 'Date',
         h : 'Hours',
         i : 'Minutes',
         s : 'Seconds',
         u : 'Milliseconds'
      };
         
   /**
    * Поле ввода дата/время.
    * Реализует нестандартное поведение при редактировании.
    * При получении фокуса значение поля не выделяется, чтобы невозможно было стереть значение.
    * Следующее умное поведение регулируется опцией {@link autoComplete}:
    * - если часть даты пользователь не указал, то проставляется текущее значение;
    * - если часть времени не указана, то проставляются нули;
    * - если указали только одну цифру, то считается, что перед этой цифрой ноль.
    * @class Deprecated/Controls/FieldDate/FieldDate
    * @extends Deprecated/Controls/FieldFormatAbstract/FieldFormatAbstract
    * @control
    * @public
    * @author Крайнов Д.О.
    * @category Date/Time
    * @designTime actions Deprecated/Controls/FieldString/design/design
    * @designTime plugin Deprecated/Controls/FieldDate/design/DesignPlugin
    * @ignoreOptions trim
    * @ignoreOptions tooltipInside
    * @ignoreOptions maxLength
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.DatePicker}.
    */
   var FieldDate = FieldFormatAbstract.extend(/** @lends Deprecated/Controls/FieldDate/FieldDate.prototype */{
      $protected: {
         _options: {
             /**
              * @cfg {String} Маска отображения данных
              *
              * Формат отображения данных в поле контрола "Строка ввода".
              *
              * Условные обозначения:
              *     1. D(day) -  календарный день.
              *     2. M(month) - месяц.
              *     3. Y(year) - год.
              *     4. H(hour) - час.
              *     5. I - минута.
              *     6. S(second) - секунда.
              *     7. U - доля секунды.
              * Опция чувствительна к регистру, для задания значения необходимо использовать только заглавные буквы.
              *
              * Количество символом в маске влияет на количество отображаемых символов.
              * Например, YY будет отображать 2 цифры года, а YYYY - 4 цифры.
              *
              * В качестве разделителей можно использовать следующие символы: ".", ":", "-", "/", "\", "|".
              *
              * I. Маски для отображения даты:
              *     1. DD.MM.YYYY
              *     2. DD.MM
              *     3. DD.MM.YY
              *     4. YY-MM-DD
              *     5. YYYY-MM-DD
              *
              * II. Маски для отображения времени:
              *     1. HH:II
              *     2. HH:II:SS
              *     3. HH:II:SS.UUU
              *
              * III. Маски для комбинированного отображения даты и времени:
              *     1. HH:II:SS.UUU
              *     2. DD.MM.YY HH:II:SS.UUU
              *     ...
              *     Совмещяя маски для отображения даты и времени, можно получить множество комбинаций.
              *
              * IV. Отдельно месяц и год можно отобразить следующими масками:
              *     1. MM/YYYY
              *     2. YYYY
              *
              * @example
              * <pre>
              *     mask:'DD.MM.YY HH:II:SS'
              * </pre>
              * При этой маске контрол отобразит подобное значение: "19.09.13 12:37:51".
              * @see getType
              * @see calendar
              * @see strToDate
              */
            mask: 'DD.MM.YY',
             /**
              * @cfg {Boolean} Проверять корректность даты
              *
              * По умолчанию для введённого значения даты проверяется её корректность, в т.ч. формат, существование.
              * Это свойство позволяет отключить эту проверку.
              *
              * Отключение свойства может иметь смысл для каких-либо нетривиальных случаев обработки даты, где
              * встроенный валидатор и отображаемая им ошибка могут мешать.
              * @example
              * <pre>
              *    performFormatValidation: false,
              *    validators: [
              *       {
              *          validator: myCustomDateValidator,
              *          errorMessage: 'Проверьте актуальность значения!',
              *          noFailOnError: true
              *       }
              *    ]
              * </pre>
              */
            performFormatValidation: true,
             /**
              * @cfg {Boolean} Отображать ли значок календаря
              * Это свойство определяет отображение значка календаря справа от контрола.
              *
              * Если поставить значение calendar: false, то значок календаря выводиться не будет,
              * и ввести дату можно будет только с клавиатуры.
              * @example
              * <pre>
              *    calendar: true
              * </pre>
              * @see calendarYearRange
              * @see arrows
              * @see mask
              */
            calendar: true,
            /**
             * @cfg {Object} Диапозон выбора года в календаре
             * Это свойство определяет диапозон выбора года в календаре. Работает при включенной опции calendar
             *
             * @example
             * <pre>
             *    <options name="calendarYearRange">
             *       <option name="minYear">1930</option>
             *       <option name="maxYear">2050</option>
             *    </options>
             * </pre>
             * @see calendar
             * @see arrows
             * @see mask
             */
            calendarYearRange: {
               minYear: 1950,
               maxYear: 2049
            },
            /**
             * @cfg {Boolean} Отображать ли стрелки переключения дней
             * При их использовании текущее значение меняется на +/- 1 один.
             *
             * @example
             * <pre>
             *    arrows: true
             * </pre>
             * @see calendar
             * @see isArrows
             * @see setArrows
             */
            arrows: false,
            /**
             * @cfg {Boolean} Умное автодополнение
             *
             * Происходит в двух случаях:
             * <ol>
             *    <li>При потере фокуса.</li>
             *    <li>При вводе значения целиком, которое не является верным, напр. 38.05.14.</li>
             * </ol>
             * Описание поведения см. в описании класса.
             * @see setAutoComplete
             * @see isAutoComplete
             */
            autoComplete: true,
            /**
             * @cfg {DateTime} Значение
             *
             * @see setStartDate
             * @see clearStartDate
             */
            value: null,
            /**
             * @cfg {Number|Function} Разделитель столетия
             *
             * Если используется формат даты с двумя числами в году, то этот параметр позволяет задать границу разделения столетий. 
             * Например, при значении 50 года будут определяться как 1950...2049.
             * При задании функции она будет вызвана при попытке определенияи года по двузначному значению.
             */
            centuryDivision: 50,
            className: 'ws-field-date',
            cssClass: 'ws-field-date'
         },
         _losingActive: null,
         _containerClickHandher: null,
         _year : 0,
         _parentMenuId: undefined,
         _startDate: undefined,
         _previousValue: ''
      },
      $constructor: function(){
         var
            self = this,
            // проверка на содержание цифр
            numRegExp,
            value;
         //минимально возможное значение года. Используются при валидации и при показе календаря
         this._options.minValidYear = 1400;
         this._keysWeHandle[cConstants.key.y] = '0';
         this._keysWeHandle[cConstants.key.androidAnyKey] = '1';
         this._getExtendedTooltipTarget().before('<input class="input-helper" type="hidden"/>');
         this._initCalendar();
         this._initArrows();
         this._inputControl.keydown(function(event){
            var
               cursor;
            if (event.which == cConstants.key.insert && !event.ctrlKey){
               event.preventDefault();
               event.stopPropagation();
               self._modifyDate();
               return false;
            }
            if (event.which == cConstants.key.plus || event.which == cConstants.key.minus){
               self._modifyDate(event.which);
               return false;
            }
            if (event.which == cConstants.key.f7){
               event.preventDefault();
               self._toggleCalendar();
            }
            if (event.which == cConstants.key.esc){
               if (/block/.test($('#ui-datepicker-div').css('display'))){
                  self._container.find('.input-helper').datepicker('hide');
                  event.stopPropagation();
               }
            }
            if (event.which === cConstants.key.androidAnyKey && cConstants.browser.isMobileAndroid) {
               cursor = self._getCursor();
               self._inputControl.html(self._previousValue);
               self._moveCursor(cursor[0], cursor[1]+1);
            }
         });
         // бинд для удаления выделенного значения по нажатию на delete или backspace
         this._container.bind('keyup', function(event) {
            // <магия>регэксп надо задавать при каждой проверке, иначе он возравщает различный результат</магия>
            numRegExp = new RegExp('[0-9]', 'g');
            if ((event.keyCode === 46 || event.keyCode === 8 || (event.keyCode === cConstants.key.androidAnyKey && cConstants.browser.isMobileAndroid)) && !numRegExp.test(self._getString())) {
               value = self._inputControl.val();
               if (value === '') {
                  value = null;
               }
               self._updateSelfContextValue(value);
               self._notifyOnValueChange(self.getValue());
            }
         });
         this._options.validators.splice(0, 0, {validator : this._textValidate});
      },

      _initFocusCatch: function() {
         this._container.bind('focusin', function(event){
            event.stopPropagation();
         });
      },

      /**
       * Добавляет стрелки около поля ввода, если они нужны. Подсписывается на события
       * @private
       */
      _initArrows: function() {
         if (this.isArrows()) {
            this._container.prepend('<div class="ws-date-button ws-date-button-right ws-date-button-enabled ws-field-date-arrow"></div>');
            this._container.prepend('<div class="ws-date-button ws-date-button-left ws-date-button-enabled ws-field-date-arrow"></div>');
            this._container.children('.ws-field-date-arrow').bind('click', this._arrowClick.bind(this));
            this._updateArrowsState(this.getValue());
         }
      },

      /**
       * Проверка значений из опции calendarYearRange с введённым годом
       * @private
       */
      _checkCalendarYearRange: function(year) {
         var calendarYearRange = this._options.calendarYearRange,
             minYear = parseInt(calendarYearRange.minYear, 10),
             maxYear = calendarYearRange.maxYear ? parseInt(calendarYearRange.maxYear, 10) : null,
             nowYear = new Date().getFullYear();
         if (!maxYear) { // если в настройках указана только начальная дата
            year = minYear > nowYear ? minYear :
                year < minYear ? minYear :
                    year > nowYear ? nowYear : year;

         }
         else if (!minYear) { // если в настройках указана только конечная дата
            year = maxYear < nowYear ? maxYear :
                year > maxYear ? maxYear :
                    year < nowYear ? nowYear : year;
         }
         else if (maxYear > minYear) { // если указаны две даты
            if (year < minYear) {
               year = minYear;
            }
            else if (year > maxYear) {
               year = maxYear;
            }
         }
         return year;
      },

      /**
       * Создаем иконку с календарем
       * @private
       */
      _initCalendar: function() {
         if (this.isCalendar() && this._clearMask.search(/[DMY]/) !== -1 && this.getType() !== 'time') {
            var
               self = this,
               inputHelper = self._container.find('.input-helper').datepicker({
                  onSelect: function(dateText){
                     // здесь лежит год в формате yyyy
                     // у datepicker есть баг, если мы ввели в FieldDate год меньший минимального значения, то в select подставляется значение минимального из диапозона,
                     // но в arguments[1] всё равно приходит наша дата введёная вручную
                     // поэтому выбранную дату возьмём из селектора
                     self._year = $('#ui-datepicker-div').find('.ui-datepicker-year').val();
                     self.setValue(self.strToDate(dateText, self._year));
                     self.setActive(true);
                     self._notify('onChange', self._notFormatedVal());
                  },
                  beforeShow: function(input){
                     var curStringVal = self._curValue(true),
                         curDate = self.strToDate(curStringVal),
                         resDate = curDate ? curDate : new Date(),
                         year = resDate.getFullYear(),
                         calendarYearRange = self._options.calendarYearRange,
                         minValidYear = self._options.minValidYear,
                         minYear, maxYear;
                     //проставляем опцию yearRange для datepicker
                     //если год в диапозоне значений из опции calendarYearRange, то устанавливаем эти значения
                     //иначе расширяем в сторону текущего значения, но не меньше minValidYear.
                     minYear = year < minValidYear ? minValidYear :
                         year > calendarYearRange.minYear ? calendarYearRange.minYear : year;
                     maxYear = year > calendarYearRange.maxYear ? year : calendarYearRange.maxYear;
                     $(input).datepicker("option", "yearRange", minYear.toString() + ":" + maxYear.toString());
                     $(input).datepicker('setDate', resDate);
                     if (self._startDate) {
                        inputHelper.datepicker('setDate', self._startDate);
                     }
                     self._container.trigger('wsSubWindowOpen');
                  },
                  onClose: function() {
                     self._container.trigger('wsSubWindowClose');
                     if(self._watchTimer) {
                        clearInterval(self._watchTimer);
                        self._watchTimer = null;
                     }
                  },
                  dateFormat: self._getMask(self._options.mask, 'datepicker'),
                  changeYear: true,
                  shortYearCutoff: self._options.centuryDivision,
                  yearRange: self._options.calendarYearRange.minYear.toString() + ":" + self._options.calendarYearRange.maxYear.toString(),
                  duration: 0
               });
            self._getCalendarContainer()
               .mousedown(function(event){
                  /**
                   * jQuery UI tracks a mousedown on a document to hide a calendar on clicking somewhere
                   * Thus we are tracking an icon click by ourselves, prevent this event from bubbling up
                   */
                  event.stopImmediatePropagation();
               })
               .click(function(){
                  //по пожеланию Новикова Д. показываем календарь даже у задизабленного поля ввода даты
                  // желание отменено по заданию:
                  /*Ошибка в разработку от 08.10.2015 №1075675
                   WS 3.7.3.10 Интеграционные тесты - неправильное поведение поля 'Даты'

                   в консоли ошибок нет

                   ка...
                   https://inside.tensor.ru/opendoc.html?guid=0e9460cd-4368-4bdf-a5cf-a6e612194a88
                   */
                  if (self.isEnabled() && !self.isReadOnly()) {
                     self.setActive(true);
                     self._toggleCalendar();
                  }
               });
            if (self._parent) {
               self._parent.getContainer().bind('container-clicked', function(){
                  self._container.find('.input-helper').datepicker('hide');
               });
            }
            if (!$.datepicker.propagationStopped) {
               $.datepicker.propagationStopped = true;
               $.datepicker.dpDiv.bind('click', function(e) {
                  if (cConstants.browser.isIE11) {
                     new Function(e.target.parentElement.getAttribute('onclick')).bind(e.target.parentElement)();
                  }
                  e.stopPropagation();
               });
            }
         } else {
            this._options.calendar = false;
            this._getCalendarContainer().remove();
         }
      },

      /**
       * Проверка на короткую маску года (YY)
       * @private
       */
      _checkShortYearMask: function() {
         var mask = this._options.mask,
             yearMask = mask.match(/[yY]+/);
         return yearMask ? yearMask[0].length == 2 : false;
      },

      /**
       * Обработчик клика по стрелке
       * @param {Object} event jQuery-событие
       * @private
       */
      _arrowClick: function(event) {
         var $arrow = $(event.target),
            date;
         if (this.isEnabled() && this.getValue()) {
            date = new Date(this.getValue());
            date.setDate(date.getDate() + ($arrow.hasClass('ws-date-button-right') ? 1 : -1));
            this.setValue(date);
            this._notify('onChange', new Date(date));
         }
      },
      /**
       * Обновляет состояние "включённости" стрелок
       * @param {Date|null} value Текущее значение контрола
       * @private
       */
      _updateArrowsState: function(value) {
         var enable = this.isEnabled() && !!value;
         if (this.isArrows()) {
            this._container.children('.ws-field-date-arrow')
               .toggleClass('ws-date-button-disabled', !enable)
               .toggleClass('ws-date-button-enabled', enable);
         }
      },
      /**
       * @return {Boolean}
       * @protected
       */
      _canValidate: function() {
         return true;
      },
      _invokeValidation: function(){
         var
            parentResult = FieldDate.superclass._invokeValidation.apply(this, arguments),
            v = this.getValue();

         if (v && typeof v === 'string') {
            v = this.strToDate(v);
         }
         if (v && v.getFullYear) {
            // валидируем по диапозону от minValidYear - до бесконечности
            var minYear = this._options.minValidYear;
            if (v.getFullYear() < minYear) {
               parentResult.result = false;
               parentResult.errors.push(rk('Год не может быть меньше') + ' ' + minYear.toString());
            }
         }
         return parentResult;
      },
      /**
       * Установка режима редактирования по месту в поле ввода.
       * @param {Boolean} [s=true] Флаг редактирования по месту.
       * Значения:
       * true|undefined - режим редактирования по месту.
       * false - обычный режим полей ввода
       */
      setEditAtPlace: function (s) {
         FieldDate.superclass.setEditAtPlace.apply(this, arguments);
         this._container
            //.toggleClass('ws-FieldEditAtPlace__underline', !!s)
            .find('.calendar-container')
               .toggleClass('ws-hidden', !!s);
         if (!s && cConstants.browser.isMacOSDesktop || cConstants.browser.isMobileIOS) {
            this._container.parent().hide().show(0);
         }
      },
      /**
       * Обновление значения в текстовом поле при его изменении извне
       * @protected
       */
      _updateInPlaceValue: function() {
         var text = $(this.getContainer()).find('.input-field').text();
         FieldDate.superclass._updateInPlaceValue.call(this, text);
      },
      /**
       * Изменить первоначальное выделение текста
       * Убирает первоначальное выделение текста у FieldDate.
       * @param range
       * @private
       */
      _modifyRange: function(range) {
         range.collapse(true);
      },
      /**
       *
       * Установить строку подсказки для контрола
       * @param {String} tooltip Текст всплывающей подсказки.
       * @example
       * <pre>
       *     control.setTooltip("Текст всплывающей подсказки");
       * </pre>
       */
      setTooltip: function(tooltip) {
         this._getCalendarContainer().attr('title', tooltip);
      },
      _getExtendedTooltipTarget: function() {
         return this._container.find('.ws-field');
      },
      destroy: function() {
         this._toggleCalendar(false);
         if(this._parent && this._containerClickHandher) {
            this._parent.getContainer().unbind('container-clicked', this._containerClickHandher);
         }
         if (this.isArrows()) {
            this._container.children('.ws-field-date-arrow').unbind('click');
         }
         $.datepicker.dpDiv.unbind('click');
         this._container.unbind('keyup');
         FieldDate.superclass.destroy.apply(this, arguments);
      },
      _prepareRegExp: function(){
         this._sepExp = /[^YMDHISU]+/g;
         this._notsepExp = /[YMDHISU]+/g;
      },
      _isCalendarOpen: function() {
         var
            dp = $('#ui-datepicker-div');
         return dp.css('display') == 'block' && dp.attr('for') == this.getName();
      },
      /**
       * Отобразить/скрыть дейтпикер
       * @param {Boolean} [state]
       * @private
       */
      _toggleCalendar: function(state) {
         if(!this.isCalendar()){
            return;
         }
         var
            dp = $('#ui-datepicker-div');
         if(state === undefined) {
            state = !this._isCalendarOpen();
         }
         var inputHelper = this._container.find('.input-helper');
         if (state) {
            inputHelper
               .datepicker('enable')
               .datepicker('show');
            var dpYear = dp.find('.ui-datepicker-year');
            if (this._options.enabled) {
               dpYear.removeAttr('disabled');
            } else {
               dpYear.attr('disabled', 'disabled');
               inputHelper.datepicker('disable');
            }

            /*
            * datepicker является singlton, и если присваивать значение wsControl при иницализации, последующие инициализации datepicker
            * перебьют это значение, поэтому проставляем wsControl каждый раз при открытии.
            * */
            inputHelper.datepicker('widget').get(0).wsControl = this;
         } else {
            inputHelper.datepicker('hide');
         }
         if (state) {
            if(this._parentMenuId === undefined) {
               this._parentMenuId = this._getParentMenuId();
            }
            dp.toggleClass('ws-has-parent-menu', !!this._parentMenuId);
            dp.attr('for-menu', this._parentMenuId);
            dp.attr('for',this.getName());
            dp.position({my: 'left top', at:'left bottom', of:this._getExtendedTooltipTarget()});
            if(!this._watchTimer) {
               this._watchTimer = setInterval(this._watchTargetPresent.bind(this), 100);
            }
         }
      },
      /**
       * Проверить видимость поля
       * Скрывает дейтпикер если поле невидимо. 
       * Вызывается по таймеру.
       * @private
       */
      _watchTargetPresent: function() {
         if(!isElementVisible(this._inputControl)){
            this._toggleCalendar(false);
         }
      },
      /**
       * возвращает jQuery объект с иконкой календаря
       * @returns {jQuery}
       * @private
       */
      _getCalendarContainer: function() {
         return this._container.find('.calendar-container');
      },
      _keyboardHover : function(event){
         if(event.which === cConstants.key.y && event.ctrlKey) {
            this._setValueInternal(null);
            this._moveCursor(0,0);
            this._onValueChangeHandler();
            return false;
         } else  if (event.which == cConstants.key.androidAnyKey && cConstants.browser.isMobileAndroid){
            event.preventDefault();
            event.stopPropagation();
            this._keyFunc(8, 'backspace', event.ctrlKey);
            return false;
         } else {
            return FieldDate.superclass._keyboardHover.apply(this, arguments);
         }
      },
      /**
       * Проверяет дату в строковом виде на соответствие какому-нибудь из известных шаблонов.
       * @param   {String}             value
       * @returns {String|undefined}  Возвращает маску или undefined, если сопоставления не произошло.
       * @private
       */
      _testStrValueMasks: function(value) {
         var mask;
         if (/^\d{2}\.\d{2}\.\d{4}$/g.test(value)) {
            mask = 'dd.mm.yyyy';
         } else if (/^\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2}$/g.test(value)) {
            mask = 'yyyy-mm-dd hh:ii:ss';
         } else if (/^\d{4}-\d{2}-\d{2}$/g.test(value)) {
            mask = 'yyyy-mm-dd';
         } else if (/^\d{4}-\d{2}-\d{2}\s\d{2}:\d{2}:\d{2}\.\d{3,9}[+-]\d{2}:\d{2}$/g.test(value)) {
            mask = 'yyyy-mm-dd hh:ii:ss.uuu';
         } else if(dateHelpers.isISODate(value)) {
            mask = 'ISO8601';
         } else if(sqlDateRegExp.test(value)) {
            mask = 'SQL';
         }
         return mask;
      },
      /**
       * Логика обработки двузначного года
       * Не изменяет год, если он не лежит в полуинтервале [0..100).
       * @param {Number} year
       * @returns {Number}
       * @private
       */
      _normalizeYear: function(year) {
         if(0 <= year && year < 100) {
            year += year >= this._options.centuryDivision ? 1900 : 2000;
         }
         return year;
      },
      /**
       * Создаёт дату из объекта определёного формата.
       * Учитывает, что в js месяцы начинаются с нуля и предварительно вычитает месяц.
       * @param {Object} obj
       * Объект может содержать поля 'y', 'm', 'd', 'h', 'i', 's', 'u'.
       * @returns {Date}
       * @private
       */
      _createDateFromObj: function(obj) {
         //Ниже расположен костыль для даты 2014.01.01 и времени меньше 01:00:00 (стал нужен ввиду обновления windows)
         var
            y = this._normalizeYear(obj.y),
            m = obj.m - 1,
            h = !cConstants.compatibility.dateBug ? obj.h : (m === 0 && obj.d === 1 && obj.h === 0 ? 1 : obj.h);
         return new Date(y, m, obj.d, h, obj.i, obj.s, obj.u);
      },
      /**
       * Производит автодополнение даты.
       * @see autoComplete
       * @private
       */
      _autoCompleteValue: function() {
         if(!this.isAutoComplete()) {
            return;
         }
         var
            obj = this._tokenizeValue(),
            now = new Date(),
            nowModified = new Date(),
            dateModified = new Date(),
            lastMonthDay,
            tokens = obj.tokens;
         if(!obj.nonEmpty) {
            return;
         }
         tokens.y = (tokens.y || obj.yearIs00) ? this._normalizeYear(tokens.y) : now.getFullYear();
         if(obj.monthIs00) {
            tokens.m = 1;
         }
         tokens.m = Math.min(12, tokens.m || now.getMonth() + 1);
         dateModified.setYear(tokens.y);
         lastMonthDay = dateModified.setLastMonthDay(tokens.m-1).getDate();
         if(tokens.d) {
            if(tokens.d > lastMonthDay) {
               tokens.d = lastMonthDay;
            }
         } else {
            if(obj.dayIs00) {
               tokens.d = 1;
            } else {
               tokens.d = now.getDate();
               if (now.getDate() == nowModified.setLastMonthDay().getDate()) {
                  tokens.d = lastMonthDay;
               }
            }
         }
         if (!this._validateTokens(tokens).length) {
            this._setValueInternal(this._createDateFromObj(tokens));
         } else {
            if (this._vResultErrors.length == 0) {
               this._setValueInternal(null);
               this._insDateFromTokens(tokens);
            } else {
               return;
            }
         }
         this._onValueChangeHandler(true);
      },
      /**
       * Разбивает строковое значение даты на числовые токены в соответствии с переданной маской.
       * @param {String} [str=this._curValue(true)]
       * @param {String} [mask=this._options.mask]
       * @returns {{tokens: {}, nonEmpty: boolean, yearIs00: boolean}}
       * Объект с полями tokens и nonEmpty.
       * Значения токенов будутч переданы в объект tokens и будут храниться в полях 'y', 'm', 'd', 'h', 'i', 's', 'u'.
       * Если хотя бы одно значение будет заполнено, то nonEmpty будет истиной.
       * Если год был указан и был равен нулю, то yearIs00 будет истиной.
       * Важно! При пустом годе в tokens.y всё равно придёт 0, но yearIs00 будет ложью.
       * @private
       */
      _tokenizeValue: function(str, mask) {
         if (str === undefined) {
            str = this._curValue(true).replace(/_/g, ' ');
         }
         if (mask === undefined) {
            mask = this.getMask().toLowerCase();
         }
         var
            args = ['y', 'm', 'd', 'h', 'i', 's', 'u'],
            charVal,
            // значение элемента токена
            val,
            // позиция символа в маске
            posInMask,
            // длина подмаски
            lenSubMask,
            // находится ли в маске данный символ
            isInMask,
            substring,
            tokens = {},
            yearIs00 = false,
            nonEmpty = false,
            monthIs00 = false,
            dayIs00 = false,
            // объект Date() с данными на текущий момент времени
            now = new Date(),
            curDate = this.getValue();
         for (var i = 0, l = args.length; i < l; ++i) {
            charVal = args[i];
            posInMask = mask.indexOf(charVal);
            lenSubMask = mask.lastIndexOf(charVal) - posInMask + 1;
            isInMask = posInMask !== -1;
            //Незаполенные значения заменяем на 0.
            substring = str.substr(posInMask, lenSubMask);
            if (isInMask) {
               if (substring.trim() !== "") {
                  substring = substring.replace(/\s/g, '0');
               }
               val = parseInt(substring, 10);
            } else {
               val = 0;
            }
            // если в маске нет текущих токенов, то надо заполнить
            // их значениями по умолчанию
            if (!isInMask) {
               switch (charVal) {
                  case 'y':
                     // текущий год
                     val = now.getFullYear();
                     break;
                  case 'm':
                     // текущий месяц
                     val = now.getMonth() + 1;
                     break;
                  case 'd':
                     // первое число месяца
                     val = 1;
                     break;
                  case 'u':
                      val = curDate instanceof Date ? curDate.getMilliseconds() : 0;
                     break;
               }
            }
            if (val === 0) {
               // todo: наверное переделать на объект
               switch (charVal) {
                  case 'y':
                     yearIs00 = true;
                     break;
                  case 'm':
                     monthIs00 = true;
                     break;
                  case 'd':
                     dayIs00 = true;
                     break;
               }
            }
            nonEmpty |= isInMask && (val !== null && isNaN(val) === false);
            tokens[charVal] = val || 0;
         }
         return {
            tokens: tokens,
            yearIs00: yearIs00,
            monthIs00: monthIs00,
            dayIs00: dayIs00,
            nonEmpty: nonEmpty
         };
      },
      /**
       * Чинит маску в соответствии с правилами ограничений символов
       * @param {String} mask Распознаваемая маска.
       * @returns {String} обновленная маска
       * @protected
       */
      _fixBrokenMask: function(mask) {
         var
            // правила ограничений
            charCount = {
               y: 4,
               m: 2,
               d: 2,
               h: 2,
               i: 2,
               s: 2,
               u: 3
            },
            // текущий символ в маске
            currentChar,
            // следующий символ в маске
            nextChar,
            // новая маска (с учётом фиксов)
            newMask = '',
            // колчиество символов одного типа (например 'yyyy')
            charSet = 0;
         mask = mask.toLowerCase();
         for (var i = 0; i < mask.length; i++) {
            currentChar = mask.charAt(i);
            nextChar = mask.charAt(i+1);
            charSet++;
            // если символа нет в наборе, значит это разделитель
            if (currentChar && !charCount[currentChar]) {
               newMask += currentChar;
               charSet = 0;
            } else if (currentChar !== nextChar) {
               // год может быть двух- и четырехзначным
               if (currentChar === 'y' && charSet === 2) {
                  charCount.y = 2;
               }
               for (var j = 0; j < charCount[currentChar]; j++) {
                  newMask += currentChar;
               }
               charSet = 0;
            }
         }
         return newMask.toUpperCase();
      },
      /**
       *
       * Переводит строку в дату по маске.
       * @param {String} str Распознаваемая строка.
       * @param {Number} [year] Год распознаваемой даты.
       * @returns {Date}
       * @example
       * <pre>
       *    strToDate('11.08.2005') == Thu Aug 11 2005 00:00:00 GMT+0400 (Московское время (зима))
       * </pre>
       * @see mask
       * @see performFormatValidation
       */
      strToDate: function(str, year){
         if (!str) {
            return;
         }
         var mask = this._testStrValueMasks(str) || this.getMask().toLowerCase();
         switch (mask) {
            case 'ISO8601':
               return dateHelpers.dateFromISO(str);
            case 'SQL':
               return Date.fromSQL(str);
         }
         var
            yearMask = mask.match(/[yY]+/),
            dayMask = mask.match(/[dD]+/),
            yearMaskLength = yearMask ? yearMask[0].length : 0,
            dayMaskLength = dayMask ? dayMask[0].length : 0,
            yearIndexMask = yearMaskLength > 0 ? yearMask.index : 0,
            yearStringVal = str.substr(yearIndexMask, yearMaskLength), // текстовое значение переданного года
            contextVal = this.getValue(),
            obj = this._tokenizeValue(str.replace('/[^0-9\.\:\-\ \\ \/]+/g', ''), mask),
            now = new Date(),
            dateModified = new Date(),
            params = obj.tokens,
            lastMonthDay;

         if (!obj.nonEmpty) {
            return;
         }
         if (year) {
            params.y = year;
         }
         else {
            // если год ввели не полностью, то подставляем текущий год
            if (yearStringVal.indexOf(this._placeHolder()) == -1)  {
               params.y = (params.y || obj.yearIs00) ? this._normalizeYear(params.y) : now.getFullYear();
            }
            else {
               params.y = now.getFullYear();
            }
         }
         if (contextVal instanceof Date && this.getType() === 'time') {
            params.d = contextVal.getDate();
            params.m = contextVal.getMonth()+1;
         } else {
            if (obj.monthIs00) {
               params.m = 1;
            }
            params.m = Math.min(12, params.m || now.getMonth() + 1);
            dateModified.setYear(params.y);
            lastMonthDay = dateModified.setLastMonthDay(params.m - 1).getDate();
            // если в маске не задан день (например маска такая: "MM/YYYY"), то ставим день из контекста
            if (!dayMaskLength && contextVal instanceof Date) {
               params.d = Math.min(contextVal.getDate(), lastMonthDay);
            }
            else {
               if (params.d) {
                  if (params.d > lastMonthDay) {
                     params.d = lastMonthDay;
                  }
               } else {
                  if (obj.dayIs00) {
                     params.d = 1;
                  } else {
                     params.d = Math.min(now.getDate(), lastMonthDay);
                  }
               }
            }
         }
         return this._createDateFromObj(params);
      },
      _setValueInternal: function(value){
         // при вствавке через буфер обмена в value приходит объект, поэтому проверяем и его тоже
         if (typeof value === 'string' || (value && value.hasOwnProperty('clipboard')) ) {
            var pasteVal = value.hasOwnProperty('clipboard') ? value.clipboard : value;
            value = !this._testStrValueMasks(pasteVal) ? this._formatTest(value) : pasteVal; // проверка формата даты
            this._inputControl.html(this._htmlMask);
            value = this.strToDate(value);
         }
         if (!value) {
            this.clear();
            value = null;
         } else if (!isNaN(value.getTime())) {
            this._insDate(value);
            this._updatePureValue();
            this._year = value.getFullYear();
         }
         FieldAbstract.prototype._setValueInternal.apply(this, [value]);
         this._hideMask(this.isActive());
         this._updateArrowsState(value);
      },
      /**
       * Проверяет дату, если нужно - обнуляет время
       * @param {Date} d Проверяемая дата
       * @return {Date|null}
       * @private
       */
      _checkDate: function(d) {
         if(d && d instanceof Date && !isNaN(d.getTime())){
            var symbols = {
               H : 'Hours',
               I : 'Minutes',
               S : 'Seconds',
               U : 'Milliseconds'
            },
               found = {};
            for(var j = 0; j < this._options.mask.length; ++j){
               found[this._options.mask[j]] = true;
            }
            for(var i in symbols){
               if(symbols.hasOwnProperty(i) && !found[i]){
                  d['set' + symbols[i]](0);
               }
            }
            return d;
         }
         else {
            return null;
         }
      },
      /**
       * Возвращает дефолтное значение
       * @returns {Date|null}
       * @private
       */
      _getDefaultValue: function(){
         if(typeof this._options.value === 'function'){
            return this._checkDate(this._options.value());
         }
         else if(typeof this._options.value === 'string'){
            return this._checkDate(this.strToDate(this._options.value));
         }
         else if(this._options.value instanceof Date){
            return this._checkDate(this._options.value);
         }
         return null;
      },
      /**
       * возвращает RegExp для сравнения с символом нажатой клавиши
       *
       * @return {RegExp}
       */
      _keyExp: function(){
         return [/[0-9]/, false];
      },
      /**
       * Устанавливает переданное значение в значение поля
       * @param {Date|Number} [insdate] Может быть объектом Date() или кодом символа(+/-).
       * Если параметр отсутствует, то вставляется текущая дата/время.
       */
      _modifyDate: function(insdate) {
         this._insDate(insdate);
         this._onValueChangeHandler();
      },
      /**
       * Визуально вставляет переданное значение в поле
       * @param {Date|Number} [insdate] Может быть объектом Date() или кодом символа(+/-).
       * Если параметр отсутствует, то вставляется текущая дата/время.
       */
      _insDate: function(insdate){
         var
            orDate, cursor, active,
            date = typeof insdate == 'object' ? insdate : new Date(),
            tokens = {};
         if (insdate == cConstants.key.plus || insdate == cConstants.key.minus){
            orDate = this.getValue();
            if (orDate === null || orDate == 'Invalid Date' || orDate == 'NaN' || orDate.getTime() < 0) {
               date = new Date();
            } else {
               date = new Date(orDate.getTime());
            }
            if (insdate == cConstants.key.plus) {
               date.setDate(date.getDate()+1);
            }
            if (insdate == cConstants.key.minus) {
               date.setDate(date.getDate()-1);
            }
         }
         for(var i in types) {
            if(types.hasOwnProperty(i)) {
               tokens[i] = date['get' + types[i]]() + (i === 'm' ? 1 : 0);
            }
         }
         active = this.isActive() && !this._losingActive;

         // Если поле активно, то запомним положение курсора, чтобы после замены кишочков вернуть курсор где он и был 
         if (active) {
            cursor = this._getCursor(true);
         }
         
         this._insDateFromTokens(tokens);

         // Возвращаем положение курсора полю, если оно активно
         if (active) {
            this._moveCursor.apply(this, cursor);
         }
      },
      /**
       * Вставляет переданное значение по токенам в поле.
       * Может вставить некорректное значение.
       * @param {Object} tokens
       */
      _insDateFromTokens: function(tokens){
         var
            mas = this._clearMask.split(/[^YMDHISU]/g);
         for (var i = 0; i < mas.length; i++) {
            var
               c = mas[i].charAt(0).toLowerCase();
            this._inputControl.find('em:eq(' + i * 2 + ')').text(this._roundTime(tokens[c], mas[i].length));
         }
      },
      /**
       * округляет полученное значение
       * @param t обрабатываемая строка
       * @param [n] количество разрядов в результате
       * @return {String} окрулённое значение
       */
      _roundTime: function(t, n){
         var
            p = '';
         if ((t.toString().length - n) > 0) {
            return t.toString().substr(t.toString().length - n, n);
         } else {
            var v = n - t.toString().length;
            for (var i = 1; i <= v; i++) {
               p += '0';
            }
            return p + t;
         }
      },
      /**
       * Метод применяет сдвиг по часовому поясу и возвращает строковое значение или объект Date(),
       * в противном случае null
       * @param {boolean} isStringResult флаг для выбора представления значения
       * true - строка; false - Date Object
       * @returns {string|Object|null}
       * @private
       */
      _notFormatedVal: function(isStringResult){
         var
            // значение часового пояса
            timeZone = new Date().getTimezoneOffset() / -60,
            timeZoneAbs = Math.abs(timeZone),
            // применить сдвиг по часовому поясу
            appendTimeZone = function(dt) {
               return timeZone === 0 ? dt : dt + (timeZone < 0 ? '-' : '+') + (timeZoneAbs < 10 ? '0': '') + timeZoneAbs;
            },
            result = null,
            dateObjVal = null,
            dataType = this.getType(),
            stringVal = this._getString(),
            contextVal = this.getValue(),
            // mode режим сериализации текущего инстанса даты в SQL-формат
            SQLSerializationMode;
         if (dataType === 'time') {
            stringVal = appendTimeZone(stringVal);
         }
         if (isStringResult) {
            result = stringVal;
         } else {
            switch (dataType) {
               case 'datetime':
                  // true - Сериализуется как Дата и время
                  SQLSerializationMode = true;
                  break;
               case 'time':
                  // false - Сериализуется как Время
                  SQLSerializationMode = false;
                  break;
               case 'date':
                  // undefined - Сериализуется как Дата
                  SQLSerializationMode = undefined;
                  break;
            }
            if (typeof stringVal === 'string' && stringVal.indexOf(this._placeHolder()) === -1) {
               dateObjVal = this.strToDate(stringVal).getTime();
               result = new Date(dateObjVal);
               var hasTimeInMask = /[hisu]/i.test(this.getMask());
               // этот код нужен, чтобы в onValueChangeHandler, при сравнении текущего значения с notFormated, учитывалось время
               if (!hasTimeInMask && contextVal instanceof Date && contextVal.getHours()>0 && result.getHours() == 0) {
                  result.setHours(contextVal.getHours(), contextVal.getMinutes(), contextVal.getSeconds(), contextVal.getMilliseconds());
               }
               result.setSQLSerializationMode(SQLSerializationMode);
            }
         }
         return result;
      },
      /**
       *
       * Получить тип отображаемых данных.
       * Возвращает режим работы: дата/ время/ дата и время.
       * @returns (String) Тип данных ('date' || 'time' || 'datetime').
       * @example
       * <pre>
       *    var type = control.getType();
       *    switch(type){
       *       case "date": CoreFunctions.alert("Дата"); break;
       *       case "time": CoreFunctions.alert("Время"); break;
       *       case "datetime": CoreFunctions.alert("ДатаВремя"); break;
       *    }
       * </pre>
       * @see mask
       */
      getType: function(){
         var
            obj = {
               date : ['Y', 'M', 'D'],
               time : ['H', 'I', 'S', 'U']
            },
            result = '',
            s = 0;
         for (var i in obj){
            for (var j = 0, l = obj[i].length; j < l; j++){
               if (this._clearMask.indexOf(obj[i][j]) != -1){
                  s++;
                  result = i;
                  break;
               }
            }
         }
         return s == 2 ? 'datetime' : result;
      },
      /**
       * Проверить корректность токенов
       * Валидирует токены, проверяя корректность их как даты.
       * Есть проблема с валидацией года, так как в токене он приходит в виде целого
       * округленного числа, из-за чего невозможно проверить корректоность его значения.
       * @param tokens
       * @returns {Array} Массив ошибок в текстовом виде. Можно передать в валидатор.
       * Пустой массив означает отсутствие ошибок.
       * @private
       */
      _validateTokens: function(tokens) {
         var
         // допустимые единицы времени содержащиеся в маске
            maskTimeUnits = {},
         // массив маски ввода без спец. символов
            maskArray = this._clearMask.split(this._sepExp),
         // сообщения для ошибок
            message = {
               y : ' ' +  rk('год'),
               m : ' ' +  rk('месяц'),
               d : ' ' +  rk('день'),
               h : ' ' +  rk('час'),
               i : rk('ы минуты'),
               s : rk('ы секунды'),
               u : rk('ы миллисекунды')
            },
         // упорядоченные временные отрезки
         // TODO: доделать валидацию года
            orderedTimeUnits = ['u', 's', 'i', 'h', 'd', 'm'/*, 'y'*/],
         // имя метода для установки/получения значения единицы времени
            methodName,
         // значение единицы времени из value
            actualNumVal,
         // значение единицы времени в токене
            numVal,
         // интервал для корректного сравнения временных единиц
            offset,
         // массив ошибок
            errors = [],
         // значение в формате DateObject
            value = this._createDateFromObj(tokens);
         $.each(maskArray, function(i, maskPath){
            maskTimeUnits[maskPath.charAt(0).toLowerCase()] = maskPath.length;
         });
         $.each(orderedTimeUnits, function(charOrder, charVal){
            if( maskTimeUnits[charVal] === undefined ) {
               return;
            }
            methodName = types[charVal];
            offset = 0;
            if (methodName === 'Month') {
               offset++;
            }
            numVal = tokens[charVal];
            actualNumVal = value['get' + methodName]();
            if (numVal !== actualNumVal + offset) {
               errors.push(rk('Неверно заполнен') + message[charVal]);
               // дни, месяца и года начинаются с единицы
               if (charOrder > 3) {
                  offset++;
               }
               // Восстанавливаем дату, убирая кривое значение, чтобы оно не переполняло и не портило другие.
               offset += actualNumVal - numVal;
               value['set' + methodName](offset);
            }
         });
         return errors;
      },
      /**
       * Проверка введённого значение даты на корректность
       * Используется как один из встроенных валидаторов.
       * Отключается опцией {@link performFormatValidation}.
       * @returns {Boolean|Array}
       * @private
       */
      _textValidate: function(){
         var
            obj = this._tokenizeValue(),
            result;
         if(!this.isPerformFormatValidation() || !obj.nonEmpty) {
            return true;
         }
         result = this._validateTokens(obj.tokens);
         if(!result.length) {
            result = true;
         }
         return result;
      },
      setActive: function(active){
         //В FF setActive(false) прилетает сюда, а контрол уже сдохший
         if (this.isDestroyed()) {
            return false;
         }
         //Хак для Хрома (ну и для остального тоже есть смысл) -
         //надо выключать contenteditable по уходу фокуса с контрола, и включать по приходу, поскольку
         //В Хроме при событии keydown на каком-то элементе может быть так, что оно дойдёт до body, и потом фокус непонятно
         //почему уйдёт на элемент с contenteditable=true. как выход можно включать/выключать contenteditable при приходе-уходе фокуса
         //на элемент. это происходит только при уходе фокуса с элемента с contenteditable на другой элемент,
         //и последующим событием keydown, необработанном тем элементом, и всплывшим до body.
         // (!) При этом ещё главная беда в том, что событие keydown обрабатывается элементом с contenteditable
         // (содержимое меняется), но не отлавливается форматирующими обработчиками, из-за чего не происходит форматирования эл-та,
         // и содержимое получается "кривым"
         this._inputControl.attr('contenteditable', active && this.isEnabled() && !this.isReadOnly() ? 'true' : 'false');

         if (!active) {
            this._losingActive = true;
            this._autoCompleteValue();
            this._losingActive = null;
         } else if (!this.isActive()) {
            this._inputControl.focus();
         }
         FieldDate.superclass.setActive.apply(this, arguments);
         if (!active && this._containerClickHandher){
            this._containerClickHandher();
         }
      },
      _enableCalendar: function(state){
         if (this.isCalendar()) {
            this._getCalendarContainer().toggleClass('calendar-disabled', !state);
            $('.ui-datepicker[for="' + this.getName() + '"]').toggleClass('ws-calendar-disabled', !state);
         }
      },
      _setEnabled: function(state) {
         this._enableCalendar(state);
         this._updateArrowsState(this.getValue());
         FieldDate.superclass._setEnabled.apply(this, arguments);
      },
      setReadOnly: function(state) {
         this._enableCalendar(!state);
         FieldDate.superclass.setReadOnly.apply(this, arguments);
      },


      /**
       * Используется для обработки событий изменения данных внутри контрола.
       * Обычно вызывается по change и keyup.
       * @param {Boolean}  [noAutoComplete=false]  Не звать автодополнение (иначе будет рекурсия)
       * @param onKeyUp попали сюда по вводу с клавиатуры, нужно в fieldLink, там у input переопределяется _noFormatedVal
       * @protected
       */
      _onValueChangeHandler: function(noAutoComplete, onKeyUp) {
         var
            value = this._curValue(true),
            notFormattedVal = this._notFormatedVal();
         if (!noAutoComplete && this.isAutoComplete() && onKeyUp !== true) { //если был вызов на keyup, то не валидируем дату вообще
            // Если дата введена целиком, но она некорректна, то пытаемся дополнить 
            if (value.indexOf(this._placeHolder()) === -1 && this._validateTokens(this._tokenizeValue().tokens).length) {
               this._autoCompleteValue();
               // мы придём в _onValueChangeHandler (сюда) ещё раз из _autoCompleteValue 
               return;
            }
         }
         if (notFormattedVal instanceof Date && !isNaN(notFormattedVal.getTime())) {
            this._year = notFormattedVal.getFullYear();
         }
         this._updateArrowsState(this._curval);
         FieldDate.superclass._onValueChangeHandler.apply(this, arguments);
         if (cConstants.browser.isMobileAndroid) {
            this._previousValue = this._inputControl.html();
         }
      },

      /**
       * Получить id родительского меню
       * @returns {String|null}
       * @protected
       */
      _getParentMenuId: function() {
         var
            menuParent = this._container.closest('.ws-menu-container');
         return menuParent.length ? menuParent.attr('id') : null;
      },
      
      /**
       *
       * Установить дату, с которой откроется календарь.
       * @param {Date} date - дата.
       * @example
       * <pre>
       *     control.setStartDate(new Date());
       * </pre>
       * @see clearStartDate
       * @see value
       * @public
       */
      setStartDate: function(date) {
         this._startDate = date;
      },
      /**
       *
       * Сбросить дату, установленную в {@link setStartDate}.
       * @example
       * <pre>
       *     control.clearStartDate();
       * </pre>
       * @see setStartDate
       * @see value
       * @public
       */
      clearStartDate: function() {
         this._startDate = undefined;
      },
      /**
       *
       * Отображён ли значок календаря
       * @returns {boolean}
       * @see calendar
       * @public
       */
      isCalendar: function() {
         return this._options.calendar;
      },
      /**
       *
       * Проверяется ли корректность даты
       * @returns {boolean}
       * @see performFormatValidation
       * @public
       */
      isPerformFormatValidation: function() {
         return this._options.performFormatValidation;
      },
      /**
       *
       * Установить (опцию) проверку на корректность даты
       * @param {boolean} performFormatValidation
       * @see performFormatValidation
       * @see isPerformFormatValidation
       * @public
       */
      setPerformFormatValidation: function(performFormatValidation) {
         this._options.performFormatValidation = !!performFormatValidation;
         this._textValidate();
      },
      /**
       *
       * Отображаются ли стрелки переключения дней
       * @returns {boolean}
       * @see arrows
       * @see setArrows
       * @public
       */
      isArrows: function() {
         return this._options.arrows;
      },
      /**
       *
       * Включено ли умное автодополнение
       * @returns {boolean}
       * @see autoComplete
       * @see setArrows
       * @public
       */
      isAutoComplete: function() {
         return this._options.autoComplete;
      },
      /**
       *
       * Включить умное автодополнение
       * @param {boolean} autoComplete
       * @see autoComplete
       * @see isAutoComplete
       * @public
       */
      setAutoComplete: function(autoComplete) {
         autoComplete = !!autoComplete;
         this._options.autoComplete = autoComplete;
         if (autoComplete) {
            this._autoCompleteValue();
         }
      }
   });

   return FieldDate;
});
