/**
 * Created with JetBrains PhpStorm.
 * User: su.filippov
 * Date: 05.12.14
 * Time: 12:05
 * To change this template use File | Settings | File Templates.
 */
define("Deprecated/Controls/FieldMask/FieldMask", ["Deprecated/Controls/FieldFormatAbstract/FieldFormatAbstract"], function(FieldFormatAbstract) {

   "use strict";

   /**
    * Поля с фиксированной маской
    * @class Deprecated/Controls/FieldMask/FieldMask
    * @extends Deprecated/Controls/FieldFormatAbstract/FieldFormatAbstract
    * @author Крайнов Д.О.
    * @control
    * @public
    * @category Fields
    * @initial
    * <component data-component='Deprecated/Controls/FieldMask/FieldMask' style='width: 100px'>
    * </component>
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.FormattedTextBox}.
    */
   var FieldMask = FieldFormatAbstract.extend(/** @lends Deprecated/Controls/FieldMask/FieldMask.prototype */{
      /**
       * @event onInputEnd При вводе последнего символа
       * При этом ввод может быть осуществлён как полностью, так и частично.
       * @param {Core/EventObject} eventObject Дескриптор события.
       * @example
       * При завершении ввода перевести фокус на следующий контрол (nextField), который найден заранее.
       * <pre>
       *    myField.subscribe('onInputEnd', function() {
       *       nextField.setActive(true);
       *    });
       * </pre>
       */
      /**
       * @event onChangePure При вводе текста в поле
       * Событие возникает даже тогда, когда значение поля в контексте не изменилось, но при этом текстовое значение внутри поля поменялось.
       * Например, не до конца ввели дату, но ввод какой-то её части был произведён.
       * @param {Core/EventObject} eventObject Дескриптор события.
       * @param {String} value Текущее значение элемента управления.
       * @example
       * Если не введено ни одного пробела, то провалидировать поле (myField).
       * <pre>
       *    myField.subscribe('onChangePure', function() {
       *       if(this.getStringValue().indexOf(' ') === -1) {
       *          this.validate();
       *       }
       *    });
       * </pre>
       * @ignoreOptions tooltipInside
       */
      $protected : {
         _options : {
            /**
            * @cfg {String} Маска ввода
            *
            * Маска вида: Lll{font-weight: bold;}:xdd{color: red;}, где
            * <ul>
            *    <li>L - заглавная буква (русский/английский алфавит),</li>
            *    <li>l - строчная буква,</li>
            *    <li>d - цифра,</li>
            *    <li>x - буква или цифра,</li>
            *    <li>в фигурные скобки заключены стили для блока,</li>
            *    <li>все остальные символы являются разделителями.</li>
            * </ul>
            * Стили должны располагаться в конце блока - либо перед разделителем, либо в конце маски через пробел от блока.
            * Регистр заглавной или строчной буквы при вводе берётся автоматически по маске.
            * @example
            * Маска задания ввода численного значения с двумя последними цифрами красного цвета: 11 222 3333/<span style="color:red">44</span>
            * <pre>
            *     mask: 'dd ddd dddd/dd {color: red;}'
            * </pre>
            */
            mask: 'llll-dddd(xxxx)',
            cssClassName: 'ws-field-format',
            cssClass: 'ws-field-format'
         }
      }
   });

   return FieldMask;

});
