/**
 * Модуль "Компонент кнопка".
 *
 * @description
 */
define("Deprecated/Controls/PushButton/PushButton", [
   "Core/Deferred",
   "Deprecated/Controls/Button/Button",
   "css!Deprecated/Controls/PushButton/PushButton"
], function(cDeferred, Button) {

   "use strict";

   /**
    * Кнопка
    * @public
    * @class Deprecated/Controls/PushButton/PushButton
    * @extends Deprecated/Controls/Button/Button
    * @author Крайнов Д.О.
    * @control
    * @category Button
    * @initial
    * <component data-component='Deprecated/Controls/PushButton/PushButton'>
    *    <option name='caption'>PushButton</option>
    * </component>
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.ToggleButton}.
    */
   var PushButton = Button.extend(/** @lends Deprecated/Controls/PushButton/PushButton.prototype */{
      $protected:{
         _pressed : false
      },
      /**
       * Происходит при активации кнопки - сообщает о нажатии на кнопку, выполняет необходимые действия
       * @private
       */
      _activate: function(){

         var self = this;

         this.togglePress();
         var result = this._notify('onActivated', this._pressed);
         if(result instanceof cDeferred){
            this._toggleProcess(true);
            result.addBoth(function(result) {
               self._toggleProcess(false);
               return result;
            });
         }
      },
      /**
       *
       * Переключить состояние двухпозиционной кнопки.
       * @param {Boolean} [val] Ожидаемое состояние, если не указан переключается в противоположное от текущего
       * @example
       * <pre>
       *    var btn = this.getTopParent().getChildControlByName("myButton");
       *    btn.togglePress(false);
       * </pre>
       * @see isPressed
       */
      togglePress : function(val){
         this._pressed = val !== undefined ? !!val : !this._pressed;
         this._container.toggleClass('ws-button-pressed', this._pressed);
         if(this._isSpriteImage && this._options.image){
            this._applyImageChange();
         }
      },
      /**
       *
       * Получить признак нажатия кнопки.
       * @return {Boolean} Возвращает состояние кнопки, нажата кнопка или нет.
       * @example
       * <pre>
       *    var btn = this.getTopParent().getChildControlByName("myButton");
       *    if (btn.isPressed()){
       *       btn.togglePress(false);
       *    }
       * </pre>
       * @see togglePress
       */
      isPressed : function(){
         return this._pressed;
      }
   });

   return PushButton;

});
