/**
 * Модуль "Компонент RecordArea".
 *
 * @description
 */
define("Deprecated/Controls/RecordArea/RecordArea", [
   "Core/core-extend",
   "Transport/ReportPrinter",
   "Core/IoC",
   "Core/CommandDispatcher",
   "Core/detection",
   "Core/constants",
   "Lib/Control/TemplatedArea/TemplatedArea",
   "Deprecated/Controls/DialogRecord/DialogRecord",
   "Lib/Mixins/PendingOperationParentMixin",
   "i18n!Deprecated/Controls/RecordArea/RecordArea"
], function(cExtend, ReportPrinter, IoC, CommandDispatcher, cDetection, cConstants, TemplatedArea, DialogRecord, PendingOperationParentMixin) {

   "use strict";

   /**
    * Для описания событий и методов можно посмотреть DialogRecord
    *
    * @class Deprecated/Controls/RecordArea/RecordArea
    * @extends Lib/Control/TemplatedArea/TemplatedArea
    * @author Крайнов Д.О.
    * @public
    * @deprecated
    */
   var RecordArea = cExtend.mixin(TemplatedArea, [PendingOperationParentMixin]).extend(/** @lends Deprecated/Controls/RecordArea/RecordArea.prototype */{
      $protected: {
         _options: {
            readOnly: false,
            newRecord: false,
            reports: {},
            /**
             * @cfg {String} Текст рядом с индикатором сохранения записи
             * @example
             * <pre>
             *     <option name="indicatorSavingMessage">Занят важным делом - сохраняю ваши данные.</option>
             * </pre>
             * @translatable
             */
            indicatorSavingMessage:  rk('Подождите, идёт сохранение')
         },
         _pending: [],
         _waiting: [],
         _record: null,
         _recordSaved: false,
         _loadingIndicator: undefined, //Индикатор загрузки
         _saving: false,               //Сохраняется ли в данный момент
         _reportPrinter: null,
         _printMenu: null,
         _printMenuIsShow: false,
         _lastMenuItemList: [],
         _window: {
            remove : function(){},
            hide: function(){},
            _titleBar : false
         }
      },
      $constructor: function(){
         this._publish('onBeforeDelete', 'onRecordDeleted', 'onBeforeSave', 'onSave', 'onSuccess', 'onFail', 'onRecordUpdate',
            'onAfterClose', 'onBeforeClose', 'onBeforeShowPrintReports', 'onPrepareReportData', 'onSelectReportTransform');

         if(this.getReports().length !== 0)
            this._reportPrinter = new ReportPrinter({});

         if (this._options.isNewRecord !== undefined){
            IoC.resolve('ILogger').error('RecordArea', rk('Опция isNewRecord будет удалена в 3.8.0. Вместо нее используйте опцию newRecord'));
            this._options.newRecord = this._options.isNewRecord;
         }

         DialogRecord.prototype.subscribeOnBeforeUnload.apply(this);
         CommandDispatcher.declareCommand(this, 'ok', function(){
            DialogRecord.prototype.ok.apply(this, []);
         });
         CommandDispatcher.declareCommand(this, 'close', function(){
            DialogRecord.prototype.close.apply(this, []);
         });
         CommandDispatcher.declareCommand(this, 'cancel', function(){
            DialogRecord.prototype.cancel.apply(this, []);
         });
         CommandDispatcher.declareCommand(this, 'save', function(){
            DialogRecord.prototype.save.apply(this, arguments);
         });
         CommandDispatcher.declareCommand(this, 'delete', function(){
            DialogRecord.prototype.delRecord.apply(this, arguments);
         });
         CommandDispatcher.declareCommand(this, 'print', function(event){
            DialogRecord.prototype.print.apply(this, [event]);
         });
         CommandDispatcher.declareCommand(this, 'printReport', function(reportName){
            DialogRecord.prototype.printReport.apply(this, [reportName]);
         });

         if(this._options.readOnly){
            var self = this;
            this._dChildReady.getResult().addCallback(function(){
               self._setEnabledForChildControls(false);
            });
         }
      },
      setSaveDiffOnly: function(){
         DialogRecord.prototype.setSaveDiffOnly.apply(this, arguments);
      },
      isRecordSaved: function(){
         return this._recordSaved;
      },
      _beforeUnloadHandler: function() {
         return DialogRecord.prototype._beforeUnloadHandler.apply(this);
      },
      _unbindBeforeUnload: function() {
         DialogRecord.prototype._unbindBeforeUnload.apply(this);
      },
      unsubscribeOnBeforeUnload: function(){
         DialogRecord.prototype.unsubscribeOnBeforeUnload.apply(this);
      },
      updateRecord: function(){
         return DialogRecord.prototype.updateRecord.apply(this, arguments);
      },
      addPendingOperation: function() {
         return DialogRecord.prototype.addPendingOperation.apply(this, arguments);
      },
      waitAllPendingOperations: function() {
         return DialogRecord.prototype.waitAllPendingOperations.apply(this, arguments);
      },
      _checkPendingOperations: function() {
         return DialogRecord.prototype._checkPendingOperations.apply(this, arguments);
      },
      save: function(){
         return DialogRecord.prototype.save.apply(this, arguments);
      },
      _openConfirmDialog: function(){
         return DialogRecord.prototype._openConfirmDialog.apply(this, arguments);
      },
      _processError: function(error){
         DialogRecord.prototype._processError.apply(this, [error]);
      },
      close: function(){
         DialogRecord.prototype.close.apply(this, arguments);
      },
      _dialogRecordSuperClassClose: function(){
         DialogRecord.prototype._dialogRecordSuperClassClose.apply(this, arguments);
      },
      ok: function(){
         DialogRecord.prototype.ok.apply(this, arguments);
      },
      _setEnabledForChildControls: function(){
         DialogRecord.prototype._setEnabledForChildControls.apply(this, arguments);
      },
      _showLoadingIndicator: function(){
         DialogRecord.prototype._showLoadingIndicator.apply(this, arguments);
      },
      _hideLoadingIndicator: function(){
         DialogRecord.prototype._hideLoadingIndicator.apply(this, arguments);
      },
      isAllReady: function(){
         return DialogRecord.prototype.isAllReady.apply(this, arguments);
      },
      getChildControls: function(){
         return DialogRecord.prototype.getChildControls.apply(this, arguments);
      },
      getReports: function(){
         return DialogRecord.prototype.getReports.apply(this, arguments);
      },
      _printMenuItemsIsChanged: function(){
         return DialogRecord.prototype._printMenuItemsIsChanged.apply(this, arguments);
      },
      _createPrintMenu: function(reportsList){
         return DialogRecord.prototype._createPrintMenu.apply(this, arguments);
      },
      showReportList: function(e){
         return DialogRecord.prototype.showReportList.apply(this, arguments);
      },
      printReport: function(isReport){
         return DialogRecord.prototype.printReport.apply(this, arguments);
      },
      _showReport: function(idReport, data, transform){
         return DialogRecord.prototype._showReport.apply(this, arguments);
      },
      print: function(event){
         return DialogRecord.prototype.print.apply(this, arguments);
      },
      _hideWindow: function(){},
      /**
       * Метод установки/замены записи.
       * @param {String} record Новая запись.
       */
      setRecord : function(record){
         this.getLinkedContext().replaceRecord(record);
      },
      getRecord : function(){
         return this.getLinkedContext().getRecord();
      },
      _getTitle: function(){
         return document.title;
      },
      setReadOnly: function(){
         DialogRecord.prototype.setReadOnly.apply(this, arguments);
      },
      isReadOnly: function(){
         return DialogRecord.prototype.isReadOnly.apply(this, arguments);
      },
      isNewRecord: function(){
         return DialogRecord.prototype.isNewRecord.apply(this, arguments);
      },
      _prepareCloseButton: function(){
         //на мобильном устройстве не создаем крестик закрытия области редактирования записи
         if(!(cConstants.browser.isMobileSafari || cConstants.browser.isMobileAndroid)){
            RecordArea.superclass._prepareCloseButton.apply(this, arguments);
         }
      }
   });

   return RecordArea;

});