/**
 * Created with JetBrains PhpStorm.
 * User: aa.adilov
 * Date: 27.08.13
 * Time: 10:03
 * To change this template use File | Settings | File Templates.
 */
define('Deprecated/Controls/SearchString/SearchString',
   [
   'Core/core-clone',
   "Core/core-instance",
   "Core/core-merge",
   'Core/helpers/Function/debounce',
   'Core/helpers/String/diffAt',
   "Deprecated/helpers/collection-helpers",
   "Core/Deferred",
   "Core/CommandDispatcher",
   "Core/constants",
   "Deprecated/Controls/Button/Button",
   "Lib/Control/FloatArea/FloatArea",
   "Deprecated/Controls/FieldString/FieldString",
   "html!Deprecated/Controls/SearchString/SearchString",
   "Lib/KbLayoutRevert/KbLayoutRevert",
   "i18n!Deprecated/Controls/SearchString/SearchString",
   "css!Deprecated/Controls/SearchString/SearchString",
   "css!Deprecated/Controls/LinkButton/LinkButton"
],
   function(coreClone, cInstance, cMerge, debounce, diffAt, dColHelpers, cDeferred, CommandDispatcher, cConstants, Button, FloatArea, FieldString, dotTplFn, KbLayoutRevert) {

   'use strict';

    var FIELD_PADDING = 40;

   /**
    * Строка поиска
    * @class Deprecated/Controls/SearchString/SearchString
    * @extends Deprecated/Controls/FieldString/FieldString
    * @author Крайнов Д.О.
    * @control
    * @public
    * @initial
    * <component data-component='Deprecated/Controls/SearchString/SearchString' style='width: 100px'>
    * </component>
    * @category Fields
    * @designTime actions /design/design
    * @ignoreOptions password
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.SearchForm}.
    */
   var SearchString = FieldString.extend(/** @lends Deprecated/Controls/SearchString/SearchString.prototype */{
      /**
        * @event onBeforeApplyFilter Перед началом поиска
        * Событие происходит перед началом поиска по связанному представлению данных.
        * От результата, возвращаемого из данного события, зависят дальнейшие действия.
        *
        * Возможные результаты:
        * <ol>
        *    <li>false - поиск не начинать.</li>
        *    <li>true - начать поиск в соответствии с заданным фильтром.</li>
        *    <li>object - использовать значения объекта как дополнительные фильтры связанного представления данных.
        *    Начать поиск по записям с использованием заданного и дополнительных фильтров.
        *    </li>
        * </ol>
        * @param {Core/EventObject} eventObject Дескриптор события.
        * @param {Object} filter Объект с фильтрами, применёнными к связанному представлению данных.
        * @example
        * Перед началом поиска проверить наличие фильтров у связанного представления данных.
        * Если фильтров нет, то применить их.
        * <pre>
        *    searchString.subscribe('onBeforeApplyFilter', function(eventObject, filter) {
        *       if (Object.isEmpty(filter)) {
        *          eventObject.setResult({
        *             'Должность': 'Инженер',
        *            'Возраст': 30
        *          });
        *       }
        *    });
        * </pre>
        * @see linkedBrowser
        * @see filterName
        * @see useBrowserFilter
       */
      /**
       * @event onBeforeResetFilter Перед сбросом поиска
       * Событие происходит перед сбросом поиска по связанному представлению данных.
       * От результата, возвращаемого из данного события, зависят дальнейшие действия.
       *
       * Возможные результаты:
       * <ol>
       *    <li>false - поиск не сбрасывать.</li>
       *    <li>true - сбросить поиск.</li>
       * </ol>
       * @param {Core/EventObject} eventObject Дескриптор события.
       * @see linkedBrowser
       * @see filterName
       * @see useBrowserFilter
       */
      $protected: {
         _suggest: undefined,
         _buttons: [],
         _searchButton: null,
         _clearButton: null,
         _searchWindow: null,
         _currentBrowser: undefined,
         _wasSearched: false,
         _browserConverted: false,
         _searchFields: [],
         _filterStorage: [],
         _oldFilters: [],
         _paramWindowFirstShow: true,   //флаг первого показа окна доп. параметров, если в браузере после загрузки оказался нужный фильтр
         _allowSearch: true,
         _afterLoadHandler: undefined,
         _onConvertHandler: undefined,
         _onFolderEnterHandler: undefined,
         _windowPosition: undefined,
         _applyDebounced: null,
         _onChangeValidValue: undefined,    //последнее значение, при котором открывали окно дополнительных параметров
         _wasSuggestVisible: false,
         _wasAbort: false,
         _lastSearchedValue: undefined,
         _changedFilterName: undefined,
         _reverted: {},
         _options: {
            /**
             *
             * @cfg {Boolean} Сбрасывать корень
             *
             * Перед поиском в иерархических представлениях данных сбрасывается корень - поиск будет идти по всем папкам.
             */
            resetRoot: false,
            /**
             * @cfg {String} Связанное представление данных
             * Это строка формата "ИмяШаблона/ИмяСвязанногоПредставленияДанных".
             *
             * В качестве связанного представления данных могут выступать следующие контролы:
             * <ol>
             *    <li><a href='http://wi.sbis.ru/demo/TreeView'>дерево</a>;</li>
             *    <li><a href='http://wi.sbis.ru/demo/TableView'>табличное представление</a>;</li>
             *    <li><a href='http://wi.sbis.ru/demo/HierarchyView'>иерархическое представление</a>;</li>
             *    <li><a href='http://wi.sbis.ru/demo/CustomView'>произвольное представление</a>.</li>
             * </ol>
             *
             * @see setLinkedBrowser
             * @see getLinkedBrowser
             * @see name
             * @editor InternalBrowserChooser
             */
            linkedBrowser: '',
            /**
             * @cfg {String} Текст подсказки
             *
             * Текст всплывающей подсказки. По умолчанию установлено дублирование этого текста в качестве подсказки в
             * строку поиска - будет показана до момента ввода поискового параметра.
             * @see tooltipInside
             * @translatable
             */
            tooltip: rk('Введите параметры поиска'),
            /**
             * @cfg {String} Имя фильтра
             *
             * Имя фильтра - это имя параметра фильтрации связанного представления данных.
             * Имя фильтра должно совпадать с именем поля связанного представления данных. По этому полю будет производиться поиск.
             * @see setFilterName
             * @see getFilterName
             * @see useBrowserFilter
             */
            filterName : '',
            /**
             * @cfg {String} Имя окна дополнительных параметров поиска
             *
             * Окно дополнительных параметров поиска используется в тех случаях, когда одного фильтра недостаточно.
             * По умолчанию окно строится под строкой поиска: верхний левый угол окна крепится к её нижнему левому углу.
             * @see getParamsWindow
             * @see setWindowPosition
             * @editor ExternalComponentChooser
             */
            paramsWindow : '',
            /**
             * @cfg {Boolean} Скрывать ли окно дополнительных параметров поиска
             */
            hiddenParamsWindow: false,
            /**
             * @cfg {Boolean} Учитывать фильтр представления данных
             * У связанного представления данных могут быть заданы свои фильтры. Их можно учитывать или нет.
             * Возможные значения:
             * <ol>
             *    <li>true - учитывать фильтры.</li>
             *    <li>false - не учитывать фильтры.</li>
             * </ol>
             *
             * @see linkedBrowser
             * @see filterName
             */
            useBrowserFilter: false,
            /**
             * @cfg {Boolean} Получать значение из контекста
             * Разрешить получение значения из контекста контрола.
             * Возможные значения:
             * <ol>
             *    <li>true - разрешить получение.</li>
             *    <li>false - запретить получение.</li>
             * </ol>
             *
             * @see setContextValueReceived
             */
            receiveContextValue: true,
            /**
             * @cfg {Boolean} Признак неактивности строки поиска при пустом представлении данных
             * Делать ли неактивной строку поиска в случае отсутствия записей в связанном представлении данных.
             * Возможные значения:
             * <ol>
             *    <li>true - сделать строку поиска неактивной.</li>
             *    <li>false - оставить строку поиска активной.</li>
             * </ol>
             *
             * @see linkedBrowser
             * @see enabled
             */
            disableAtEmptyBrowser: false,
            /**
             * @cfg {Number} Минимальная длина значения для начала автоматического поиска
             *
             * Если данное значение больше 0, следовательно включен автоматический поиск, который активируется при достижении
             * минимальной длины вводимого поискового параметра, то есть поиск активируется без нажатия на кнопку лупы
             */
            startSearch: 0,
            /**
             * @cfg {Boolean} Сбрасывать поиск при заходе в папку
             */
            resetOnOpen: false,
            /**
             * @cfg {Boolean} Очищать параметры поиска на окне дополнительных параметров после изменения значения в строке поиска
             */
            clearParams: false,
            /**
             * @cfg {Boolean} Задает необходимость использовать механизм смены неверной раскладки
             * @see $ws.single.KbLayoutRevert
             */
            useKbLayoutRevert : false,
            /**
             * @cfg {Boolean} Дублировать ли текст {@link tooltip} внутрь строки поиска.
             * По умолчанию текст подсказки дублируется в строку поиска.
             * Возможные значения:
             * <ol>
             *    <li>true - дублировать.</li>
             *    <li>false - не дублировать.</li>
             * </ol>
             *
             * @see tooltip
             */
            tooltipInside: true,
            /**
             * @cfg {Boolean} Показывать ли кнопку поиска (лупу)
             */
            showLoop: true
         }
      },
      $constructor: function(){
         this._applyDebounced = debounce.call(this.applySearch, 750);
         this._publish('onBeforeApplyFilter', 'onResetFilter', 'onBeforeResetFilter');
         this._declareCommands();
      },
      _dotTplFn: dotTplFn,
      _initEvents: function() {
         SearchString.superclass._initEvents.apply(this, arguments);
         this.subscribe('onActivated', this._onActivatedHandler, true);
         this.subscribe('onValueChange', this._valueChangeHandler);
         this.subscribe('onKeyPressed', this._keyPressedHandler);
         this.subscribe('onChange', this._changeHandler);
         this.subscribe('onFocusOut', this._focusOutHandler);
         $(document).bind('mousedown.' + this.getId() + ' wsmousedown.' + this.getId(), this._mouseDownHandler);
         this._onConvertHandler = this._onConvert.bind(this);
      },
      /**
       * Обработчик на изменение значения строки поиска пользователем
       * @param {Core/EventObject} eventObject дескриптор события
       * @param {String} value текущее значение
       * @private
       */
      _changeHandler: function(event, value){
         if (value === '') {
            if (this._currentBrowser && this._wasSearched) {
                  this._currentBrowser.clearTextHighlight();
               if(this._notify('onBeforeResetFilter') !== false) {
                  this._resetFilter();
               }
            } else {
               this.setValue(null);
            }
         } else if (this._options.startSearch > 0 && value.length >= this._options.startSearch) {
            //выполнить поиск, если поисковое значение достигло минимальной длины
            this._applyDebounced();
         }
      },
      _onResizeHandler: function() {
         SearchString.superclass._onResizeHandler.apply(this, arguments);
      },
      /**
       * Обработчик на нажатие клавиш по строке поиска
       * @param {Core/EventObject} eventObject дескриптор события
       * @param {Event} e javaScript событие
       * @private
       */
      _keyPressedHandler: function(eventObject, e) {
         var currentActiveRow,
             newActiveRow,
             rowkey,
             isKeyUp,
             isKeyLeft;
         this._wasSuggestVisible = !!(this._suggest && this._suggest.isVisible());
         if (e.which === cConstants.key.enter) {
            if(this._suggest && this._wasSuggestVisible && this._suggest.getBrowser().getActiveRow() === false) {
               this._suggest.hide();
               this._wasSuggestVisible = false;
            }
            e.stopPropagation();
            e.preventDefault();
         } else if (this._currentBrowser) {
            //Если открыто автодополнение, то не обрабатываем нажатие клавиш на связанный браузер
            if (this._wasSuggestVisible) {
               return;
            }
            isKeyUp = e.which === cConstants.key.up;
            isKeyLeft = e.which === cConstants.key.left;
            currentActiveRow = this._currentBrowser.getActiveRow();
            //Если нет текущей активной записи, то активной записью станет первая
            newActiveRow = currentActiveRow ? $(currentActiveRow[(isKeyUp ? 'prev' : 'next') + 'All']().filter('[rowkey]')[0])
                                            : this._currentBrowser.getContainer().find('tr[rowkey]').eq(0);
            rowkey = newActiveRow.attr('rowkey');
            if (e.which === cConstants.key.down || isKeyUp) {
               this._currentBrowser.setActiveRow(newActiveRow);
               this._currentBrowser.setActive(true);
               e.stopPropagation();
               e.preventDefault();
               return false;
            }
            if (this._currentBrowser.isTree() && (e.which === cConstants.key.right || isKeyLeft)) {
               if (isKeyLeft === this._currentBrowser.isTreeFolderExpanded(rowkey) &&
                     this._currentBrowser.isRecordFolder(rowkey)) {
                  this._currentBrowser[isKeyLeft ? 'hideBranch' : 'showBranch'](rowkey);
                  eventObject.setResult(false);
                  e.preventDefault();
                  e.stopPropagation();
                  return false;
               }
               eventObject.setResult(true);
               return true;
            }
         }
      },
      _fireOnActivated: function() {
         if (!this._wasSuggestVisible) {
            SearchString.superclass._fireOnActivated.apply(this, arguments);
         } else {
            this._wasSuggestVisible = false;
         }
      },
      /**
       * Обработчик на изменение значения в строке поиска, обработка скрытия/появления крестика
       * @private
       */
      _valueChangeHandler: function() {
         if (this.getStringValue() === '') {
            this._hideCross();
         } else if (this._clearButton.getContainer().hasClass('ws-hidden')) {
            this._showCross();
         }
      },
      /**
       * Обработчик клика вне области строки поиска
       * @param {Event} e javaScript событие
       * @private
       */
      _mouseDownHandler: function(e) {
         //если у нас показано окно доп параметров, то по клику куда-то мимо потрудимся его закрыть
         if(this._searchWindow && this._searchWindow.isShow()){
            var element = $(e.target).closest('.ws-search-window, .ws-search-string');
            // если мы не нашли родителя, который живет в нашей строке поиска, то смело закрываем окно доп параметров
            if(element.length === 0){
               this._searchWindow.hide();
            }
         }
      },
      /**
       * Эта функция отлавливает уход фокуса со строки поиска и с окна доп параметров, чтобы окно доп параметров закрыть
       * @param {Core/EventObject} eventObject дескриптор события
       * @param {Boolean} focus пришел или ушел фокус
       * @param {Lib/Control/Control} nextFocusControl следующий контрол, на который перешел фокус
       * @private
       */
      _focusOutHandler: function(event, focus, nextFocusControl){
         var paramsWindowSearch = function(parent) {
            return parent === this._searchWindow;
         }.bind(this);

         if(this._searchWindow && nextFocusControl){
            if(nextFocusControl !== this._searchWindow &&
               nextFocusControl.getTopParent() !== this._searchWindow &&
               nextFocusControl !== this &&
               nextFocusControl !== this._searchButton &&
               !nextFocusControl.findParent(paramsWindowSearch)) {
               this._searchWindow.hide();
            }
         }
      },
      _onPasteHandler: function() {
         if (!this._pasteProcessing && this.getStringValue() === this._onChangeValidValue) {
            this._onChangeResultHandler(true);
         }
      },
      _declareCommands: function(){
         CommandDispatcher.declareCommand(this, 'search', this._notifyOnActivated);
         CommandDispatcher.declareCommand(this, 'reset', this.resetSearch);
      },
      _notifyOnActivated: function(){
         this._notify('onActivated');
      },
      /**
       * Определить у строки поиска используемое на ней автодополнение
       * @example
       * При готовности автодополнения (suggest) определить его у строки поиска (searchString).
       * <pre>
       *    suggest.subscribe('onReady', function() {
       *       searchString.setSuggest(this);
       *    });
       * </pre>
       */
      setSuggest: function(suggest) {
         if (cInstance.instanceOfModule(suggest, 'Lib/Control/Suggest/Suggest')) {
            this._suggest = suggest;
         }
      },
      /**
       *
       * Начать поиск по заданным параметрам. При этом происходит событие {@link onActivated}.
       * @command search
       * @example
       * При нажатии клавиши Enter начать поиск. При нажатии клавиши Del сбросить результаты поиска.
       * <pre>
       *    //подписываемся на событие при нажатии клавиши
       *    searchString.subscribe('onKeyPressed', function(eventObject, event) {
       *       //проверяем код нажатой клавиши и разрешение на поиск
       *       if (event.which == cConstants.key.enter && this.isAllowSearch()) {
       *          //начинаем поиск по заданным параметрам
       *          this.applySearch();
       *       } else if (event.which == cConstants.key.del) {
       *          //сбрасываем результаты поиска
       *          this.resetSearch();
       *       }
       *    });
       * </pre>
       * @see resetSearch
       * @see isAllowSearch
       * @see onActivated
       */
      applySearch: function(){
         this._notifyOnActivated();
      },
      /**
       *
       * Сбросить результат поиска. При этом происходит событие {@link onChange}.
       * @command reset
       * @example
       * При нажатии клавиши Enter начать поиск. При нажатии клавиши Del сбросить результаты поиска.
       * <pre>
       *    //подписываемся на событие при нажатии клавиши
       *    searchString.subscribe('onKeyPressed', function(eventObject, event) {
       *       //проверяем код нажатой клавиши и разрешение на поиск
       *       if (event.which == cConstants.key.enter && this.isAllowSearch()) {
       *          //начинаем поиск по заданным параметрам
       *          this.applySearch();
       *       } else if (event.which == cConstants.key.del) {
       *          //сбрасываем результаты поиска
       *          this.resetSearch();
       *       }
       *    });
       * </pre>
       * @see applySearch
       * @see isAllowSearch
       * @see onChange
       */
      resetSearch: function(){
         this._onChangeValidValue = undefined;
         if (this._searchWindow && this._searchWindow.isShow()) {
            this._searchWindow.hide();
         }
         if (this._wasSearched || this.getStringValue() !== '') {
            this._notify('onChange', '');
         }
      },
      _onContextValueReceived: function(){
         if (this._options.receiveContextValue) {
            SearchString.superclass._onContextValueReceived.apply(this, arguments);
         }
      },
      /**
       *
       * Установить получение значений из контекста контрола.
       * @param {Boolean} value Разрешить (true) или запретить (false).
       * @example
       * При готовности строки поиска (searchString) запретить принимать значения из контекста.
       * <pre>
       *    searchString.subscribe('onReady', function() {
       *       this.setContextValueReceived(false);
       *    });
       * </pre>
       * @see receiveContextValue
       */
      setContextValueReceived: function(value){
         this._options.receiveContextValue = !!value;
      },
      init: function(){
         var self = this;
         if(this._options.showLoop) {
            this._buttons.push(this._searchButton = new Button({
               element: this._container.find('.ws-search-button'),
               parent: this.getParent(),
               renderStyle: 'asLink',
               img: 'sprite:icon-16 icon-Search icon-primary',
               tooltip: rk('Выполнить поиск'),
               allowChangeEnable: this._options.allowChangeEnable,
               handlers: {
                  'onActivated': function () {
                     self._notifyOnActivated();
                  }
               }
            }));
         }
         this._buttons.push(this._clearButton = new Button({
            element: this._container.find('.ws-clear-button'),
            parent: this.getParent(),
            renderStyle: 'asLink',
            img: 'sprite:ico-Reset',
            tooltip: rk('Очистить результаты поиска'),
            allowChangeEnable: this._options.allowChangeEnable,
            handlers: {
               'onActivated': function(){
                  self.resetSearch();
                  //Вернём фокус на поле ввода
                  self.setActive(true);
               }
            }
         }));
         this.setLinkedBrowser(this._options.linkedBrowser);
         SearchString.superclass.init.apply(this, arguments);
         //onValueChange не стреляет при инициализации, а возможно нужно крестик отобразить
         this._valueChangeHandler();
      },
      _clearSearchFields: function(){
         for (var i = 0, l = this._searchFields.length; i < l; i++) {
            this._searchFields[i].setValue(null, true);
         }
      },
      /**
       *
       * Установить связанное представление данных.
       * @param {String|SBIS3.CORE.DataViewAbstract} linkedBrowser Строка формата "ИмяШаблона/ИмяСвязанногоПредставленияДанных"
       * или экземпляр класса представления данных.
       * @example
       * При готовности строки поиска (searchString) установить связанное представление данных.
       * <pre>
       *    searchString.subscribe('onReady', function() {
        *       if (this.getLinkedBrowser() === undefined) {
        *          this.setLinkedBrowser('Шаблон/Справочник');
        *       }
        *    });
       * </pre>
       * @see linkedBrowser
       * @see getLinkedBrowser
       */
      setLinkedBrowser: function(linkedBrowser) {

         var toSearch,
             name,
             self,
             def;

         if (linkedBrowser) {
            def = new cDeferred();
            self = this;
            toSearch = false;

            def.addCallback(function(browser) {

               if (self._currentBrowser) {
                  self._currentBrowser.unsubscribe('onAfterLoad', self._afterLoadHandler);
                  if (self._currentBrowser.isHierarchy()) {
                     self._currentBrowser.unsubscribe('onFolderEnter', self._onFolderEnterHandler);
                  }
                  toSearch = self._wasSearched;
                  if (!self._browserConverted && !self._currentBrowser.isDestroyed()) {
                     self._resetFilter(toSearch);
                     self._wasSearched = false;
                  }
                  self._browserConverted = false;
               }

               self._currentBrowser = browser;

               self._subscribeBrowser();
               // TODO Не нужно отправлять запрос при конвертации иерархического представления, пока не сделать без костылей, дерево не развернуто (от 29.09.2014, Алена Чистякова в курсе)
               if (toSearch) {
                  self._notifyOnActivated();
               }

            });

            if (cInstance.instanceOfModule(linkedBrowser, 'Deprecated/Controls/DataViewAbstract/DataViewAbstract')) {
               def.callback(linkedBrowser);
            } else {
               name = linkedBrowser;

               if (name.indexOf('/') > -1) {
                  name = linkedBrowser.split('/')[1];
               }

               this.getTopParent().waitChildControlByName(name).addCallback(function(instanse) {

                  def.callback(instanse);
                  return instanse;

               });
            }
         }

      },
      _subscribeBrowser: function() {

         var browser = this._currentBrowser;

         browser.once('onAfterLoad', this._checkFilter.bind(this));
         browser.subscribe('onAfterLoad', this._afterLoadHandler = this._onAfterLoadHandler.bind(this));
         if (browser.hasEvent('onConvert')) {
            browser.unsubscribe('onConvert', this._onConvertHandler);
            browser.subscribe('onConvert', this._onConvertHandler);
         }
         if (browser.isHierarchy()) {
            browser.subscribe('onFolderEnter', this._onFolderEnterHandler = this._onFolderEnter.bind(this));
         }

      },
      /**
       * Сбрасывать поиск при открытии папки
       *
       * Будет ли сбрасываться поиск при входе в папку в иерархии
       * @param {boolean} reset сбрасывать или нет поиск
       * @example
       * <pre>
       *    if (dataView.isHierarchy()) {
       *       searchString.setResetOnOpen(true);
       *    }
       * </pre>
       */
      setResetOnOpen: function (reset) {
         reset = !!reset;
         if (this._currentBrowser && this._currentBrowser.isHierarchy()) {
            if (reset && !this._options.resetOnOpen) {
               this._currentBrowser.subscribe('onFolderEnter', this._onFolderEnterHandler = this._onFolderEnter.bind(this));
            } else if (!reset && this._options.resetOnOpen) {
               this._currentBrowser.unsubscribe('onFolderEnter', this._onFolderEnterHandler);
            }
         }
         this._options.resetOnOpen = reset;
      },
      /**
       * Очищать ли параметры поиска на окне дополнительных параметров после изменения значения в строке поиска
       *
       * Будут ли очищаться параметры поиска на окне дополнительных параметров после изменения значения в строке поиска
       * @param {boolean} clear очищать или нет параметры
       * @example
       * <pre>
       *    if (!searchString.getLinkedBrowser()) {
       *       searchString.setClearParams(true);
       *    }
       * </pre>
       */
      setClearParams: function (clear) {
         this._options.clearParams = !!clear;
      },
      _onFolderEnter: function (e, node) {
         var filter;

         if (this._options.resetOnOpen && this._wasSearched) {
            filter = this._prepareResetFilter();
            filter[this._currentBrowser.getRecordSet().getHierarchyField()] = node;
            this._resetValues();
            e.setResult(filter);
         }
      },
      _onConvert: function (event, view) {
         this._browserConverted = true;
         this.setLinkedBrowser(view.makeOwnerName());
      },
      _checkFilter: function() {
         var filter = this._currentBrowser.getQuery(),
             filterName = this.getFilterName();

         if (filter[filterName]) {
            this.setValue(filter[filterName]);
            this._filterStorage.push(filterName);
            if (this._options.paramsWindow) {
               this._createParamsWindow(true);
            }
            this._wasSearched = true;
         }
      },
       /**
        *
        * Получить экземпляр класса связанного представления данных.
        * @returns {undefined|*} Возвращается undefined, если связанного представления данных нет.
        * @example
        * При готовности строки поиска (searchString) установить связанное представление данных.
        * <pre>
        *    searchString.subscribe('onReady', function() {
        *       if (this.getLinkedBrowser() === undefined) {
        *          this.setLinkedBrowser('Шаблон/Справочник');
        *       }
        *    });
        * </pre>
        * @see linkedBrowser
        * @see setLinkedBrowser
        */
      getLinkedBrowser: function(){
         return this._currentBrowser;
      },
       /**
        *
        * Установить имя фильтра для поиска по связанному представлению данных.
        * @param {String} filterName Имя фильтра.
        * @example
        * Проверить наличие фильтра для поиска по связанному представлению данных. Задать фильтр, если его нет.
        * <pre>
        *    searchString.subscribe('onReady', function() {
        *       if (this.getFilterName()) {
        *          this.setFilterName('Описание');
        *       }
        *    });
        * </pre>
        * @see linkedView
        * @see filterName
        * @see getFilterName
        */
       setFilterName: function(filterName){
          if (filterName && this._options.filterName !== filterName) {
             this._changedFilterName = this._options.filterName;
             this._options.filterName = filterName;
          }
       },
      /**
       *
       * Разрешить изменение активности строки поиска, если связанное представление данных не имеет записей.
       * @param {Boolean} value Разрешить (true) и запретить (false).
       * @example
       * При готовности строки поиска (searchString) разрешить изменять активность.
       * <pre>
       *    searchString.subscribe('onReady', function() {
       *       this.setDisableAtEmptyBrowser(true);
       *    });
       * </pre>
       * @see disableEmptyBrowser
       */
      setDisableAtEmptyBrowser: function(value){
         this._options.disableAtEmptyBrowser = !!value;
      },
       /**
        *
        * Получить имя фильтра, установленного для поиска по связанному представлению данных.
        * @returns {String} Имя фильтра.
        * @example
        * Проверить наличие фильтра для поиска по связанному представлению данных. Задать фильтр, если его нет.
        * <pre>
        *    searchString.subscribe('onReady', function() {
        *       if (this.getFilterName() == '') {
        *          this.setFilterName('Описание');
        *       }
        *    });
        * </pre>
        * @see linkedView
        * @see filterName
        * @see setFilterName
        */
      getFilterName: function(){
         return this._options.filterName;
      },
       /**
        *
        * @private
        */
      _onAfterLoadHandler: function(){
         if (this._options.disableAtEmptyBrowser && !this._wasSearched) {
            var recordsCount = this._currentBrowser.getRecordSet().getRecords().length;
            if (recordsCount === 0 && this._options.enabled) {
               if(this._currentBrowser.isHierarchy() && this._currentBrowser.getRootNode() !== this._currentBrowser.getCurrentRootNode()) {
                  return;
               }
               this.setEnabled(false);
            } else if (recordsCount > 0 && !this._options.enabled) {
               this.setEnabled(true);
            }
         }
      },
      _prepareResetFilter: function() {
         var onResetResult,
             filter;

         if (this._wasSearched) {
            if (this._currentBrowser.isHierarchy()) {
               this._currentBrowser.clearTurn(true);
            }
            filter = this._currentBrowser.getQuery();
            for (var i = 0, l = this._filterStorage.length; i < l; i++) {
               var indexOldFilter;
               for (var j = 0, ln = this._oldFilters.length; j < ln; j++) {
                  if (this._oldFilters[j].hasOwnProperty(this._filterStorage[i])) {
                     indexOldFilter = j;
                     break;
                  }
               }
               if (typeof indexOldFilter === 'undefined') {
                  delete filter[this._filterStorage[i]];
               } else {
                  filter[this._filterStorage[i]] = this._oldFilters[j][this._filterStorage[i]];
                  indexOldFilter = undefined;
               }
            }
            if (this._currentBrowser.isTree()) {
               //в случае дерева getQuery вернет Раздел, который открывали последним...
               filter[this._currentBrowser.getRecordSet().getHierarchyField()] = this._currentBrowser.getRootNode();
            }
            if (this._options.resetRoot && this._currentBrowser.isHierarchyMode()) {
               this._currentBrowser.setRootNode(this._currentBrowser.getRootNode(), true);
            }
            onResetResult = this._notify('onResetFilter', coreClone(filter));
            if ($.isPlainObject(onResetResult)) {
               //позволяем переопределить фильтр при сбросе поиска
               filter = onResetResult;
            }
         }

         return filter;
      },
      /**
       * Очищает результаты поиска.
       * @param {Boolean} notClear очищать значения строки поиска и окна дополнительных параметров
       * @private
       */
      _resetFilter: function (notClear) {
         var filter;

         if (this._wasSearched) {
            filter = this._prepareResetFilter();
            this._resetValues(notClear);
            this._currentBrowser.setQuery(filter, true).addCallback(function(){
               if (this._currentBrowser.isTree()) {
                  this._currentBrowser.applyTurnTree();
               }
            }.bind(this));
         }
      },
      _resetValues: function(notClear) {
         if (!notClear) {
            this.setValue(null);
            this._resetWindowParams();
         }
         this._wasSearched = false;
         this._reverted = {};
         this._onChangeValidValue = undefined;
         this._lastSearchedValue = undefined;
         this._filterStorage = [];
         this._oldFilters = [];
      },
      _resetWindowParams: function ( ) {
         var window = this._searchWindow;
         if (window) {
            if (window.isShow()) {
               window.hide();
            }
            this._clearSearchFields();
         }
      },
       /**
        *
        * Установить расположение окна дополнительных параметров поиска относительно начала отсчёта - верхнего левого угла.
        * Если не задавать расположение окна дополнительных параметров этим методом, то оно будет находиться под строкой
        * поиска: верхний левый его угол крепится к нижнему левому углу строки поиска.
        * @param {Object} offset Отступ относительно начала координат - верхнего левого угла. Задаётся объектом {left: number, top: number}.
        * @example
        * Установить окно дополнительных параметров после строки поиска, прикрепив его верхний левый край к верхнему правому краю строки.
        * <pre>
        *     searchString.subscribe('onInit', function(){
        *        var container = this.getContainer(),
        *           offset = container.offset();
        *        this.setWindowPosition({
        *           //верхний край
        *           top: offset.top,
        *           //левый край
        *           left: offset.left + container.width()
        *        });
        *     })
        * </pre>
        * @see paramsWindow
        * @see getParamsWindow
        */
      setWindowPosition: function (offset) {
         var win = this._searchWindow,
               left, top;
         if (this._options.paramsWindow && offset && typeof (left = offset.left) !== 'undefined' &&
               typeof (top = offset.top) !== 'undefined') {
            if (win) {
               win.setOffset({y: offset.top, x: offset.left});
            } else {
               this._windowPosition = offset;
            }
         }
      },
       /**
        *
        * Получить окно дополнительных параметров поиска.
        * @returns {undefined|SBIS3.CORE.Window} Возвращает экземпляр класса SBIS3.CORE.Window.
        * @example
        *
        * <pre>
        *
        * </pre>
        * @see paramsWindow
        * @see setWindowPosition
        */
      getParamsWindow: function ( ) {
         return this._searchWindow;
      },
      _createParamsWindow: function (notDisplay) {
         var isSetPosition = typeof this._windowPosition !== 'undefined',
               offset = isSetPosition ? this._windowPosition : this._container.offset(),
               self = this,
               config;
         if (!isSetPosition) {
            offset.top += 24;
         }
         config = {
            template: this._options.paramsWindow,
            opener: this,
            border: false,
            parent: this.getParent(),
            cssClassName: 'ws-search-window',
            autoHide: false,
            autoCloseOnHide: true,
            offset: {
               y: offset.top,
               x: offset.left
            },
            animation: 'fade',
            animationLength: 0,
            handlers: {
               'onAfterShow': function(e){
                  e.setResult(this.getContainer().offset());
                  var childControls = this.getChildControls();
                  for(var i = 0, l = childControls.length; i < l; i++){
                     childControls[i].subscribe('onFocusOut', self._focusOutHandler.bind(self));
                  }
               },
               'onDestroy': function(){
                  self._searchWindow = undefined;
                  self._searchFields = [];
               },
               'onBeforeShow': function(){
                  if(self._options.hiddenParamsWindow)
                     this._cancelShow();
               }
            }
         };
         if (notDisplay) {
            config.handlers.onReady = function ( ) {
               self._initParams(this.getChildControls());
            };
            config.handlers.onBeforeShow = function ( ) {
               if(self._paramWindowFirstShow) {
                  self._paramWindowFirstShow = false;
                  this.hide();
               }
            };
         }
         this._searchWindow = new FloatArea(config);
      },
      _notifyOnChange: function(notFormattedValue){
         var onChangeResult;
         this._updateSelfContextValue(notFormattedValue);
         onChangeResult = this._notify('onChange', notFormattedValue);
         if (onChangeResult) {
            this._onChangeValidValue = notFormattedValue;
         }
         this._notifyOnValueChange(notFormattedValue);
         this._onChangeResultHandler(onChangeResult);
      },
      _onChangeResultHandler: function (result) {
         if (result && this._options.paramsWindow) {
            /* Делаю проверку isDestroyed(), из-за того, что вставка (paste) в поле делается по таймауту,
               а окно к этому мементу может ещё не уничтожиться, и проверка на существование searchWindow пройдёт */
            if (!this._searchWindow || this._searchWindow.isDestroyed()) {
               this._createParamsWindow();
            } else {
               if (this._searchWindow.isVisible()) {
                  if(this._options.hiddenParamsWindow){
                     this._searchWindow.setOffset({x: -10000, y: -10000});
                  }else{
                     this._searchWindow.moveToTop();
                  }
               } else {
                  this._searchWindow.show();
               }
            }
         } else if (this._searchWindow && this._searchWindow.isVisible()) {
            this._searchWindow.hide();
         }
      },
      _initParams: function (fields, extender, filter) {
         var currentFilter,
             filterName,
             field;
         if ($.isArray(fields)) {
            currentFilter = this._currentBrowser.getQuery();
            for (var i = 0, l = fields.length; i < l; i++) {
               field = fields[i];
               if (cInstance.instanceOfModule(field, 'Deprecated/Controls/FieldString/FieldString')) {
                  filterName = field.getName();
                  if (extender) {
                     this._setOldFilters(field, extender, filter);
                  } else if (currentFilter[filterName]) {
                     field.setValue(currentFilter[filterName], true);
                  }
                  this._filterStorage.push(filterName);
                  this._searchFields.push(field);
               }
            }
         }
      },
      _setOldFilters: function(field, extender, filter) {
         var value = field.getStringValue(),
             filterName = field.getName(),
             noOldValue = true;
         if (value !== '') {
            extender[filterName] = value;
         } else if (filter[filterName]) {
            for (var j = 0, ln = this._oldFilters.length; j < ln; j++) {
               if (this._oldFilters[j].hasOwnProperty(filterName)) {
                  filter[filterName] = this._oldFilters[j][filterName];
                  noOldValue = false;
                  break;
               }
            }
            if (noOldValue) {
               delete filter[filterName];
            }
         }
      },
       /**
        * Обработчик на выполнение поиска.
        * @private
        */
      _onActivatedHandler: function() {
          var stringValue = this.getStringValue(),
              checkSearchWindowChange = function(filter) {
                 for(var i = 0, len = this._searchFields.length; i < len; i ++) {
                    if(filter[this._searchFields[i].getName()] !== this._searchFields[i].getStringValue()) {
                       return false;
                    }
                 }
                 return true;
              }.bind(this),
              checkOldFilters;

         if (this._options.enabled) {
            if (this._currentBrowser && this._options.filterName && stringValue.trim() !== '') {
               var filter = this._currentBrowser.getQuery(),
                   extender = {};

               if(filter[this._changedFilterName]) {
                  delete filter[this._changedFilterName];
               }

               if (this._searchWindow) {
                  this._initParams(this._searchWindow.getChildControls(), extender, filter);
               }

               if (this._lastSearchedValue === stringValue && checkSearchWindowChange(filter)) {
                  //если в прошлый раз искали по такому же значению, но в фильтре браузера другое
                  //просто сменим раскладку, искать ничего не будет
                  if (filter[this._options.filterName] !== stringValue && this._options.useKbLayoutRevert) {
                     this.setValue(KbLayoutRevert.process(stringValue));
                  }
                  return;
               }

               var isTree = this._currentBrowser.isTree(),
                   onBeforeApplyFilterResult;
               if (!this._allowSearch) {
                  this._wasAbort = true;
                  this._currentBrowser.getRecordSet().abort();
               }
               if (this._options.clearParams && typeof this._onChangeValidValue !== 'undefined' && stringValue !== this._onChangeValidValue) {
                  //Если установлена опция очищения параметров доп. окна, при этом окно ранее открывалось и текущее
                  //значение в строке поиска отличается, то очистим дополнительные поля
                  if(this._searchWindow) {
                     this._clearSearchFields();
                  } else if(this._options.useBrowserFilter) {
                     /* Если окно доп параметров разрушено, но фильтры остались в браузере - удалим их */
                     this._filterStorage.forEach(function(key) {
                        if(this._searchFields.indexOf(key) === -1 && key !== this.getFilterName()) {
                           if(filter.hasOwnProperty(key)) {
                              delete filter[key];
                           }
                        }
                     }, this);
                  }
               }
               if (!this._wasSearched) {
                  this._wasSearched = true;
                  checkOldFilters = true;
               } else {
                  this._filterStorage = [];
               }
               extender[this._options.filterName] = stringValue;
               this._filterStorage.push(this.getFilterName());
               if (checkOldFilters) {
                  for (var j = 0, ln = this._filterStorage.length; j < ln; j++) {
                     if (filter.hasOwnProperty(this._filterStorage[j])) {
                        var oldFilter = {};
                        oldFilter[this._filterStorage[j]] = filter[this._filterStorage[j]];
                        this._oldFilters.push(oldFilter);
                     }
                  }
                  if (this._currentBrowser.isHierarchyMode()) {
                     this._oldFilters.push({'Разворот': filter['Разворот']});
                  }
               }
               filter = this._options.useBrowserFilter ? cMerge(filter, extender) : extender;
               onBeforeApplyFilterResult = this._notify('onBeforeApplyFilter', coreClone(filter));
               if (this._currentBrowser.isHierarchyMode()) {
                  filter['Разворот'] = 'С разворотом';
                  this._filterStorage.push('Разворот');
                  if (this._options.resetRoot) {
                     this._currentBrowser.setRootNode(this._currentBrowser.getRootNode(), true);
                  }
                  if (this._options.resetRoot || isTree) {
                     //если была открыта папка вызывается loadNode - он портит Раздел.
                     filter[this._currentBrowser.getRecordSet().getHierarchyField()] = this._currentBrowser.getRootNode();
                  }
               }
               if (onBeforeApplyFilterResult !== false) {
                  if ($.isPlainObject(onBeforeApplyFilterResult)) {
                     for (var key in onBeforeApplyFilterResult) {
                        if (onBeforeApplyFilterResult.hasOwnProperty(key) && !filter.hasOwnProperty(key)) {
                           this._filterStorage.push(key);
                        }
                     }
                     filter = onBeforeApplyFilterResult;
                  }
                  this._setBrowserHighlight(filter);
                  this._allowSearch = false;
                  this._lastSearchedValue = stringValue;
                  this._applySearch(filter);

                  if (this._searchWindow) {
                     this._searchWindow.hide();
                  }
               }
            } else if (stringValue !== '') {
               this._showCross();
            }
         }
      },
      /**
       * Подсветка текста в браузере
       * @param filter фильтр браузера
       * @private
       */
      _setBrowserHighlight: function(filter) {
         if (this._options.filterName && filter.hasOwnProperty(this._options.filterName)) {
            var value = filter[this._options.filterName];
            this._currentBrowser.setTextHighlight(typeof value === 'string' && value.length ? value : '');
         }
      },
      _applySearch: function(filter) {
         var filterCopy = coreClone(filter),
             self = this,
             reverted;
         /*К сожалению вынужден делать третий запрос, чтобы откатить фильтр к первоначальному
               sbisdoc://1+ОшРазраб+01.11.14+136602+2DBDF88C-35F7-4D89-A64B-3FFA3E7584F+*/
         this._currentBrowser.setQuery(filterCopy, true).addCallback(function() {
            //Результат колбэка оказался не числом в иерархии, поэтому пока проверяем так
            if (self._currentBrowser.getRecordSet().getRecordCount()) {
               self._afterSearchHandler();
            } else if (!self._wasAbort) {
               reverted = self._tryRevertKbLayout(filter);

               if (Object.keys(reverted || {}).length) {
                  self._lastSearchedValue = self.getStringValue();
                  self._currentBrowser.setQuery(filter, true).addCallback(function() {
                     //TODO: в будущем возможно придется проставить значения дополнительным параметрам поиска
                     if (self._currentBrowser.getRecordSet().getRecordCount()) {
                        self.setValue(reverted[self._options.filterName]);
                        self._reverted = reverted;
                        self._afterSearchHandler();
                     } else {
                        self._currentBrowser.setQuery(filterCopy, true).addCallback(function() {
                           self._wasAbort = false;
                           self._allowSearch = true;
                        });
                     }
                  });
               }
            } else {
               self._wasAbort = false;
               self._allowSearch = true;
            }
         });
      },
      _afterSearchHandler: function() {
         this._wasAbort = false;
         this._allowSearch = true;

         if (this._currentBrowser.isTree()) {
            this._currentBrowser.applyTurnTree(true);
         }
      },
      /**
       * Пытается найти в полях данные, которые введены в ошибочной раскладке
       * меняет фильтр если найдет такие
       * @param {Object} filter фильтр, который нужно изменить
       * @returns {Object|undefined} объект с измененными значениями
       */
      _tryRevertKbLayout : function(filter) {
         var reverted,
             currentValue,
             revertedValue;

         if (!this._options.useKbLayoutRevert) {
            return reverted;
         }

         reverted = {};

         /* Делаем пока замену раскладки только на строке поиска, окно дополнительных параметров не трогаем
          так как не понятно как обработать следующую ситуацию:
          потенциально ищем результаты на русском, в строку поиска ввели значение на английской раскладке,
          а в поле на окне дополнительных параметров значение на русской раскладке, в результате не найдем
          ничего, потому что раскладка на дополнительном поле сменится.

          Для того чтобы учитывать поля на окне, в forEach передать [ this ].concat(this._searchFields)
          */
         [ this ].forEach(function(field) {

            var name = cInstance.instanceOfModule(field, 'Deprecated/Controls/SearchString/SearchString') ? this._options.filterName : field.getName(),
                hasRevertedValue = this._reverted.hasOwnProperty(name);

            currentValue = field.getStringValue();
            if (hasRevertedValue) {
               var diffPos = diffAt(currentValue, this._reverted[name]),
                  symbolsCommon = diffPos === -1 ? '' : currentValue.substr(0, diffPos);
               currentValue = currentValue.replace(symbolsCommon, '');
            }

            revertedValue = KbLayoutRevert.process(currentValue);

            if (revertedValue !== currentValue) {
               revertedValue = hasRevertedValue ? symbolsCommon + revertedValue : revertedValue;
               reverted[name] = revertedValue;
               filter[name] = revertedValue;
            }

         }.bind(this));

         return reverted;
      },
      /**
       *
       * Разрешён ли поиск.
       * @returns {Boolean} Признак: разрешён (true) или запрещён (false).
       * @example
       * При нажатии клавиши Enter начать поиск. При нажатии клавиши del сбросить результаты поиска.
       * <pre>
       *    //подписываемся на событие при нажатии клавиши
       *    searchString.subscribe('onKeyPressed', function(eventObject, event) {
       *       //проверяем код нажатой клавиши и разрешение на поиск
       *       if (event.which == cConstants.key.enter && this.isAllowSearch()) {
       *          //начинаем поиск по заданным параметрам
       *          this.applySearch();
       *       } else if (event.which == cConstants.key.del) {
       *          //сбрасываем результаты поиска
       *          this.resetSearch();
       *       }
       *    });
       * </pre>
       * @see applySearch
       * @see resetSearch
       */
      isAllowSearch: function(){
         return this._allowSearch;
      },
      /**
       * Показать крестик
       * @private
       */
      _showCross: function() {
         this._toggleCross();
      },
      /**
       * Скрыть крестик
       * @private
       */
      _hideCross: function() {
         this._toggleCross(true);
      },
      /**
       * Скрыть или показать крестик
       * @param {Boolean} toHide true - скрываем, false - показываем
       * @private
       */
      _toggleCross: function(toHide) {
         toHide = !!toHide;
         this._clearButton.getContainer().toggleClass('ws-hidden', toHide);
         this._container.toggleClass('ws-SearchString__cross-visible', !toHide);
      },
      _setEnabled: function(s){
         SearchString.superclass._setEnabled.apply(this, arguments);
         this._searchButton && this._searchButton.setEnabled(s);
         this._clearButton && this._clearButton.setEnabled(s);
      },
      setAllowChangeEnable: function(s) {
         SearchString.superclass.setAllowChangeEnable.apply(this, arguments);
         this._searchButton && this._searchButton.setAllowChangeEnable(s);
         this._clearButton && this._clearButton.setAllowChangeEnable(s);
      },
      /**
       * Задает параметр, отвечающий за смену раскладки в строке поиска
       * Раскладка меняется, если по запросу ничего не найдено
       *
       * @param {Boolean} useKbLayoutRevert менять ли раскладку
       * @example
       * <pre>
       *    searchString.setUseKbLayoutRevert(true);
       * </pre>
       */
      setUseKbLayoutRevert: function(useKbLayoutRevert){
         this._options.useKbLayoutRevert = !!useKbLayoutRevert;
      },
      /**
       * Получить признак того, что используется смена раскладки при поиске
       *
       * @return {Boolean} useKbLayoutRevert меняется ли раскладка
       * @example
       * <pre>
       *    //если не используется смена раскладки при поиске, то установим ее
       *    if(!searchString.getUseKbLayoutRevert()){
       *       searchString.setUseKbLayoutRevert(true);
       *    }
       * </pre>
       */
      getUseKbLayoutRevert: function(){
         return this._options.useKbLayoutRevert;
      },
      destroy: function(){
         var window = this._searchWindow,
             button;
         for (var i = 0, l = this._buttons.length; i < l; i++) {
            button = this._buttons[i];
            if (cInstance.instanceOfModule(button, 'Deprecated/Controls/Button/Button')) {
               button.destroy();
               button = null;
            }
         }
         if (cInstance.instanceOfModule(window, 'Lib/Control/FloatArea/FloatArea')) {
            window.destroy();
            window = null;
         }
         if (!this._options.receiveContextValue && this._options.name) {
            this.getLinkedContext().removeValue(this._options.name, true);
         }
         SearchString.superclass.destroy.apply(this, arguments);
      }
   });

   return SearchString;

});
