define("Deprecated/Controls/SwitcherDouble/SwitcherDouble", ["Deprecated/Controls/SwitcherAbstract/SwitcherAbstract", "html!Deprecated/Controls/SwitcherDouble/SwitcherDouble", "css!Deprecated/Controls/SwitcherAbstract/SwitcherAbstract"], function( SwitcherAbstract, dotTplFn) {

   "use strict";

   var buttonWidth = 24;

   /**
    * Двухпозиционный переключатель.
    *
    * @class Deprecated/Controls/SwitcherDouble/SwitcherDouble
    * @extends Deprecated/Controls/SwitcherAbstract/SwitcherAbstract
    * @author Крайнов Д.О.
    * @public
    * @control
    * @category Select
    * @initial
    * <component data-component='Deprecated/Controls/SwitcherDouble/SwitcherDouble'>
    *    <option name='textOn'>On</option>
    *    <option name='textOff'>Off</option>
    * </component>
    * @deprecated Используйте класс {@link SBIS3.CONTROLS.SwitcherDouble}.
    */
   var SwitcherDouble = SwitcherAbstract.extend(/** @lends Deprecated/Controls/SwitcherDouble/SwitcherDouble.prototype */{
      $protected: {
         _options: {
            value: false,
            /**
             * @cfg {String} Текст при выключенном состоянии
             * @translatable
             */
            textOff: '',
            /**
             * @cfg {String} Текст при включённом состоянии
             * @translatable
             */
            textOn: '',
             /**
              * @cfg {String} Делает цвет текста как у метки
              */
            colorStyle: 'gray',
            /**
             * @typedef {string} DispositionType
             * @variant horizontal горизонтальное
             * @variant vertical вертикальное
             */
            /**
             * @cfg {DispositionType} Расположение двухпозиционного переключателя
             */
            disposition: 'horizontal'
         },
         _toggler: undefined,
         _togglerCircle: undefined,
         _textContainer: undefined
      },
      $constructor: function(){
         this._initEvents();
         if (this._options.disposition === 'vertical') {
            var textWidth = this._container.width() - buttonWidth;
            if (textWidth) {
               this._container.find('.ws-switcher-double-text').width(textWidth);
            }
         }
      },
      /**
       * Подписывается на события
       * @protected
       */
      _initEvents: function(){
         this._toggler.bind('click', this._userAction.bind(this, this._toggleByUser));
         this._textOffContainer.bind('click', this._userAction.bind(this, this._keyLeft));
         this._textOnContainer.bind('click', this._userAction.bind(this, this._keyRight));
      },
      /**
       * Обрабатывает действие пользователя, предотвращает изменения на выключенном контроле
       * @param {Function} callback Функция, которую необходимо выполнить
       * @private
       */
      _userAction: function(callback){
         if( this.isEnabled() ){
            callback.call(this);
         }
      },
      /**
       * Привязывает блоки из вёрстки к переменным
       * @private
       */
      _bindBlocks: function(){
         this._toggler = this._container.find('.ws-switcher-toggler-container');
         this._togglerCircle = this._container.find('.ws-switcher-toggler-circle');
         this._textOffContainer = this._container.find('.ws-switcher-text-off');
         this._textOnContainer = this._container.find('.ws-switcher-text-on');
      },
      /**
       * Переключает классы в зависимости от состояния
       * @param {Boolean} value Значение переключателя
       * @private
       */
      _toggleClasses: function(value){
         this._textOffContainer.toggleClass('ws-switcher-double-text-off', value);
         this._textOnContainer.toggleClass('ws-switcher-double-text-off', !value);
         this._toggler.toggleClass('ws-switcher-toggler-on', value);
      },
      /**
       * Дополнительно вешает свой класс ws-enabled для удобства
       * @see isEnabled
       * @param {Boolean} enable Включён ли контрол
       */
      _setEnabled: function(enable){
         SwitcherDouble.superclass._setEnabled.apply(this, arguments);
         this._textOffContainer.toggleClass('ws-disabled', !enable);
         this._textOnContainer.toggleClass('ws-disabled', !enable);
         this._toggler.toggleClass('ws-disabled', !enable);
      },
      _dotTplFn: dotTplFn
   });

   return SwitcherDouble;

});