define('Deprecated/Controls/TableView/plugins/RightAccordion-plugin/RightAccordion-plugin', [
   "Core/core-instance",
   "Deprecated/Controls/TableView/TableView",
   "css!Deprecated/Controls/TableView/plugins/RightAccordion-plugin/RightAccordion-plugin"
], function(cInstance, TableView) {
   /**
    * @class SBIS3.CORE.RightAccordion
    * @extends Deprecated/Controls/TableView/TableView
    * @author Крайнов Д.О.
    * @plugin
    * @public
    * @deprecated
    */
    TableView.RightAccordionPlugin = TableView.extendPlugin(/** @lends SBIS3.CORE.RightAccordion.prototype  */{
      $protected: {
         _isSetDblLine: false
      },
      $withoutCondition: ['init'],
      $constructor: function () {
         this._options.display.isRightAccordion = this._options.display.isRightAccordion || this._container.hasClass('ws-right-accordion');
         if (this._options.display.isRightAccordion) {
            this._container.addClass('ws-right-accordion');
            if (cInstance.instanceOfModule(this, 'Deprecated/Controls/TreeView/TreeView')) {
               this._options.display.viewMode = 'foldersTree';
               this._options.display.folderIconOpen = 'icon-16 icon-Arrow1730 icon-disabled action-hover';
               this._options.display.folderIconClose = 'icon-16 icon-DayForward icon-disabled action-hover';
               this.subscribe('onFolderOpen', this._setDblLine);
               this.subscribe('onKeyPressed', this._cancelKeyPressed);
               this.subscribe('onAfterRender', this._setDblLine);
            }
            this._options.mode = 'navigationMode';
         }
      },
      $condition: function () {
         return this._options.display.isRightAccordion;
      },
      _isNavigation: function(){
         return true;
      },
      _cancelKeyPressed: function(event,e){
         event.setResult(false);
      },
      _setDblLine: function(){
         var isDbLineClassAdded = false;
         this._container
               .find('tr .ws-browser-cell-container').each(function(){
                  if(this.scrollHeight !== this.clientHeight || this.scrollWidth !== this.clientWidth) {
                     $(this).parents('tr.ws-browser-table-row').addClass('ws-browser-row-dblline');
                     isDbLineClassAdded = true;
                  }
               });
         isDbLineClassAdded && this.recalcBrowserOnDOMChange();
      },
      _onResizeHandler: function(){
         //Бывает такое, что onResizeHandler срабатывает, когда ещё колонок в браузере нету
         //Добавляю проверку на загруженность колонок
         if (this._isVisibleWithParents() && this._currentRecordSet &&  !Object.isEmpty(this._currentRecordSet.getColumns())) {
            this._setDblLine();
         }
      },
      _drawBody: function() {
         this._setDblLine();
      },
      /**
       * Включение/выключение выделения строк, ключи которых переданы в массиве
       * @param {Array} keys массив ключей записей, для которых включаем/выключаем выделение
       * @param {Boolean} [enable=true] Чтобы включить возможность выделения строки,
       * false, чтобы выключить
       */
      setEnabledRows: function (keys, enable) {
         var rowKey;
         for( var i = 0, len = keys.length; i < len; i++ ) {
            rowKey = keys[i];
            this._container.find('tr[rowKey='+ rowKey +']')
               .toggleClass('ws-browser-disabled-item', !enable);
         }
         //снимаем выделение с активной строки, если она задизаблена
         if(this._activeElement && this._isDisabledRow(this._activeElement)) {
            this._activeElement.removeClass('ws-browser-row-selected');
         }
      }
   });

});