define('Deprecated/Templates/FastTemplate',[
   'Transport/Templates/Template',
   'Deprecated/core-attach',
   'Core/Context',
   'Core/Deferred',
   'Core/CommandDispatcher',
   'Core/helpers/collection-helpers',
   'Core/helpers/getModuleNameWithPlugin',
   'Core/IoC',
   'Core/core-instance',
   'Core/helpers/dom&controls-helpers',
   'Core/moduleStubs'
], function(
   Template,
   core_attach,
   Context,
   Deferred,
   CommandDispatcher,
   colhelpers,
   getModuleNameWithPlugin,
   ioc,
   cInstance,
   dcHelpers,
   moduleStubs
) {
   var FastTemplate;
   FastTemplate = Template.extend({
      $protected: {
         _options: {
            template: ''
         },
         _dom: null,
         _rootConfig: {},
         _controlsConfig: []
      },
      $constructor: function() {
         var self = this;
         this._dom = document.createElement('div');
         this._dom.innerHTML = this._options.template;
         if (!this._dom.firstChild) {
            throw new Error("Wrong template (" + this.getName() + ") came from server");
         }

         var firstChild = this._dom.firstChild;
         this._rootConfig = JSON.parse(firstChild.getAttribute('templateConfig'));
         this._controlsConfig = JSON.parse(firstChild.getAttribute('config'));

         firstChild.removeAttribute('templateConfig');
         firstChild.removeAttribute('config');

         for (var key in this._controlsConfig.functions) {
            if (this._controlsConfig.functions.hasOwnProperty(key)) {
               var
                  val = this._controlsConfig.functions[key],
                  path = '["' + val.split('/').join('"]["') + '"]',
                  acessor = new Function("s", "val", "return arguments.length == 1 ? s" + path + " : (s" + path + " = val);"),
                  configRoot = self._controlsConfig,
                  fSpec = acessor(configRoot).split('#');
               switch (fSpec[0]) {
                  case 'function':
                     self._dReady.push(core_attach.getHandler(fSpec[1]).addCallback(function(f) {
                        acessor(configRoot, f);
                     }));
                     break;
                  case 'moduleFunc':
                     var
                        m = fSpec[1].split("/"),
                        fName = m.length > 1 ? m.pop() : '',
                        mName = m.join('/');
                     self._dReady.push(moduleStubs.require(getModuleNameWithPlugin(mName)).addCallback(function(mod) {
                        var fn = mod[0][fName];
                        if (!fn) {
                           ioc.resolve('ILogger').error(rk('Шаблон') + ' ' + self.getName(),
                              rk('В шаблоне указан обработчик, но в модуле') + ' ' + mName + ' ' + rk('не найдена функция')
                              + ' ' + fName + ' ' + rk('для этого обработчика'));
                        } else {
                           fn.wsHandlerPath = 'js!' + mName + (fName ? ':' + fName : '');
                           acessor(configRoot, fn);
                        }
                     }));
                     break;
                  case 'floatArea':
                     acessor(configRoot, function(event) {
                        var topParentContainer = this.getTopParent().getContainer();
                        this.setEnabled(false);//Отключаем кнопку, чтобы юзер 100500 раз панельку не вызывал
                        core_attach.attachInstance("Control/Area:FloatArea", {
                           opener: this,
                           template: fSpec[1],
                           target: topParentContainer,//$('body'),
                           side: 'right',
                           autHide: true,
                           animationLength: 300,
                           offset: {
                              x: 0,
                              y: (window.scrollY > topParentContainer.offset().top) ? window.scrollY : 0
                           },
                           handlers: {
                              'onAfterClose': function() {
                                 this.getOpener().setEnabled(true);//включаем обратно
                              }
                           }
                        });
                     });
                     break;
                  case 'dialog':
                     acessor(configRoot, function() {
                        var
                           finishContextDfr = new Deferred(),
                           linkedCtx = Context.createContext(finishContextDfr, null, this.getLinkedContext());

                        core_attach.attachInstance("Control/Area:Dialog", {
                           template: fSpec[1],
                           opener: this,
                           context: linkedCtx,
                           handlers: {
                              onDestroy: function() {
                                 finishContextDfr.callback();
                              }
                           }
                        });
                     });
                     break;
                  case 'command':
                     var fn = function(event) {
                        event.setResult(CommandDispatcher.sendCommand.apply(CommandDispatcher, [
                           this, fSpec[1]
                        ].concat(Array.prototype.slice.call(arguments, 1))));
                     };
                     fn.isCommand = true;
                     acessor(configRoot, fn);
                     break;
                  case 'newpage':
                  case 'page':
                     acessor(configRoot, function() {
                        var link = typeof this.getOpenLink === 'function' ? this.getOpenLink() || fSpec[1] : fSpec[1];
                        if (fSpec[0] == 'page') {
                           window.location = link;
                        } else {
                           window.open(link);
                        }
                     });
                     break;
                  case 'menu':
                     acessor(configRoot, function() {
                        if (cInstance.instanceOfModule(this, 'Deprecated/Controls/Button/Button')) {
                           this._options.menuName = fSpec[1];
                           this.unsubscribe('onActivated', arguments.callee);
                           this._initMenu();
                           this._notify('onActivated');
                        }
                     });
                     break;
               }
            }
         }

         for (var key in this._rootConfig) {
            if (this._rootConfig.hasOwnProperty(key)) {
               var
                  val = this._rootConfig[key];
               if (key.substr(0, 2) == 'on') {
                  var
                     handlers = val.split('|');
                  handlers.forEach(function(val, idx) {
                     self._dReady.push(core_attach.getHandler(val).addCallback(function(f) {
                        self._loadedHandlers[key] = self._loadedHandlers[key] || [];
                        self._loadedHandlers[key][idx] = f;
                        return f;
                     }));
                  });
               }
            }
         }
         if (this._rootConfig.style) {
            var cssReady = dcHelpers.insertCss(this._rootConfig.style, true, this.getName());
            if (cssReady) {
               this._dReady.push(cssReady);
            }
         }

         var include = colhelpers.filter(this._dom.firstChild.childNodes, function(child) {
            return child.nodeName == 'I';
         });
         if (include.length > 0) {
            // Не может быть несколько инклюдов... Всегда берем первый
            var spec = include[0].getAttribute('spec');
            if (spec) {
               try {
                  spec = JSON.parse(spec);
               } catch (e) {
                  spec = false;
               }
               if (spec) {
                  spec.js && self._dReady.push(core_attach.attachSequentally(spec.js));
                  spec.css && self._dReady.push(core_attach.attachSequentally(spec.css));
               }
            }
         }

         this._dReady.done();
      },

      _getIncludeDescriptorNodes: function() {
         return colhelpers.filter(this._dom.firstChild.childNodes, function(child) {
            return child.nodeName == 'I';
         });
      },

      _collectAllControlsToPreload: function(source) {
         return colhelpers.reduce(source, function(res, item) {
            if (item.children && item.children.length) {
               res = res.concat(this._collectAllControlsToPreload(item.children));
            }
            res.push(item);
            return res;
         }, [], this);
      },

      isPage: function() {
         return !this._rootConfig.isApplication;
      },

      getConfig: function() {
         for (var attr in this._rootConfig) {
            if (this._rootConfig.hasOwnProperty(attr)) {
               this._mergeAttrToConfig(this._configuration, attr, this._rootConfig[attr]);
            }
         }
         return this._configuration;
      },
      getStyle: function() {
         return this._rootConfig.windowStyle || "";
      },
      getAlignment: function() {
         var
            h = this._rootConfig.HorizontalAlignment,
            v = this._rootConfig.VerticalAlignment;
         return {
            horizontalAlignment: !h ? 'Stretch' : h,
            verticalAlignment: !v ? 'Stretch' : v
         };
      },
      getTitle: function() {
         return this._rootConfig.title;
      },
      createMarkup: function(container) {
         container.html(this._dom.firstChild.innerHTML);
      },
      getDimensions: function() {
         var
            width = this._rootConfig.width + "",
            height = this._rootConfig.height + "";
         return {
            width: !width ? '' : width.toLowerCase() === 'auto' ? 'auto' : width.indexOf('%') >= 0 ? width : parseInt(width, 10) + 'px',
            height: !height ? '' : height.toLowerCase() === 'auto' ? 'auto' : height.indexOf('%') >= 0 ? height : parseInt(height, 10) + 'px'
         };
      },
      getControls: function(parent) {
         if (parent) {
            return [];
         }
         return this._controlsConfig.children;
      },
      needSetZindexByOrder: function() {
         return true;
      }
   });

   return FastTemplate;
});