define('Deprecated/Templates/XMLTemplate', [
   'Transport/Templates/Template',
   'Transport/nodeType',
   'Transport/attachTemplate',
   'Core/Deferred',
   'Core/ParallelDeferred',
   'Core/IoC',
   'Deprecated/core-attach',
   'Core/Context',
   'Core/CommandDispatcher',
   'Core/helpers/Object/isEmpty',
   'Core/helpers/collection-helpers',
   'Core/core-instance',
   'Core/helpers/dom&controls-helpers',
   'Core/helpers/random-helpers'
], function(Template, nodeType, attach, Deferred, ParallelDeferred, ioc, core_attach, Context, CommandDispatcher, isEmptyObject, colhelper, cInstance, dcHelpers, randomHelpers) {
   var XMLTemplate;
   /**
    * @class Deprecated/Templates/XMLTemplate
    * @extends Transport/Templates/Template
    * @author Бегунов А.В.
    * @public
    * @deprecated
    */
   XMLTemplate = Template.extend(/** @lends Deprecated/Templates/XMLTemplate.prototype */{
      /**
       * @cfg {Document} XML-документ шаблона
       * @name Deprecated/Templates/XMLTemplate#templateXML
       * @see templateName
       */
      /**
       * @cfg {String}  Название шаблона, оно же путь к нему
       * @name Deprecated/Templates/XMLTemplate#templateName
       * @see templateXML
       */
      $protected: {
         _xml: null,
         _toText: [],
         _html: '',
         _dReady: null,
         _innerTemplates: [],
         _templateName: '',
         _document: undefined,
         _controlTagCache: ''
      },
      $constructor: function(cfg) {
         var self = this;
         this._xml = cfg.templateXML;
         this._document = this._xml.documentElement ? this._xml.documentElement : this._xml;
         this._innerTemplates[this._templateName = cfg.templateName] = true;
         this._includeInnerTemplate(new Deferred()).addCallbacks(function() {
            self._assignId();
            self._loadEventHandlers();
         }, function(e) {
            ioc.resolve('ILogger').log("Template", "Building failed. Reason: " + e.message);
            return e;
         });

         var tag = this._xml.getElementsByTagName('style')[0];
         if (tag) {
            var style = this._findCDATA(tag, true);
            if (style) {
               var cssReady = dcHelpers.insertCss(style, true, this.getName());
               if (cssReady) {
                  this._dReady.push(cssReady);
               }
            }
         }
      },

      _getIncludeDescriptorNodes: function() {
         var collection;

         if (this._xml.nodeType == nodeType.DOCUMENT_NODE) {
            collection = this._xml.firstChild.childNodes;
         } else {
            collection = this._xml.childNodes;
         }

         return colhelper.filter(collection, function(child) {
            return child.nodeName.toUpperCase() == 'I';
         });
      },

      isPage: function() {
         return this._document.getAttribute('isApplication') === 'false';
      },
      _collectAllControlsToPreload: function(source) {
         return this._getControlsByFilter(function() {
            return true;
         });
      },
      _extractControlConfiguration: function(controlNode) {
         var configObject, cfg = controlNode.getAttribute('config');
         if (cfg) {
            try {
               configObject = eval("(" + cfg + ")");
            } catch (e) {
               configObject = {};
            }
         } else {
            configObject = this._parseConfiguration(controlNode.getElementsByTagName('configuration')[0]);
         }
         return configObject;
      },
      /**
       * @param node где нужно искать
       * @param needValue что нужно вернуть - значение или узел
       * @return {String} styleData значение тега style
       */
      _findCDATA: function(node, needValue) {
         var childNode,
             styleData;
         for (var i = 0, l = node.childNodes.length; i < l; i++) {
            childNode = node.childNodes[i];
            if (childNode.nodeType === nodeType.CDATA_SECTION_NODE) {
               styleData = needValue ? childNode.nodeValue : childNode;
               break;
            }
         }
         return styleData;
      },
      /**
       * Ищет все теги include и инстанцирует их в нужные места
       * @param {Core/Deferred} dResult
       * @returns {Core/Deferred}
       */
      _includeInnerTemplate: function(dResult) {
         var self = this,
             includeNodes = this._xml.getElementsByTagName('include'),
             dP = new ParallelDeferred(),
             includeNode,
             parent, includeName,
             innerTemplates = [],
             styles = [];
         if (includeNodes.length === 0) {
            dResult.callback();
         } else {
            for (var i = 0, l = includeNodes.length; i < l; i++) {
               includeNode = includeNodes[i];
               parent = includeNode.parentNode;
               if ((includeName = includeNodes[i].getAttribute('name')) !== null) {
                  if (this._innerTemplates[includeName]) {
                     return dResult.errback("Cyclic dependency detected");
                  } else {
                     innerTemplates.push(includeName);
                     styles[i] = "";
                     (function(parent, includeNode, i) {
                        dP.push(attach.loadTemplateFile(includeName).addCallback(function(xmlDoc) {
                           var templateChildren = (xmlDoc.documentElement ? xmlDoc.documentElement.childNodes : xmlDoc.childNodes),
                               tag = xmlDoc.getElementsByTagName('style')[0],
                               newNode;
                           if (tag) {
                              styles[i] = self._findCDATA(tag, true);
                              (xmlDoc.documentElement ? xmlDoc.documentElement : xmlDoc).removeChild(tag);
                           }
                           for (var j = 0, cnt = templateChildren.length; j < cnt; j++) {
                              newNode = templateChildren[0];
                              if (self._xml.adoptNode) {
                                 newNode = self._xml.adoptNode(newNode);
                              }
                              parent.insertBefore(newNode, includeNode);
                           }
                           parent.removeChild(includeNode);
                           return xmlDoc;
                        }));
                     })(parent, includeNode, i);
                  }
               }
               else {
                  for (var key in includeNode.childNodes) {
                     if (includeNode.childNodes.hasOwnProperty(key)) {
                        var
                           val = includeNode.childNodes[key];
                        if (val.getAttribute) {
                           var source = val.getAttribute('source');
                           if (source) {
                              dP.push(core_attach.attach(source));
                           }
                        }
                     }
                  }
               }
            }
            dP.done().getResult().addCallback(function() {
               var styleNode = self._xml.getElementsByTagName('style')[0];
               for (var i = 0, l = innerTemplates.length; i < l; i++) {
                  self._innerTemplates[innerTemplates[i]] = true;
               }
               if (styleNode) {
                  self._findCDATA(styleNode, false).nodeValue += styles.join('');
               } else {
                  styleNode = self._xml.createElement('style');
                  styleNode.appendChild(self._xml.createCDATASection(styles.join('')));
                  self._document.appendChild(styleNode);
               }
               self._includeInnerTemplate(dResult);
            });
         }
         return dResult;
      },
      /**
       * Проставляет id контролам у которых его нету.
       */
      _assignId: function() {
         var controls = this._getControlTags(this._xml);
         for (var i = 0, l = controls.length; i < l; i++) {
            var control = controls[i];
            if (!control.getAttribute('id')) {
               control.setAttribute('id', randomHelpers.randomId());
            }
         }
      },
      _getControlTags: function(where) {
         var result;
         if (this._controlTagCache) {
            return this._controlTagCache;
         }

         if (where.querySelectorAll) {
            var qsa = where.querySelectorAll('div[wsControl="true"]');
            if (qsa) {
               result = qsa;
            }
         }

         if (!result) {
            result = [];
            var collection = where.getElementsByTagName('div');
            for (var i = 0, l = collection.length; i < l; i++) {
               var item = collection[i];
               if (item.getAttribute('wsControl')) {
                  result.push(item);
               }
            }

         }

         return (this._controlTagCache = result);
      },
      /**
       * Это оптимизация.
       * Используем более быстрый querySelectorAll если возможно
       * @returns {Array}
       */
      _getFunctionOptions: function() {
         var res;
         if (this._xml.querySelectorAll) {
            res = this._xml.querySelectorAll('option[type="function"]');
            if (res) {
               return res;
            }
         }

         var functions = this._xml.getElementsByTagName('option');
         res = [];
         for (var i = 0; i < functions.length; i++) {
            if (functions[i].getAttribute('type') === 'function') {
               res.push(functions[i]);
            }
         }
         return res;
      },
      /**
       * Инициирует загрузку всех функций используемых в шаблоне
       */
      _loadEventHandlers: function() {
         var functions = this._getFunctionOptions();
         for (var i = 0; i < functions.length; i++) {
            var name = functions[i].getAttribute('name'),
                value = functions[i].getAttribute('value');

            if (value !== null && value.length > 0) {
               this._dReady.push(core_attach.getHandler(value));
            }
         }
         this._dReady.push(this._processTemplateHandlers()).done(this);
      },
      /**
       * Ставит в очередь на загрузку все хэндлеры диалогов, найденные в содержании
       * @returns {Core/Deferred}
       */
      _processTemplateHandlers: function() {
         var
            dMainHandlers = new ParallelDeferred(),
            self = this;

         var attrs = this._document.attributes, events = {};
         for (var i = 0, l = attrs.length; i < l; i++) {
            var
               anAttr = attrs[i],
               attrName = anAttr.nodeName;
            if (attrName.substring(0, 2) == 'on' && anAttr.nodeValue !== '') { // it is event handler
               events[attrName] = anAttr.nodeValue.split('|');
            }
         }

         if (!isEmptyObject(events)) {
            /**
             * Здесь мы начинаем загрузку всех хандлеров, определенных на самом окне.
             * Здесь, а не ранее, потому что они будут иметь более высокий приоритет,
             * но не должны нарушить ранее заданный порядок.
             *
             * В колбэке основной цепочки стартуем ParallelDeferred,
             * зависящий от загрузки всех хандлеров на окне
             */

            for (var eventName in events) {
               if (events.hasOwnProperty(eventName)) {
                  (function(eN, hSpec) {
                     self._loadedHandlers[eN] = [];
                     for (var i = 0; i < hSpec.length; ++i) {
                        (function(i) {
                           dMainHandlers.push(core_attach.getHandler(hSpec[i]).addCallbacks(function(f) {
                              self._loadedHandlers[eN][i] = f;
                              return f;
                           }, function(e) {
                              ioc.resolve('ILogger').error(
                                 "Template",
                                 "Error while loading handler " + eN + ": " + e.message,
                                 e);
                              return e;
                           }));
                        }(i));
                     }
                  })(eventName, events[eventName]);
               }
            }
         }

         return dMainHandlers.done().getResult();
      },
      /**
       * Возвращает стиль окна, заданный при проектировании
       */
      getStyle: function() {
         return this._document.getAttribute('windowStyle') || "";
      },
      /**
       * @returns {Object} Объект с параметрами width и height
       */
      getDimensions: function() {
         var
            width = this._document.getAttribute('width'),
            height = this._document.getAttribute('height');
         return {
            width: !width ? '' : width.toLowerCase() === 'auto' ? 'auto' : width.indexOf('%') >= 0 ? width : parseInt(width, 10) + 'px',
            height: !height ? '' : height.toLowerCase() === 'auto' ? 'auto' : height.indexOf('%') >= 0 ? height : parseInt(height, 10) + 'px'
         };
      },
      /**
       * @returns {Object} объект { h: String, w: String } с параметрами выравнивания ws-area
       */
      getAlignment: function() {
         var
            h = this._document.getAttribute('HorizontalAlignment'),
            v = this._document.getAttribute('VerticalAlignment');
         return {
            horizontalAlignment: !h ? 'Stretch' : h,
            verticalAlignment: !v ? 'Stretch' : v
         };
      },
      /**
       * @returns {String} заголовок окна
       */
      getTitle: function() {
         return this._document.getAttribute('title');
      },

      /**
       * @return {object} конфиг окна прописанный в шаблоне
       */
      getConfig : function(node) {
         var cfg = this._configuration,
             tag = node || this._document;
         if (tag.attributes !== null) {
            for (var i = 0, l = tag.attributes.length; i < l; i++) {
               var att = tag.attributes[i];
               this._mergeAttrToConfig(cfg, att.nodeName, att.nodeValue);
            }
         }
         return cfg;
      },
      /**
       * @returns {Object} Хэш-мэп событий, и подписантов на них. Подписанты передаются в виде массива
       */
      getDeclaredHandlers: function() {
         return this._loadedHandlers;
      },
      createMarkup: function(container) {
         var markup;
         if (this._html === '') {
            // TODO зачем здесь так?
            var markupNode = (this._xml.nodeName == 'ws-template' ? this._xml : this._xml.getElementsByTagName('ws-template')[0]);
            var ownerDoc = container.get(0).ownerDocument;
            var fragment = ownerDoc.createElement('div');
            var col = markupNode ? markupNode.childNodes : [];
            var item, i = 0, l;
            while (col.length && i < col.length) {
               item = col.item(i);
               if (item.nodeType == nodeType.ELEMENT_NODE && item.nodeName != 'style') {
                  item = Template._importNode(ownerDoc, item, true);
                  i++;
                  fragment.appendChild(item);
               } else {
                  i++;
               }
            }
            var configs = fragment.getElementsByTagName('configuration');
            for (i = 0, l = configs.length; i < l; i++) {
               configs[0].parentNode.removeChild(configs[0]);
            }
            this._html = markup = fragment.innerHTML.replace(/<\/ ?br>/ig, "").replace(/&amp;/ig, "&");
         } else {
            markup = this._html;
         }
         container.html(markup);
      },

      _getControlsByFilter: function(filter) {
         var controls = this._getControlTags(this._xml);
         var result = [];
         for (var i = 0, l = controls.length; i < l; i++) {
            var control = controls[i];

            if (filter(control)) {
               var cfg = this._extractControlConfiguration(control);
               cfg.type = control.getAttribute('type');
               cfg.id = control.getAttribute('id');
               result.push(cfg);
            }
         }
         return result;
      },

      /**
       * @param {String} parentId
       * @returns {Array} параметры и типы контролов, присутствующих в шаблоне
       */
      getControls: function(parentId) {
         return this._getControlsByFilter(function(control) {
            return parentId == control.getAttribute('parentId');
         });
      },
      /**
       * Обрабатывает конфигурацию элементов управления
       *
       * @param {Node} configRoot Текщий узел разобра
       * @param {Boolean} [makeArray] обрабатывается ли в настоящий момент массив?
       * @returns {Object} Конфигурация контрола
       */
      _parseConfiguration: function(configRoot, makeArray){
         var
             name, value, type,
         // Это место переписано так не случайно. От старого вариант почему-то ВНЕЗАПНО ломался каверидж
            retvalFnc = function() {
               var self = this;
               self.mass = makeArray ? [] : {};
               self.push = function(name, value) {
                  if (makeArray) {
                     self.mass.push(value);
                  } else if (name !== null) {
                     self.mass[name] = value;
                  }
               }
            },
            retval = new retvalFnc();

         if (configRoot && configRoot.childNodes) {
            var children = configRoot.childNodes;
            for (var i = 0, l = children.length; i < l; i++) {
               var child = children[i];
               if (child.nodeName && (child.nodeName == 'option' || child.nodeName == 'options')) {
                  name = child.getAttribute('name');
                  type = child.getAttribute('type');
                  value = child.getAttribute('value');

                  //if (type === 'array' || name === null || value === null){
                  if (type === 'array' || (value === null && type != 'cdata')) {
                     //Если не в листе дерева, то разбираем дальше рекурсивно
                     if (value === null)
                        value = this._parseConfiguration(child, type === 'array');
                     retval.push(name, value);
                  }
                  //добрались до листа дерева
                  else //if (!makeArray){
                  {
                     switch (type) {
                        case 'cdata':
                           retval.push(name, this._findCDATA(child, true));
                           break;
                        case 'boolean':
                           retval.push(name, value === "true");
                           break;
                        case 'moduleFunc':
                        case 'function':
                           if (typeof(value) === 'string' && value.length > 0) {
                              var hdl = core_attach.getHandler(value);
                              if (!hdl.isReady() || hdl.isSuccessful()) {
                                 (function(name) {
                                    hdl.addCallback(function(handler) {
                                       if (typeof(handler) == 'function') {
                                          retval.push(name, handler);
                                          return handler;
                                       }
                                       else
                                          throw new Error("Integrity error! Some serious problems in $ws.core.getHandler()!");
                                       // XXX: Potentially uncaught error condition
                                    });
                                 })(name);
                              } else {
                                 throw new Error(value + " function is not ready or don't exist");
                              }
                           }
                           break;
                        case 'dialog':
                           if (typeof(value) === 'string' && value.length > 0) {
                              (function(value) {
                                 retval.push(name, function() {
                                    var
                                       finishContextDfr = new Deferred(),
                                       linkedCtx = Context.createContext(finishContextDfr, null, this.getLinkedContext());
                                    core_attach.attachInstance("Control/Area:Dialog", {
                                       template: value,
                                       opener: this,
                                       context: linkedCtx,
                                       handlers: {
                                          onDestroy: function() {
                                             finishContextDfr.callback();
                                          }
                                       }
                                    });
                                 });
                              })(value);
                           }
                           break;
                        case 'floatArea':
                           if (typeof(value) === 'string' && value.length > 0) {
                              (function(value) {
                                 retval.push(name, function() {
                                    var topParentContainer = this.getTopParent().getContainer();
                                    this.setEnabled(false);//Отключаем кнопку, чтобы юзер 100500 раз панельку не вызывал
                                    core_attach.attachInstance("Control/Area:FloatArea", {
                                       id: this.getId(),
                                       opener: this,
                                       name: this.getName() + '-floatArea',
                                       template: value,
                                       target: topParentContainer,//$('body'),
                                       side: 'right',
                                       autHide: true,
                                       showDelay: 300,
                                       animationLength: 300,
                                       offset: {
                                          x: 0,
                                          y: (window.scrollY > topParentContainer.offset().top) ? window.scrollY : 0
                                       },
                                       handlers: {
                                          'onAfterClose': function() {
                                             this.getOpener().setEnabled(true);//включаем обратно
                                          }
                                       }
                                    });
                                 });
                              })(value);
                           }
                           break;
                        case 'command':
                           if (typeof(value) === 'string' && value.length > 0) {
                              (function(value) {
                                 retval.push(name, function(event) {
                                    event.setResult(CommandDispatcher.sendCommand.apply(CommandDispatcher, [this, value].concat(Array.prototype.slice.call(arguments, 1))));
                                 });
                              })(value);
                           }
                           break;
                        case 'page':
                        case 'newpage':
                           if (typeof(value) === 'string' && value.length > 0) {
                              (function(value, type) {
                                 retval.push(name, function() {
                                    var link = typeof this.getOpenLink === 'function' ? this.getOpenLink() || value : value;
                                    if(type == 'page')
                                       window.location = link;
                                    else
                                       window.open(link);
                                 });
                              })(value, type);
                           }
                           break;
                        case 'menu':
                           if (typeof(value) === 'string' && value.length > 0) {
                              (function(value) {
                                 retval.push(name, function() {
                                    if (cInstance.instanceOfModule(this, 'Deprecated/Controls/Button/Button')) {
                                       this._options.menu = value;
                                       this.unsubscribe('onActivated', arguments.callee);
                                       this._initMenu();
                                       this._notify('onActivated');
                                    }
                                 });
                              })(value);
                           }
                           break;
                        case null:
                        default :
                           if (value === "null") {
                              value = null;
                           }
                           if (value === "Infinity") {
                              value = Infinity;
                           }
                           retval.push(name, value);
                           break;
                     }
                  }
                  //}
               }
            }
         }
         return retval.mass;
      },

      needSetZindexByOrder: function() {
         return true;
      }
   });

   return XMLTemplate;
});