define('Deprecated/helpers/Hcontrol/getNonControlSize', function () {
    /**
     * Получить авто-размер для неконтрола
     * @param {Object} collection jQuery-набор элементов - неконтролов.
     * @param {String} type Height|Width - тип размера.
     * @returns {Number} значение.
     */

    return function (collection, type) {

        var max = 0, curr = 0, i, ln = (collection && collection.length) || 0, isHidden, ltype;

        if (ln > 0) {
            isHidden = jQuery.expr.filters.hidden,
                ltype = type.toLowerCase();

            for (i = 0; i < ln; i++) {
                var elem = collection[i], jqElem;

                if (!isHidden(elem)) {
                    jqElem = $(elem);

                    var attr = elem.getAttribute('orig' + type);
                    if (attr === null || attr === "auto" || attr === "Auto") {
                        curr = jqElem['getNative' + type]();
                    } else {
                        curr = parseFloat(attr);

                        var margins = elem.getAttribute('alignmargin');
                        if (margins !== null) {
                            margins = margins.split(',');

                            if (type === 'Height') {
                                curr += ((parseInt(margins[0], 10) + parseInt(margins[2], 10)) || 0);
                            } else {
                                curr += ((parseInt(margins[1], 10) + parseInt(margins[3], 10)) || 0);
                            }
                        }

                        // добавляем padding+border, если есть.
                        curr += jqElem["outer" + type]() - jqElem[ltype]();
                    }
                    max = (curr > max) ? curr : max;
                }
            }
        }

        return max;
    };
});