define('Deprecated/helpers/Hcontrol/parseMargins', function () {
    /**
     * Получает и парсит атрибут alignmargin, отвечающий за отступы контрола.
     * Если атрибута нет, марджины ставятся в ноль по умолчанию.
     * @param {jQuery} elem  элемент, у которого получить марджины.
     * @returns {Object} Объект марджинов.
     */

    return function (elem) {
        var result, wsMargin, margins;

        elem = $(elem);

        wsMargin = elem.attr('alignmargin');
        if (wsMargin) {
            margins = wsMargin.split(',');
            result = {
                'top': parseInt(margins[0], 10),
                'right': parseInt(margins[1], 10),
                'bottom': parseInt(margins[2], 10),
                'left': parseInt(margins[3], 10)
            };
        } else {
            result = {};
        }

        for (var key in result) {
            if (result.hasOwnProperty(key)) {
                result[key] = result[key] || parseInt(elem.css('margin-' + key), 10) || 0;
            }
        }
        return result;
    };
});