define('Deprecated/helpers/String/parseComplexKey', function() {

    /**
    * Производит разбор сложного идентификатора.
    * @remark
    * Разбор идентификатора производится в объект вида:
        * <pre>
    * {
        *    objName: name,
        *    objKey: key
        * }
    * </pre>
    * @param {string} key Сложный идентификатор.
    * @returns {*}
    */

   return function (key) {
        if (typeof key == 'string') {
            var splitPos = key.indexOf(',');
            if (splitPos != -1) {
                return {
                    objName: key.substr(splitPos + 1),
                    objKey: key.substr(0, splitPos)
                };
            }
        }
        return {
            objName: '',
            objKey: key
        };
    };
});