define('Deprecated/helpers/collection-helpers',[
   'Core/helpers/vital/objectsDiff',
   'Core/helpers/Object/isPlainObject',
   'Core/helpers/Array/isPlainArray'
], function(
   objectsDiff,
   isPlainObject,
   isPlainArray
){
   /**
    * @class Deprecated/helpers/collection-helpers
    * @public
    * @deprecated
    */
   var collectionHelpers = /** @lends Deprecated/helpers/collection-helpers.prototype */{
      forEach: function (obj, iterateCallback, context) {
         if (obj === null || obj === undefined || obj.length === 0)
            return;

         var i, l, key;
         if (obj instanceof Array) {
            if (obj.forEach) {
               //В Firefox-е именно здесь глючит цикл обхода - пропускает некоторые итерации
               //Заменяю forEach на родной массивский - он работает нормально
               obj.forEach(iterateCallback, context);
            } else {
               l = obj.length;
               for (i = 0; i < l; i++) {
                  if (i in obj) {
                     iterateCallback.call(context, obj[i], i, obj);
                  }
               }
            }
         } else if ('length' in obj && (obj.length - 1) in obj) {
            /**
             * Это место переписано так не случайно.
             * При необъяснимых обстоятельствах на iOS 8.1 старая проверка
             * (obj.length === +obj.length) для obj === { 0: ??? }
             * давала положительный результат (obj.length в момент проверки был === 1)
             * Но следующая строка при чтении obj.length уже давала как и положено `undefined`
             * Как показали опыты, переписанная нижеследующим образом проверка не багает
             */
            l = parseInt(obj.length, 10);
            for (i = 0; i < l; i++) {
               if (i in obj) {
                  iterateCallback.call(context, obj[i], i, obj);
               }
            }
         } else {
            for (key in obj) {
               if (obj.hasOwnProperty(key)) {
                  iterateCallback.call(context, obj[key], key, obj);
               }
            }
         }
      },
      map: function (obj, iterateCallback, context) {
         var results = [];
         if (obj === null || obj === undefined)
            return results;
         //todo: обработать jqueryObj
         collectionHelpers.forEach(obj, function (value, index, list) {
            results[results.length] = iterateCallback.call(context, value, index, list);
         }, context);
         if ('length' in obj && (obj.length - 1) in obj) {//если на входе массив - подгоним длину
            /**
             * В ios8 есть баг объект с числовыми ключами может содержать length
             * https://bugs.webkit.org/show_bug.cgi?id=142792
             */
            results.length = obj.length;
         }
         return results;
      },

      filter: function (obj, iterateCallback, context) {
         var results = [];
         if (obj === null || obj === undefined)
            return results;

         //todo: обработать jqueryObj
         collectionHelpers.forEach(obj, function (value, index, list) {
            if (iterateCallback) {
               if (iterateCallback.call(context, value, index, list))
                  results[results.length] = value;
            } else if (!!value) {
               results[results.length] = value;
            }
         }, context);

         return results;
      },
      /**
       *
       * @param obj
       * @param iterateCallback
       * @param context
       * @returns {{}}
       */
      filterObj: function (obj, iterateCallback, context) {
         var results = {};
         if (obj === null || obj === undefined)
            return results;
         //todo: обработать jqueryObj
         collectionHelpers.forEach(obj, function (value, index, list) {
            if (iterateCallback) {
               if (iterateCallback.call(context, value, index, list))
                  results[index] = value;
            } else if (value)
               results[index] = value;
         }, context);

         return results;
      },

      reduce: function (obj, iterator, memoInitial, context) {
         var initial = arguments.length > 2, memo = memoInitial;

         if (obj === null || obj === undefined)
            obj = [];
         //todo: обработать jqueryObj
         collectionHelpers.forEach(obj, function (value, index, list) {
            if (!initial) {
               memo = value;
               initial = true;
            } else {
               memo = iterator.call(context, memo, value, index, list);
            }
         });

         if (!initial)
            throw new TypeError('Reduce of empty array with no initial value');

         return memo;
      },

      //Используется SBIS3.CORE.FieldLink, Deprecated/Controls/FilterButton/FilterButton
      isEqualValues: function (first, second) {
         if (first instanceof Array && second instanceof Array && first.length === second.length) {
            for (var i = 0, len = first.length; i < len; i++) {
               if (first[i] !== second[i]) {
                  return false;
               }
            }
            return true;
         }
         return first === second;
      },

      objectsDiff: objectsDiff,
      /**
       * Возвращает количество свойств в объекте.
       * @param {Object} obj Объект, у которого хотим узнать кол-во свойств.
       * @returns {Number} Количество свойств объекта.
       * @see forEach
       * @see map
       * @see uniqueArray
       * @see filter
       * @see find
       * @see findIdx
       * @see reduce
       * @see isEqualObject
       * @see pick
       */
      countOfProperties: function (obj) {
         var count = 0;
         if (typeof(obj) != "object" || obj == null) {
            return 0;
         }
         for (var prop in obj) {
            count++;
         }
         return count;
      },

      /**
       * Выбирает из объекта указанные свойства, возвращает объект с выбранными свойствами.
       * @param {Object} obj Объект, из которого выбираются свойства.
       * @param {string[]} propNames Свойства, которые нужно выбрать - массив имён.
       * @return {Object} Объект, содержащий указанные свойства. Если какого-то свойства нет в объекте obj, то его не будет и в результате.
       * @see forEach
       * @see map
       * @see uniqueArray
       * @see filter
       * @see find
       * @see findIdx
       * @see reduce
       * @see isEqualObject
       * @see countOfProperties
       */
      pick: function(obj, propNames) {
         return collectionHelpers.reduce(propNames, function(res, propName) {
            //прототипные свойства тоже берём
            if (propName in obj) {
               res[propName] = obj[propName];
            }
            return res;
         }, {});
      },
      isPlainObject: isPlainObject,
      isPlainArray: isPlainArray
   };

   return collectionHelpers;
});