define('Deprecated/helpers/dom&controls-helpers', [
   'Core/constants',
   'Core/core-functions',
   'Core/Deferred',
   'Core/compatibility',
   'Core/detection',
   'Core/helpers/generate-helpers',
   'Core/EventBus',
   'Core/core-instance',
   'Core/ControlBatchUpdater',
   'Core/IoC',
   'Deprecated/helpers/Hcontrol/contains',
   'Deprecated/helpers/Hcontrol/parseMargins',
   'Deprecated/helpers/Hcontrol/getNonControlSize',
   'Deprecated/helpers/Hcontrol/getTextWidth'
], function(constants, cFunc, Deferred, compatibility, detection, genHelpers, EventBus, coreIns, ControlBatchUpdater, IoC, contains, parseMargins, getNonControlSize, getTextWidth){

   /**
    * @class Deprecated/helpers/dom&controls-helpers
    * @public
    * @deprecated
    */
   var domHelpers = /** @lends Deprecated/helpers/dom&controls-helpers.prototype */{
      /**
       * Возвращает массив компонентов, найденных в указанном контейнере
       * @param container
       * @returns {Array} Массив компонентов
       */
      findControlsInContainer: function(container) {
         var controls = [];
         $('[data-component]', container).each(function (idx, item) {
            var inst = item.wsControl;
            if (inst) {
               controls.push(inst);
            }
         });
         return controls;
      },
      /**
       * Очищает оптимизированным сособом содержимое переданного jQuery-элемента
       * @param container jQuery-элемент
       */
      clearContainer: function(container) {
         container.get(0).innerHTML = '';
      },
      /**
       *
       * @param value
       * @returns {*|boolean}
       */
      detectCommonDataContainer: function (value) {
         return value && value.s && value.d && (value._type == 'record' || value._type == 'recordset');
      },
      /**
       * Возвращает имя тэга элемента DOM дерева в нижнем регистре. Фунция совместима с IE8+.
       * @param {Object} elem - элемент DOM дерева.
       * @returns {String} Имя тега.
       */
      getTagName: function (elem) {
         return elem.localName || (elem.nodeName && elem.nodeName.toLowerCase());
         // Bugfix. IE8 DOM localName is undefined, checking nodeName instead.
      },
      /**
       * Возвращает на сколько пикселей сдвинули страницу вниз/влево.
       * @returns {{left: (Number), top: (Number)}}
       */
      getScrollOffset: function () {
         return {
            left: window.pageXOffset || document.documentElement.scrollLeft || document.body.scrollLeft,
            top: window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop
         };
      },
      /**
       * Получить авто-размер для неконтрола
       * @param {Object} collection jQuery-набор элементов - неконтролов.
       * @param {String} type Height|Width - тип размера.
       * @returns {Number} значение.
       */
      getNonControlSize: getNonControlSize,

      /**
       * Вставляет кусок css на страницу
       * @param {String} style CSS-текст, который нужно вставить.
       * @param {Boolean} [waitApply=false] Нужно ли ожидание применения css. Если задано true, то возвращает Deferred, сигнализирующий готовность css (применённость к документу).
       * @param {String} [hint] "Подсказка". Присутствует в сообщении об ошибке если стили не удалось применить.
       * @returns {Deferred|null} Если waitApply = true, то возвращает Deferred, сигнализирующий готовность css (применённость к документу), иначе null.
       */
      insertCss: function (style, waitApply, hint) {
         /**
          * Возвращает тэг для вставки css
          * @return {*}
          */
         function getCurStyleHolder() {
            var tag;
            if ("getElementsByClassName" in document) {
               tag = document.getElementsByClassName("ws-style-holder-current")[0];
            }
            else {
               var styles = document.getElementsByTagName("style");
               for (var i = 0, l = styles.length; i < l; i++) {
                  if (hasClass(styles[i], "ws-style-holder-current")) {
                     tag = styles[i];
                     break;
                  }
               }
            }
            tag = tag || createStyleHolder();
            return tag;
         }

         /**
          * Создает новый тэг style
          * @return {HTMLElement}
          */
         function createStyleHolder() {
            var sHolder = document.createElement('style');
            var head = document.getElementsByTagName('head')[0];

            sHolder.setAttribute('type', 'text/css');
            sHolder.setAttribute('media', 'all');
            sHolder.className = 'ws-style-holder ws-style-holder-current';
            head.appendChild(sHolder);

            return sHolder;
         }

         /**
          * Проверяет есть ли у элемента указанные классы
          * @param {HTMLElement} element.
          * @param {String} cls классы через пробел.
          * @return {Boolean}
          */
         function hasClass(element, cls) {
            var
               className = ' ' + element.className + ' ',
               m = cls.split(" ");
            for (var i = 0, l = m.length; i < l; i++) {
               if (className.indexOf(' ' + m[i] + ' ') == -1) {
                  return false;
               }
            }
            return true;
         }

         /**
          * Функция проверки применения стилей
          * @returns {boolean}
          */
         function checkMarkerDiv() {
            var pos = markerDiv.css('position'),
               ok = (pos === 'absolute'),
               timeout = +new Date() - start > constants.styleLoadTimeout,
               notifierDiv = $('#onlineChecker');

            if (ok || timeout) {
               markerDiv.remove();
               if (waitInterval) {
                  clearInterval(waitInterval);
                  if(timeout) {
                     notifierDiv.text(rk("Страница загружается слишком долго. Попробуйте перезагрузить страницу"));
                     notifierDiv.css('display', '');
                     notifierDiv.css('zIndex', 9999);
                     result.callback();
                  } else {
                     result.callback();
                  }
               }
            }
            return ok;
         }

         var
            markerCss = '',
            result = null,
            markerDivId, markerDiv, waitInterval, start, styleHolder;

         if (waitApply) {
            markerDivId = genHelpers.randomId('cssReady-');

            markerDiv = $('<div id="' + markerDivId + '" style="display: none;" />').appendTo($('body'));
            markerCss = '#' + markerDivId + ' { position: absolute; }';
         }

         if (compatibility.standartStylesheetProperty) {
            styleHolder = createStyleHolder();
            styleHolder.appendChild(document.createTextNode(style + markerCss));
         }
         else {
            styleHolder = getCurStyleHolder();
            style = style + markerCss;
            var
               cssText = styleHolder.styleSheet.cssText,
               curRulesCnt = (cssText.match(/\{|,/g) || []).length,
               insRulesCnt = (style.match(/\{|,/g) || []).length;

            if (curRulesCnt + insRulesCnt > 4000) {
               styleHolder.className = 'ws-style-holder';
               styleHolder = createStyleHolder();
            }

            try {
               styleHolder.styleSheet.cssText += style;
            } catch (e) {
               IoC.resolve('ILogger').error('insertCss', 'Failed to insert styles to document! IE8/9 Stylesheet limit exceeded (31 per document)?');
               throw e;
            }
         }

         if (waitApply) {
            start = +new Date();
            if (!checkMarkerDiv()) {
               result = new Deferred();
               result.addErrback(function (e) {
                  return e;
               });
               waitInterval = setInterval(checkMarkerDiv, 1);
            }
         }

         return result;
      },

      contains: contains,

      /**
       * Возвращает выделенный на странице текст
       * @return {String}
       */
      getTextSelection: function () {
         var txt;

         if (window.getSelection)
            txt = window.getSelection().toString();
         else if (document.getSelection)
            txt = document.getSelection().toString();
         else if (document.selection)  // IE 6/7
            txt = document.selection.createRange().text;

         return txt;
      },
      /**
       * Очистка выделения на странице
       * Если передали currentContainer, и window.getSelection().getRangeAt(0).startContainer находится в нём,
       * то будет произведено selection.collapseToStart(). Иначе будет произведено selection.removeRange(), иначе
       * collapse может приводить к получению фокуса теряющим активность контролом.
       * @param {HTMLElement|jQuery} [currentContainer] Контейнер в котором должен сохраняться фокус.
       */
      clearSelection: function (currentContainer) {
         if (window.getSelection) {
            var
               elem,
               selection = window.getSelection(),
               collapsed = selection.isCollapsed || false;

            try {
               elem = selection.getRangeAt(0).startContainer;

               // Если выделение находится в активном контейнере, то просто сколлапсим его вместо очищения
               if (domHelpers.contains(currentContainer, elem)) {
                  selection.collapseToStart();
                  collapsed = true;
               }
            } catch (w) {
            }

            if (collapsed) {
               return;
            }

            // Если выделение не сколлапсили в начало, то просто очистим его
            try { //If node is invisible "INVALID_STATE_ERR: DOM Exception 11", mb there's other cases
               if (selection && selection.removeRange) {
                  selection.removeRange();
               } else if (selection && selection.empty) {
                  selection.empty(); // ie
               }
            } catch (e) {
            }
         }
         else if (document.selection && document.selection.empty) {
            try {
               document.selection.empty();
            }
            catch (e) {
            }
         }
      },

      /**
       * Приводит innerHTML, отдаваемый ie8 к стандарту
       * @param html
       * @returns {XML|string|void}
       */
      ieFixInnerHTML: function (html) {
         var
            tRegExp = /<(?:[A-Z][A-Z0-9]*)\b[^>]*>/gi,
            aRegExp = /\s+\S+=[^'"\s>]+/g;

         return html.replace(tRegExp, function (tag) {
            return tag.replace(aRegExp, function (attr) {
               var a = attr.split('=');
               a[1] = '"' + a[1] + '"';
               return a.join('=');
            });
         });
      },

      getTextWidth: getTextWidth,

      parseMargins: parseMargins,
      /**
       *
       * @param templateName
       */
      addXmlLog: function (templateName) {
         var tplListElem = $('#xmlContent');
         if (!tplListElem.length) {
            tplListElem = $('<div id="xmlContent" style="display:none; visibility: hidden;"></div>');
            $('body').append(tplListElem);
         }
         if (!tplListElem.data(templateName)) {
            tplListElem.data(templateName, true);
            tplListElem.append('<div name="' + templateName + '">')
         }
      }
   };

   return domHelpers;
});