define('Deprecated/helpers/functional-helpers', [], function(){

    /**
     * @class Deprecated/helpers/functional-helpers
     * @public
     * @deprecated
     */
   return /** @lends Deprecated/helpers/functional-helpers.prototype */{
      /**
       * Сравнивает 2 значения с учетом наличия метода equals в первом.
       * @param a
       * @param b
       * @returns {*}
       */
      //Используют SBIS3.CORE.FieldAbstract, Deprecated/Controls/FieldText/FieldText
      compareValues: function (a, b) {
         var comparisonResult;
         if (a && a.equals) {
            comparisonResult = a.equals(b);
         } else {
            comparisonResult = (a == b);
         }
         return comparisonResult;
      },

      /**
       * Делает функцию, вызывающую заданный метод у объекта, который будет передан ей в качестве аргумента.
       * @remark
       * Удобно для передачи метода объекта в качестве функции-итератора в forEach и ему подобные.
       * @param {String} methodName Имя метода.
       * @param {Array} args Аргументы метода.
       * @returns {Function}
       * @example
       * <pre>
       *     [control1, control2, control3].forEach( helpers.methodCaller('destroy'));//вызовет destroy у всех контролов
       *     [window1, floatArea1].forEach(helpers.methodCaller('hide'));//закроет окно и плав. панель
       * </pre>
       * @see constant
       * @see nop
       * @see memoize
       * @see forAliveOnly
       */
      methodCaller: function (methodName, args) {
         return function (obj) {
            if (obj) {
               return args ? obj[methodName].apply(obj, args) : obj[methodName]();
            } else {
               return undefined;
            }
         }
      },

      /**
       * Делает функцию, возвращающую заданное значение-константу. Может пригодиться для создания примитивных обработчиков, возвращающих одно и то же значение.
       * @param {*} res Значение.
       * @return {Function}
       * @example
       * <pre>
       *     var dfr = new Deferred();
       *     ... //отдаём dfr кому-то, кто в него что-то стреляет...
       *     dfr.addBoth(helpers.constant(100500)); //dfr будет всегда возвращать 100500, что бы с ним не делали раньше (была в нём ошибка или нет)...
       *     //или:
       *     dfr.addErrback(helpers.constant(new Error('Unknown error'))); //dfr в случае ошибки будет всегда возвращать 'Unknown error'
       * </pre>
       * @see methodCaller
       * @see nop
       * @see memoize
       * @see forAliveOnly
       */
      constant: function (res) {
         return function () {
            return res;
         };
      },
      /**
       * Функция, которая ничего не делает. Бывает нужна в качестве коллбека-заглушки, чтобы не проверять коллбеки на null.
       * @see methodCaller
       * @see constant
       * @see memoize
       * @see forAliveOnly
       */
      nop: function () {
      }
   }
});