define('Deprecated/helpers/string-helpers', [
   'Core/helpers/string-helpers-min',
   'Deprecated/helpers/String/parseComplexKey',
   'Core/helpers/String/escapeTagsFromStr',
   'Core/helpers/String/escapeUnicode',
   'Core/helpers/String/unEscapeASCII',
   'Core/helpers/String/escapeASCII'
], function(
   strHelpersMin,
   parseComplexKey,
   escapeTagsFromStr,
   escapeUnicode,
   unEscapeASCII,
   escapeASCII
) {
   var
   //Проблема: &nbsp; не должен быть частью ссылки, &nbsp; в строке может быть записан как &nbsp; и как &amp;nbsp; необходимо учитывать оба варианта
      urlRegExpString = '(https?|ftp|file):\/\/[-A-Za-zА-ЯЁа-яё0-9.]+(?::[0-9]+)?(\/([-A-Za-zА-ЯЁа-яё0-9+&@#$/%№=~_{|}!?:,.;()\'\[\\\]](?!&nbsp;|amp;nbsp;))*)*',
      excludeLinkString = '<[\\s]*a[\\s\\S]*?>[\\s\\S]*?<\/a>|',

      /**
       * @class Deprecated/helpers/string-helpers
       * @public
       * @deprecated
       */
      strHelpers = /** @lends Deprecated/helpers/string-helpers.prototype */ {
      /**
       *
       */
      urlRegExpString: urlRegExpString,
      /**
       *
       */
      excludeLinkString: excludeLinkString,
      /**
       * Удаляет все пробелы из строки.
       * @param {String} str Строка для преобразования.
       * @returns {*}
       * @see unEscapeHtml
       * @see escapeHtml
       * @see htmlToText
       * @see escapeASCII
       * @see unEscapeASCII
       * @see unEscapeHtmlSpecialChars
       */
      removeWhiteSpaces: function(str){
         return typeof(str) === "string" ? str.replace(/\s/g, "") : undefined;
      },
      /**
      * Удаляет указанные тэги из строки.
      * @param {String} str Строка для преобразования.
      * @param {Array|String} tags Массив тэгов, которые необходимо убрать из строки.
      */
         //SBIS3.CORE.FieldLabel, SBIS3.CORE.FieldLink, SBIS3.CORE.FilterButton, SBIS3.CORE.RequestHistoryPlugin, SBIS3.CORE.HierarchyViewAbstract,
         // SBIS3.CORE.Infobox, SBIS3.CORE.LoadingIndicator, SBIS3.CORE.Menu, SBIS3.CORE.NavigationPanel, SBIS3.CORE.SimpleDialogAbstract, SBIS3.CORE.TabButtons, SBIS3.CORE.TableView, Deprecated/Controls/TableView/plugins/AtPlaceEdit-plugin
      escapeTagsFromStr: escapeTagsFromStr,
      /**
       * Удаляет все теги из строки, заменяя теги "<br>" на переводы строки ("\n").
       * @param {String} html Строка для преобразования.
       * @return {String} Cтрока без тегов.
       * @see unEscapeHtml
       * @see escapeHtml
       * @see removeWhiteSpaces
       * @see escapeASCII
       * @see unEscapeASCII
       * @see unEscapeHtmlSpecialChars
       */
      htmlToText: function (html) {
         var result = html.replace(/<br>/g, '\n');
         return strHelpers.escapeTagsFromStr(result, '\\w+');
      },

      escapeASCII: escapeASCII,

      unEscapeASCII: unEscapeASCII,
      /**
       * Преобразовывает HTML-сущности в символы.
       * @param {String} str Строка для преобразования.
       * @return {String} Преобразованная строка.
       * @see unEscapeHtml
       * @see escapeHtml
       * @see htmlToText
       * @see removeWhiteSpaces
       * @see escapeASCII
       * @see unEscapeASCII
       */
      unEscapeHtmlSpecialChars: function (str) {
         if (typeof str == "string") {
            var
               chars = {
                  '&minus;': '-',
                  '&nbsp;': ' ',
                  '&#92;': '\\'
               },
               chr;
            for (chr in chars) {
               str = str.replace(new RegExp(chr, 'g'), chars[chr]);
            }
         }
         return str;
      },
      /**
       *
       */
      serializeURLData: strHelpersMin.serializeURLData,
      /**
       *
       */
      deserializeURLData: strHelpersMin.deserializeURLData,

      /**
       *
       */
      parseComplexKey: parseComplexKey,

      /**
       * Преобразует строку к валидному формату для XSLT трансформации.
       */
      removeInvalidXMLChars: function (valueStr) {
         if (typeof valueStr == "string") {
            valueStr = valueStr.replace(/[^\x09\x0A\x0D\x20-\uD7FF\uE000-\uFFFD\u10000-\u10FFFF]*/g, "");
         }
         return valueStr;
      },
      /**
       * Заменяет/убирает Юникод-символы на аналогичные коды из win1251.
       * @remark
       * Актуально до тех пор, пока БД в кодировке win1251.
       */
      escapeUnicode: escapeUnicode
   };

   return strHelpers;
});