(function() {

    "use strict";

    var global = (function() {
            return this || (0, eval)('this');
        }()),
        define = global.define || (global.requirejs && global.requirejs.define) || (requirejsVars && requirejsVars.define);
   function getCookie(name) {
      var matches = document.cookie.match(new RegExp(
         "(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
      ));
      return matches ? decodeURIComponent(matches[1]) : undefined;
   }
    function itIsControl(name) {
        return name.indexOf('SBIS3.CONTROLS/') === 0 || name.indexOf('Controls/') === 0;
    };
    /**
     @author Кочнев Н.С.
     @workaround Временное решение. Нужно, для того чтобы никто кроме онлайна не смог загрузить css'ки контролов
     TODO: Выпилить, когда научимся компилить контролы под разные темы и определять пренадлежность теме конкретного сервиса
     */
    function resolveSuffix(name) {
        var config = window.wsConfig;
        var themeNameFromCookies = getCookie('thmname');
        var themeNames;

        if (!config) {
            return '';
        }
        if (itIsControl(name)) {

            if (config.themeName) {
                    return '__' + config.themeName;
            } else {
                if (themeNameFromCookies) {
                    return '__' + themeNameFromCookies;
                } else {
                    return '';
                }
            }
        }
        else {
            return '';
        }
    };

    define('css', ['native-css', 'Core/pathResolver', 'Core/detection'], function(cssAPI, pathResolver) {
        return {
            load: function(name, require, load, conf) {
                if (conf.testing || require.isBrowser === false) {
                    load(true);
                } else {

                    var path = pathResolver(name, 'css');
                    var suffix = resolveSuffix(name);

                    if (suffix) {
                       load(null);
                       return;
                    }

                    if (path.substr(path.length - 4, 4) == '.css') {
                        path = path.substr(0, path.length - 4);
                    }
                    path = path + suffix;
                    cssAPI.load(path, require, load, conf);
                }
            }
        };
    });

})();
