define('js', [
   'text',
   'Core/pathResolver',
   'Core/constants',
   'Core/IoC',
   'Core/polyfill'
], function(
   text,
   pathResolver,
   constants,
   IoC
) {
   'use strict';

   var global = (function(){ return this || (0,eval)('this'); }()),
      nodeRequire = require,
      isRemote = /http[s]?:\/\//;

   return {
      load: function(name, require, onLoad, conf) {
         var paths,
            moduleName = String(name).split('/')[0],
            jsModules = constants.jsModules || {},
            jsCoreModules = constants.jsCoreModules || {};

         try {
            paths = [pathResolver(name, 'js')];
         } catch (e) {
            return onLoad.error(e);
         }

         if (constants.isNodePlatform && isRemote.test(paths[0])) {
            var onLoadJS = function (text) {
               onLoad.fromTextFixed ? onLoad.fromTextFixed(text) : onLoad.fromText(text);
            };

            onLoadJS.error = function (e) {
               onLoad.error(e);
            };
            text.load(paths[0], require, onLoadJS, conf);
         } else {
            if (constants.isNodePlatform && paths[0] !== name && global.isMochaRunned) {
               //Предварительно подключаем файл, используя нодовский require
               nodeRequire(paths[0]);
            }
            if (name.indexOf('SBIS3') === 0) {
               paths.push('i18n!' + name);
            }
            require(paths, function(ctor) {
               onLoad(ctor);
            }, function(err) {
               onLoad.error(err);
            });
         }
      }
   };
});
