(function() {
   'use strict';

   var global = (function(){ return this || (0,eval)('this'); }()),
       define = global.define || (global.requirejs && global.requirejs.define) || (requirejsVars && requirejsVars.define);

   define('optional', ['Core/constants'], function(constants) {
      return {
         load: function (name, require, onLoad) {
            //Skip if module name isn't available in constants.modules
            if (
               constants &&
               constants.modules &&
               Object.keys(constants.modules).length > 0
            ) {
               var moduleName = name.split('/')[0],
                  plugins = moduleName.split(/[!?]/);
               moduleName = plugins.pop();
               if (
                  moduleName !== 'WS' &&
                  moduleName !== 'Core' &&
                  moduleName !== 'Lib' &&
                  moduleName !== 'Ext' &&
                  moduleName !== 'Deprecated' &&
                  moduleName !== 'Helpers' &&
                  moduleName !== 'Transport' &&
                  moduleName !== 'Resources' &&
                  plugins.indexOf('js') === -1 &&
                  plugins.indexOf('css') === -1 &&
                  plugins.indexOf('tmpl') === -1 &&
                  plugins.indexOf('xhtml') === -1 &&
                  plugins.indexOf('remote') === -1
               ) {
                  if (constants.requirejsPaths && !(moduleName in constants.requirejsPaths)) {
                     onLoad(null);
                     return;
                  }
               }
            }

            require([name], onLoad, function() {
               onLoad(null);
            });
         }
      }
   });
})();
