(function(){

   'use strict';

   var global = (function(){ return this || (0,eval)('this'); }()),
      define = global.define || (global.requirejs && global.requirejs.define) || requirejsVars.define;
   /**
    * Поддерживаемые форматы запроса
    * - tmpl!SBIS3.CORE.HTMLChunk - подключит шаблон
    */
   define('tmpl', ['text',
      'View/config',
      'Core/pathResolver',
      'View/Runner'
   ], function(text, config, pathResolver, runner) {
      var tclosure = runner.Run;
      function resolverControls(path) {
         return 'tmpl!' + path;
      }
      function setToJsonForFunction(func, moduleName, path) {
         func.toJSON = function() {
            var serialized = {
               $serialized$: 'func',
               module: moduleName
            };
            if (path) {
               serialized.path = path;
            }
            return serialized;
         }
      }
      return {
         load: function (name, require, load) {
            try {
               var path = pathResolver(name, 'tmpl'),
                  conf = { config: config, filename: path },
                  onLoad = function (html) {
                     if (html && html.indexOf('define') == 0) {
                        load.fromTextFixed ? load.fromTextFixed(html) : load.fromText(html);
                     } else {
                        //Если у нас не скомпилена tmpl, например /debug/

                        try {
                           require(['View/Builder', 'Lib/Control/Control.compatible',
                              'is!compatibleLayer?Lib/Control/AreaAbstract/AreaAbstract.compatible'], function(builder) {
                              var tmpl = builder.Tmpl;
                              tmpl.template(html, resolverControls, conf).handle(function (traversed) {
                                 var templateFunction = tmpl.func(traversed, conf);
                                 Object.keys(templateFunction.includedFunctions).forEach(function(elem) {
                                    setToJsonForFunction(templateFunction.includedFunctions[elem], 'tmpl!' + name, 'includedFunctions.' + elem);
                                 });
                                 // Чтобы отличать функции старого шаблонизатора от нового
                                 templateFunction.stable = true;
                                 var closured = function () {
                                    return templateFunction.apply(this, tmpl.addArgument(tclosure, arguments));
                                 };
                                 closured.stable = true;
                                 closured.includedFunctions = templateFunction.includedFunctions;
                                 setToJsonForFunction(closured, 'tmpl!' + name);
                                 load(closured);
                              }, function (error) {
                                 var errms = 'Error while creating template ' + name + '\n' + error.message + '\n' + error.stack;
                                 console.log(errms);
                                 error.message = errms
                              });
                           });
                        } catch (e) {
                           e.message = 'Error while creating template ' + name + '\n' + e.message + '\n' + e.stack;
                           load.error(e);
                        }
                     }
                  };
               onLoad.error = function (e) {
                  e.message = 'Error while loading template ' + name + '\n' + e.message + '\n' + e.stack;
                  load.error(e);
               };
               text.load(path, require, onLoad, conf);
            } catch(e) {
               e.message = 'Error while resolving template ' + name + '\n' + e.message + '\n' + e.stack;
               load.error(e);
            }
         }
      }
   });
})();
