/**
 * Модуль 'Компонент кнопка загрузки файла с камеры'.
 * @description
 */
define('Lib/Control/FileCam/FileCam', [
   "Core/core-extend",
   "Core/core-merge",
   "Lib/Control/FileButton/FileButton",
   "Lib/Control/FileCamLoader/FileCamLoader",
   "Core/IoC"
], function(cExtend, cMerge, FileButton, FileCamLoader, IoC) {

   'use strict';

    IoC.resolve('ILogger').log('Lib/Control/FileCam/FileCam', 'Module is deprecated and will be removed, use "Lib/File/Attach/SbisAttach"');

   /**
    * <b>Внимание</b>: Использование класса FileCam признано устаревшим.
    * Для загрузки файлов используйте класс {@link Lib/File/Attach/SbisAttach},
    * для получения фото с камеры используйте класс {@link Lib/File/ResourceGetter/PhotoCam}
    *
    * @deprecated
    * @class Lib/Control/FileCam/FileCam
    * @extends Lib/Control/FileButton/FileButton
    * @author Крайнов Д.О.
    * @control
    * @public
    * @category Button
    * @initial
    * <component data-component='Lib/Control/FileCam/FileCam'>
    *    <option name='caption'>FileCam</option>
    * </component>
    */
   var FileCam = FileButton.extend(/** @lends Lib/Control/FileCam/FileCam.prototype */{

      _createButton: function(options, mixin) {
         var loader = mixin ? cExtend.mixin(FileCamLoader, mixin) : FileCamLoader;
         return new loader(cMerge(options, {
            name: this._options.name ? this._options.name + '-FileCamLoader' : '',
            opener: this
         }));
      },

      /**
       *
       * Получить изображение с камеры и загрузить его
       * Работаем через плагин
       */
      getImage: function() {
         return this.activate();
      },

      _activate: function() {
         return this._fileButton.getImage();
      }
   });

   return FileCam;

});