/**
 * Модуль 'Компонент кнопка загрузки скриншота'.
 * Умеет загружать скриншот из буфера обмена на сервер
 * Использует модуль загрузки и выбора файлов FileLoader
 * @description
 */
define('Lib/Control/FileClipboard/FileClipboard', [
   "Core/core-extend",
   "Core/core-merge",
   "Lib/Control/FileButton/FileButton",
   "Lib/Control/FileClipboardLoader/FileClipboardLoader",
   "Core/IoC"
], function(cExtend, cMerge, FileButton, FileClipboardLoader, IoC) {

   'use strict';

    IoC.resolve('ILogger').log('Lib/Control/FileClipboard/FileClipboard', 'Module is deprecated and will be removed, use "Lib/File/Attach/SbisAttach"');

   /**
    * <b>Внимание</b>: Использование класса FileClipboard признано устаревшим.
    * Для загрузки файлов используйте класс {@link Lib/File/Attach/SbisAttach},
    * для получения файлов из буфера обмена используйте класс {@link SBIS3.Plugin/components/Extensions/Integration/FileGetter/ClipboardGetter}
    *
    * @deprecated
    * @class Lib/Control/FileClipboard/FileClipboard
    * @extends Lib/Control/FileButton/FileButton
    * @author Крайнов Д.О.
    * @control
    * @public
    * @category Button
    * @initial
    * <component data-component='Lib/Control/FileClipboard/FileClipboard'>
    *    <option name='caption'>FileClipboard</option>
    * </component>
    */
   var FileClipboard = FileButton.extend(/** @lends Lib/Control/FileClipboard/FileClipboard.prototype */{

      _createButton: function(options, mixin) {
         var loader = mixin ? cExtend.mixin(FileClipboardLoader, mixin) : FileClipboardLoader;
         return new loader(cMerge(options, {
            name: this._options.name ? this._options.name + '-FileClipboardLoader' : ''
         }));
      },

      /**
       *
       * Вызывает выбор файла из кода
       * Поскольку клик происходит в коде, в IE8 и в Chrome не работатет.
       * В этом случае работаем через плагин
       */
      getScreenshot: function() {
         return this.activate();
      },

      _activate: function() {
         this._fileButton.getScreenshot();
      }
   });

   return FileClipboard;

});