/**
 * Модуль 'Компонент загрузки скриншота'.
 * Умеет загружать скриншот из буфера обмена на сервер
 * Используется плагин.
 *
 * @description
 */
define('Lib/Control/FileClipboardLoader/FileClipboardLoader', [
   "Deprecated/helpers/fast-control-helpers",
   "Core/CommandDispatcher",
   "Lib/Control/FileLoaderAbstract/FileLoaderAbstract",
   "Core/IoC",
   "i18n!Lib/Control/FileClipboardLoader/FileClipboardLoader"
], function(dFCHelpers, CommandDispatcher, FileLoaderAbstract, IoC) {

   'use strict';

    IoC.resolve('ILogger').log('Lib/Control/FileClipboardLoader/FileClipboardLoader', 'Module is deprecated and will be removed, use "Lib/File/Attach/SbisAttach"');

   /**
    * <b>Внимание</b>: Использование класса FileClipboardLoader признано устаревшим, используйте класс {@link Lib/File/Attach/SbisAttach}
    *
    * @class Lib/Control/FileClipboardLoader/FileClipboardLoader
    * @extends Lib/Control/FileLoaderAbstract/FileLoaderAbstract
    * @author Крайнов Д.О.
    * @category Loaders
    * @control
    * @public
    * @nonVisual
    * @deprecated
    */
   var FileClipboardLoader = FileLoaderAbstract.extend(/** @lends Lib/Control/FileClipboardLoader/FileClipboardLoader.prototype */{
      /**
       * Инициализирует инпут выбора файла
       */
      $constructor: function() {
         this._container = $(); // контейнер не нужен!
         CommandDispatcher.declareCommand(this, 'load', this.getScreenshot);
      },

      /**
       *
       * Вызывает выбор файла из кода
       * Поскольку клик происходит в коде, в IE8 и в Chrome не работатет.
       * В этом случае работаем через плагин
       */
      getScreenshot: function() {
         var self = this;
         this._getPlugins('Clipboard', '1.0.1.0').addCallbacks(function(plugin) {
            if (!self._isDestroyed) {
               self._notify('onAppletReady', self._randomId, plugin);
               plugin.call('getImageAsPNGFile', {}).addCallbacks(function(result) {
                  if (!result) {
                     dFCHelpers.alert(rk('В буфере обмена нет скриншота'), {}, self);
                  }
                  self._post(result, true);
               }, function(error) {
                  self._logError(error, 'FileClipboardLoader');
               });
            }
         }, function(error) {
            self._notify('onAppletReady', self._randomId, null, error);
         });
      }
   });

   return FileClipboardLoader;

});