/**
 * Модуль 'Компонент кнопка сканирования'.
 * Умеет сканировать документы
 * @description
 */
define('Lib/Control/FileScaner/FileScaner', [
   "Core/core-extend",
   "Core/core-merge",
   "Lib/Control/FileButton/FileButton",
   "Lib/Control/FileScanLoader/FileScanLoader",
   "Core/IoC"
], function(cExtend, cMerge, Button, FileScanLoader, IoC) {

   'use strict';

    IoC.resolve('ILogger').log('Lib/Control/FileScaner/FileScaner', 'Module is deprecated and will be removed, use "Lib/File/Attach/SbisAttach"');

   /**
    * <b>Внимание</b>: Использование класса FileCam признано устаревшим.
    * Для загрузки файлов используйте класс {@link Lib/File/Attach/SbisAttach},
    * для получения сканов используйте класс {@link SBIS3.Plugin/components/Extensions/Integration/FileGetter/ScannerGetter}
    *
    * @deprecated
    * @class Lib/Control/FileScaner/FileScaner
    * @extends Lib/Control/FileButton/FileButton
    * @author Крайнов Д.О.
    * @control
    * @public
    * @category Button
    * @initial
    * <component data-component='Lib/Control/FileScaner/FileScaner'>
    *    <option name='caption'>FileScaner</option>
    * </component>
    */
   var FileScaner = Button.extend(/** @lends Lib/Control/FileScaner/FileScaner.prototype */{
       /**
        * @cfg {Boolean} Сжимать несколько файлов в один zip архив
        * @name Lib/Control/FileScaner/FileScaner#createZip
        *
        * Возможные значения:
        * <ul>
        *    <li>true - несколько отсканированных файлов будут помещены в zip-архив и загружен будет уже архив;</li>
        *    <li>false - несколько отсканированных файлов будут загружены по отдельности.</li>
        * </ul>
        */

      _createButton: function(options, mixin) {
         var loader = mixin ? cExtend.mixin(FileScanLoader, mixin) : FileScanLoader;
         return new loader(cMerge(options, {
            name: this._options.name ? this._options.name + '-FileScanLoader' : ''
         }));
      },

      /**
       *
       * Вызывает сканирование
       * Работаем через плагин
       */
      scan: function() {
         return this.activate();
      },

      _activate: function() {
         return this._fileButton.scan();
      }
   });

   return FileScaner;

});