define('Lib/Control/InfoboxContent/InfoboxContent',
   [
      'require',
      'Lib/Control/CompoundControl/CompoundControl',
      'tmpl!Lib/Control/InfoboxContent/InfoboxContent',
      'Core/Sanitize',
      'Core/js-template-doT' //Приходится пока что реквайрить dot, потому что очень многие задают шаблоны строками
   ],
   function(
      require,
      CompoundControl,
      dotTplFn,
      Sanitize
   ) {

      'use strict';

      var prepareTemplate = function(tpl) {
         var template;

         switch (typeof tpl) {
            case 'string' :
               template = tpl.indexOf('html!') === 0 || tpl.indexOf('tmpl!') === 0 ?
                  require(tpl) :
                  doT.template(tpl);
               break;
            case 'function' :
               template = tpl;
               break;
            case 'undefined' :
               template = undefined;
               break;
            default:
               template = null;
         }
         return template;
      };

      var InfoboxContent = CompoundControl.extend({
         _dotTplFn: dotTplFn,
         $protected: {
            _options: {
               message: '',
               title: '',
               options: {}
            }
         },

         _modifyOptions: function (cfg) {
            cfg.message = prepareTemplate(cfg.message)(cfg.options || {});
            if (cfg.title) {
               cfg.title = prepareTemplate(cfg.title)(cfg.options || {});
            }
            cfg.sanitize = function(markup) {
               return Sanitize(markup.message || markup.title, {validNodes: {component: true}, validAttributes : {config: true} });
            };
            return cfg;
         }
      });

      return InfoboxContent;
   });