/// <amd-module name="Lib/File/Attach/Option/Getters/FS" />
define("Lib/File/Attach/Option/Getters/FS", ["require", "exports", "tslib", "Lib/File/Attach/Option/ResourceGetter", "Lib/File/ResourceGetter/FSGetter"], function (require, exports, tslib_1, ResourceGetter, FSGetter) {
    "use strict";
    /**
     * Класс конфигурации IResourceGetter для выбора из файловой системы, передаваемый в SbisAttach
     * @class
     * @name Lib/File/Attach/Option/Getters/FS
     * @public
     * @author Заляев А.В.
     */
    var FS = /** @class */ (function (_super) {
        tslib_1.__extends(FS, _super); /** @lends Lib/File/Attach/Option/Getters/FS.prototype*/
        /**
         * @cfg {Boolean} Выбрать несколько файлов
         * <wiTag group="Управление">
         * Позволяет выбрать несколько файлов
         */
        /**
         * @cfg {Array<String>} Список расширений выбираемых файлов
         * <wiTag group="Управление">
         * Помимо перечисления массива конкретных расширений файлов, можно также передать в массив значения:
         * <ul>
         *      <li> "image" - доступен выбор всех типов изображений</li>
         *      <li> "audio" - доступен выбор всех типов аудио файлов</li>
         *      <li> "video" - доступен выбор всех типов видео файлов</li>
         * </ul>
         * @example
         * <pre>
         *    extensions: ["image"]
         *    // extensions: ["jpe","jpg","jpeg","gif","png","bmp","ico","svg","svgz","tif","tiff","pct","psd"]
         * </pre>
         */
        /**
         * @cfg {HTMLElement} DOM элемент - контейнер, в котором будет построен невидивый input[type=file] посредством которого открывается окошко выбора файлов
         * <wiTag group="Управление">
         * По умолчанию: document.body
         */
        /**
         * @param {Object} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         */
        function FS(options) {
            return _super.call(this, new FSGetter(options || {})) || this;
        }
        return FS;
    }(ResourceGetter /** @lends Lib/File/Attach/Option/Getters/FS.prototype*/));
    return FS;
});
