/// <amd-module name="Lib/File/Attach/Option/Getters/Rich" />
define("Lib/File/Attach/Option/Getters/Rich", ["require", "exports", "tslib", "Lib/File/Attach/Option/ResourceGetter", "Lib/File/ResourceGetter/FSGetter", "optional!js!SBIS3.FL.RichGetter"], function (require, exports, tslib_1, ResourceGetter, FSGetter, RichGetter) {
    "use strict";
    /**
     * Класс конфигурации IResourceGetter для выбора из файловой системы, по средствам "богатого окна выбора", передаваемый в SbisAttach
     * При недоступности SBIS3.FL.RichGetter в проекте, будет сконфигурирован lib/File/ResourceGetter/FSGetter
     * @class
     * @name Lib/File/Attach/Option/Getters/Rich
     * @public
     */
    var Rich = /** @class */ (function (_super) {
        tslib_1.__extends(Rich, _super); /** @lends Lib/File/Attach/Option/Getters/Rich.prototype*/
        /**
         * @param {Object} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         * @see lib/File/ResourceGetter/FSGetter
         * @see SBIS3.FL.RichGetter
         */
        function Rich(options) {
            return _super.call(this, RichGetter ? new RichGetter(options || {}) : new FSGetter(options || {})) || this;
        }
        return Rich;
    }(ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Rich.prototype*/));
    return Rich;
});
