/// <amd-module name="Lib/File/Attach/Option/Getters/Rich" />

import ResourceGetter = require("Lib/File/Attach/Option/ResourceGetter");
import FSGetter = require("Lib/File/ResourceGetter/FSGetter");
import RichGetter = require("optional!js!SBIS3.FL.RichGetter");

/**
 * Класс конфигурации IResourceGetter для выбора из файловой системы, по средствам "богатого окна выбора", передаваемый в SbisAttach
 * При недоступности SBIS3.FL.RichGetter в проекте, будет сконфигурирован lib/File/ResourceGetter/FSGetter
 * @class
 * @name Lib/File/Attach/Option/Getters/Rich
 * @public
 */
class Rich extends ResourceGetter /** @lends Lib/File/Attach/Option/Getters/Rich.prototype*/{
    /**
     * @param {Object} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/ResourceGetter/IResourceGetterBase
     * @see lib/File/ResourceGetter/FSGetter
     * @see SBIS3.FL.RichGetter
     */
    constructor (options?: any) {
        super (RichGetter? new RichGetter(options || {}): new FSGetter(options || {}));
    }
}
export = Rich;