/// <amd-module name="Lib/File/Attach/Option/ResourceGetter" />
define("Lib/File/Attach/Option/ResourceGetter", ["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * Класс конфигурации IResourceGetter, передаваемый в SbisAttach
     * @class Lib/File/Attach/Option/ResourceGetter
     * @public
     * @see Lib/File/Attach/SbisAttach
     * @author Заляев А.В.
     */
    var ResourceGetterOption /** @lends Lib/File/Attach/Option/ResourceGetter.prototype*/ = /** @class */ (function () {
        /**
         *
         * @param {string | IResourceGetter} getter Экземпляр IResourceGetter, либо ссылка на модуль
         * @param {string} name
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/ResourceGetter/IResourceGetterBase
         */
        function ResourceGetterOption(getter, name, options) {
            this.getter = getter;
            this.name = name;
            this.options = options;
        }
        ResourceGetterOption.prototype.getName = function () {
            return this.name;
        };
        ;
        /**
         * Возвращает параметры вызова конструктора
         * @return {*}
         */
        ResourceGetterOption.prototype.getOptions = function () {
            return this.options;
        };
        ;
        /**
         * Возвращает экземпляр IResourceGetter, либо ссылку на модуль
         * @return {string | IResourceGetter}
         */
        ResourceGetterOption.prototype.getGetter = function () {
            return this.getter;
        };
        return ResourceGetterOption;
    }());
    return ResourceGetterOption;
});
