/// <amd-module name="Lib/File/Attach/Option/ResourceGetter" />

import IResourceGetter = require("Lib/File/ResourceGetter/IResourceGetter");

/**
 * Класс конфигурации IResourceGetter, передаваемый в SbisAttach
 * @class Lib/File/Attach/Option/ResourceGetter
 * @public
 * @see Lib/File/Attach/SbisAttach
 * @author Заляев А.В.
 */
class ResourceGetterOption /** @lends Lib/File/Attach/Option/ResourceGetter.prototype*/{
    /**
     *
     * @param {string | IResourceGetter} getter Экземпляр IResourceGetter, либо ссылка на модуль
     * @param {string} name
     * @param {*} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/ResourceGetter/IResourceGetterBase
     */
    constructor (private getter: string | IResourceGetter, private name?: string, private options?: any) {
    
    }
    getName(): string {
        return this.name;
    };
    /**
     * Возвращает параметры вызова конструктора
     * @return {*}
     */
    getOptions(): any {
        return this.options;
    };
    /**
     * Возвращает экземпляр IResourceGetter, либо ссылку на модуль
     * @return {string | IResourceGetter}
     */
    getGetter(): string | IResourceGetter {
        return this.getter;
    }
}
export = ResourceGetterOption;