/// <amd-module name="Lib/File/Attach/Option/Sources/BLPlugin" />
define("Lib/File/Attach/Option/Sources/BLPlugin", ["require", "exports", "tslib", "Lib/File/Attach/Option/Source", "Lib/File/LocalFileLink"], function (require, exports, tslib_1, SourceOption, LocalFileLink) {
    "use strict";
    var LINK = "js!SBIS3.Plugin/components/Extensions/Integration/Source/BL_SbisPluginSource";
    /**
     * @typedef {Object} Endpoint
     * @property {String} contract Контракт - определяет доступные операции
     * @property {String} [address] Адрес - указывает место расположения сервиса, к которому будет осуществлено подключение
     * @property {String} [moveContract=ПорядковыйНомер] Название объекта бл в которому принадлежат методы перемещения
     */
    /**
     * @typedef {Object} Binding
     * @property {String} [create]
     * @property {String} [read]
     * @property {String} [update]
     * @property {String} [query]
     * @property {String} [move]
     * @property {String} [copy]
     * @property {String} [merge]
     * @property {String} [destroy]
     */
    /**
     * Класс конфигурации ISource для загрузки на Бизнес-Логику через СБИС Плагин
     * @class
     * @name Lib/File/Attach/Option/Sources/BLPlugin
     * @public
     * @author Заляев А.В.
     */
    var BLPlugin = /** @class */ (function (_super) {
        tslib_1.__extends(BLPlugin, _super); /** @lends Lib/File/Attach/Option/Sources/BLPlugin.prototype*/
        /**
         * @cfg {Endpoint|String} endpoint Конечная точка, обеспечивающая доступ клиента к функциональным возможностям источника данных.
         */
        /**
         * @cfg {Binding} binding Соответствие методов CRUD+ методам БЛ. Определяет, какой метод объекта БЛ соответствует каждому методу CRUD+.
         */
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/LocalFileLink
         * @see WS.Data/Source/ISource
         */
        function BLPlugin(options) {
            return _super.call(this, LINK, LocalFileLink, options || {}) || this;
        }
        return BLPlugin;
    }(SourceOption /** @lends Lib/File/Attach/Option/Sources/BLPlugin.prototype*/));
    return BLPlugin;
});
