/// <amd-module name="Lib/File/Attach/Option/Sources/BLXHR" />
define("Lib/File/Attach/Option/Sources/BLXHR", ["require", "exports", "tslib", "Lib/File/Attach/Option/Source", "Lib/File/LocalFile"], function (require, exports, tslib_1, SourceOption, LocalFile) {
    "use strict";
    var LINK = "WS.Data/Source/SbisFile";
    /**
     * @typedef {Object} Endpoint
     * @property {String} contract Контракт - определяет доступные операции
     * @property {String} [address] Адрес - указывает место расположения сервиса, к которому будет осуществлено подключение
     * @property {String} [moveContract=ПорядковыйНомер] Название объекта бл в которому принадлежат методы перемещения
     */
    /**
     * @typedef {Object} Binding
     * @property {String} [create]
     * @property {String} [read]
     * @property {String} [update]
     * @property {String} [query]
     * @property {String} [move]
     * @property {String} [copy]
     * @property {String} [merge]
     * @property {String} [destroy]
     */
    /**
     * Класс конфигурации ISource для загрузки на Бизнес-Логику через XHR запросы
     * @class
     * @name Lib/File/Attach/Option/Sources/BLXHR
     * @public
     * @author Заляев А.В.
     */
    var BLXHR = /** @class */ (function (_super) {
        tslib_1.__extends(BLXHR, _super); /** @lends Lib/File/Attach/Option/Sources/BLXHR.prototype*/
        /**
         * @cfg {Endpoint|String} endpoint Конечная точка, обеспечивающая доступ клиента к функциональным возможностям источника данных.
         */
        /**
         * @cfg {Binding} binding Соответствие методов CRUD+ методам БЛ. Определяет, какой метод объекта БЛ соответствует каждому методу CRUD+.
         */
        /**
         * @param {*} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/LocalFileLink
         * @see WS.Data/Source/ISource
         */
        function BLXHR(options) {
            return _super.call(this, LINK, LocalFile, options || {}) || this;
        }
        return BLXHR;
    }(SourceOption /** @lends Lib/File/Attach/Option/Sources/BLXHR.prototype*/));
    return BLXHR;
});
