/// <amd-module name="Lib/File/Attach/Option/Sources/FileTransferPlugin" />

import SourceOption = require("Lib/File/Attach/Option/Source");
import LocalFileLink = require("Lib/File/LocalFileLink");

const LINK = "js!SBIS3.Plugin/components/Extensions/Integration/Source/FileTransfer_SbisPluginSource";

/**
 * Класс конфигурации ISource для загрузки на FileTransfer через СБИС Плагин
 * @class
 * @name Lib/File/Attach/Option/Sources/FileTransferPlugin
 * @public
 * @author Заляев А.В.
 */
class FileTransferPlugin extends SourceOption /** @lends Lib/File/Attach/Option/Sources/FileTransferPlugin.prototype*/{
    /**
     * @param {*} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/LocalFileLink
     * @see WS.Data/Source/ISource
     */
    constructor (options?: any) {
        super (LINK, LocalFileLink, options || {});
    }
}
export = FileTransferPlugin;