/// <amd-module name="Lib/File/Attach/Option/Sources/SbisDiskPlugin" />
define("Lib/File/Attach/Option/Sources/SbisDiskPlugin", ["require", "exports", "tslib", "Lib/File/Attach/Option/Source", "Lib/File/LocalFileLink"], function (require, exports, tslib_1, SourceOption, LocalFileLink) {
    "use strict";
    var LINK = "js!SBIS3.Plugin/components/Extensions/Integration/Source/SBISDisk_SbisPluginSource";
    /**
     * Класс конфигурации ISource для загрузки на СБИС Диск через СБИС Плагин
     * Позволяет загружать ресурсы сужности {@link Lib/File/LocalFileLink}
     * @class
     * @name Lib/File/Attach/Option/Sources/SbisDiskPlugin
     * @public
     * @author Заляев А.В.
     */
    var SbisDiskPlugin = /** @class */ (function (_super) {
        tslib_1.__extends(SbisDiskPlugin, _super); /** @lends Lib/File/Attach/Option/Sources/SbisDiskPlugin.prototype*/
        /**
         * @cfg {String} catalog Каталог для загрузки на сервис
         *
         * <ul>
         *  <li> mydocs – мои документы </li>
         *  <li> commondocs – общие документы </li>
         *  <li> docs – документы </li>
         *  <li> images – картинки </li>
         *  <li> messages – сообщения </li>
         * </ul>
         * По умолчанию: "temp"
         */
        /**
         * @cfg {String} serviceUrl Адресс сервиса СБИС Диск
         * По умолчанию: "/disk/api/v1/"
         */
        /**
         * @param {Object} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/LocalFileLink
         * @see WS.Data/Source/ISource
         */
        function SbisDiskPlugin(options) {
            return _super.call(this, LINK, LocalFileLink, Object.assign({
                catalog: "temp"
            }, options)) || this;
        }
        return SbisDiskPlugin;
    }(SourceOption /** @lends Lib/File/Attach/Option/Sources/SbisDiskPlugin.prototype*/));
    return SbisDiskPlugin;
});
