/// <amd-module name="Lib/File/Attach/Option/Sources/SbisDiskXHR" />
define("Lib/File/Attach/Option/Sources/SbisDiskXHR", ["require", "exports", "tslib", "Lib/File/Attach/Option/Source", "Lib/File/LocalFile"], function (require, exports, tslib_1, SourceOption, LocalFile) {
    "use strict";
    var LINK = "SbisDiskBase/Data/Source";
    /**
     * Класс конфигурации ISource для загрузки на СБИС Диск через Xhr - запрос
     * Позволяет загружать ресурсы сужности {@link Lib/File/LocalFile}
     * @class
     * @name Lib/File/Attach/Option/Sources/SbisDiskXHR
     * @public
     * @author Заляев А.В
     */
    var SbisDiskXHR = /** @class */ (function (_super) {
        tslib_1.__extends(SbisDiskXHR, _super); /** @lends Lib/File/Attach/Option/Sources/SbisDiskXHR.prototype*/
        /**
         * @cfg {String} catalog Каталог для загрузки на сервис
         *
         * <ul>
         *  <li> mydocs – мои документы </li>
         *  <li> commondocs – общие документы </li>
         *  <li> docs – документы </li>
         *  <li> images – картинки </li>
         *  <li> messages – сообщения </li>
         * </ul>
         * По умолчанию: "temp"
         */
        /**
         * @cfg {String} serviceUrl Адресс сервиса СБИС Диск
         * По умолчанию: "/disk/api/v1/"
         */
        /**
         * @param {Object} [options] Параметры вызова конструктора
         * @constructor
         * @see Lib/File/LocalFile
         * @see WS.Data/Source/ISource
         */
        function SbisDiskXHR(options) {
            return _super.call(this, LINK, LocalFile, Object.assign({
                catalog: "temp"
            }, options)) || this;
        }
        return SbisDiskXHR;
    }(SourceOption /** @lends Lib/File/Attach/Option/Sources/SbisDiskXHR.prototype*/));
    return SbisDiskXHR;
});
