/// <amd-module name="Lib/File/Attach/Option/Sources/SbisDiskXHR" />

import SourceOption = require("Lib/File/Attach/Option/Source");
import LocalFile = require("Lib/File/LocalFile");

const LINK = "SbisDiskBase/Data/Source";

/**
 * Класс конфигурации ISource для загрузки на СБИС Диск через Xhr - запрос
 * Позволяет загружать ресурсы сужности {@link Lib/File/LocalFile}
 * @class
 * @name Lib/File/Attach/Option/Sources/SbisDiskXHR
 * @public
 * @author Заляев А.В
 */
class SbisDiskXHR extends SourceOption /** @lends Lib/File/Attach/Option/Sources/SbisDiskXHR.prototype*/{
    /**
     * @cfg {String} catalog Каталог для загрузки на сервис
     *
     * <ul>
     *  <li> mydocs – мои документы </li>
     *  <li> commondocs – общие документы </li>
     *  <li> docs – документы </li>
     *  <li> images – картинки </li>
     *  <li> messages – сообщения </li>
     * </ul>
     * По умолчанию: "temp"
     */
    /**
     * @cfg {String} serviceUrl Адресс сервиса СБИС Диск
     * По умолчанию: "/disk/api/v1/"
     */
    /**
     * @param {Object} [options] Параметры вызова конструктора
     * @constructor
     * @see Lib/File/LocalFile
     * @see WS.Data/Source/ISource
     */
    constructor (options?: any) {
        super (LINK, LocalFile, Object.assign({
            catalog: "temp"
        }, options));
    }
    
}
export = SbisDiskXHR;