define("Lib/File/Attach/Test/BL", ["require", "exports", "Lib/File/Attach/SbisAttach", "Core/core-simpleExtend", "Lib/File/Attach/Option/Getters/FS", "Lib/File/Attach/Option/Getters/Rich", "Lib/File/Attach/Option/Getters/Scanner", "Lib/File/Attach/Option/Getters/PhotoCam", "Lib/File/Attach/Option/Getters/Clipboard", "Lib/File/Attach/Option/Getters/Dialogs", "Lib/File/Attach/Option/Sources/Fabric"], function (require, exports, SbisAttach, CoreExtend, FS, Rich, Scanner, PhotoCam, Clipboard, Dialogs, Fabric) {
    "use strict";
    /**
     * Класс, наследник SbisAttach, с предустановленными параметрами для загрузки в бизнес логику
     * @public
     * @class
     * @name Lib/File/Attach/BL
     * @extends Lib/File/Attach/SbisAttach
     * @author Заляев А.В.
     */
    var BL = CoreExtend.extend(SbisAttach, {
        constructor: function (opt) {
            SbisAttach.call(this, {
                sourceOptions: Fabric.getBLSourceOptions(opt.sourceOptions),
                /**
                 * sourceOptions: [
                 *   new BLXHR(opt.sourceOptions), // Lib/File/Attach/Option/Sources/BLXHR
                 *   new BLPlugin(opt.sourceOptions) // Lib/File/Attach/Option/Sources/BLPlugin
                 * ]
                 */
                getterOptions: [
                    new FS(opt.resourceOptions /* Объект конфигурации окна выбора файлов */),
                    new Rich(opt.resourceOptions /* Объект конфигурации "богатого" окна выбора файлов */),
                    new Scanner(),
                    new PhotoCam(),
                    new Clipboard(),
                    new Dialogs()
                ],
                attachOptions: {
                    fileProperty: "Файл",
                    multiselect: true
                }
            }); // super()
        },
    });
    return BL;
});
