/// <amd-module name="Lib/File/Attach/Test/BL" />
import SbisAttach = require("lib/File/Attach/SbisAttach");
import CoreExtend = require('Core/core-simpleExtend');
// Getter options
import FS = require("Lib/File/Attach/Option/Getters/FS");
import Rich = require("Lib/File/Attach/Option/Getters/Rich");
import Scanner = require("Lib/File/Attach/Option/Getters/Scanner");
import PhotoCam = require("Lib/File/Attach/Option/Getters/PhotoCam");
import Clipboard = require("Lib/File/Attach/Option/Getters/Clipboard");
import Dialogs = require("Lib/File/Attach/Option/Getters/Dialogs");
// Source options fabric
import Fabric = require("Lib/File/Attach/Option/Sources/Fabric");


type Options = {
    sourceOptions: {
        binding: {
            create: string
        },
        endpoint: {
            address: string,
            contract:string
        },
        idProperty: string
    },
    resourceOptions: any
}

/**
 * Класс, наследник SbisAttach, с предустановленными параметрами для загрузки в бизнес логику
 * @public
 * @class
 * @name Lib/File/Attach/BL
 * @extends Lib/File/Attach/SbisAttach
 * @author Заляев А.В.
 */
let BL = CoreExtend.extend(SbisAttach, {
	constructor(opt: Options){
        SbisAttach.call(this, {
            sourceOptions: Fabric.getBLSourceOptions(opt.sourceOptions),
            /**
             * sourceOptions: [
             *   new BLXHR(opt.sourceOptions), // Lib/File/Attach/Option/Sources/BLXHR
             *   new BLPlugin(opt.sourceOptions) // Lib/File/Attach/Option/Sources/BLPlugin
             * ]
             */
            getterOptions: [
                new FS(opt.resourceOptions/* Объект конфигурации окна выбора файлов */),
                new Rich(opt.resourceOptions/* Объект конфигурации "богатого" окна выбора файлов */),
                new Scanner(/* Объект конфигурации сканера */),
                new PhotoCam(/* Объект конфигурации веб-камеры */),
                new Clipboard(/* Объект конфигурации выбора через буфер обмена */),
                new Dialogs(/* Объект конфигурации окна выбора файлов через СБИС Плагин */)
            ],
            attachOptions: {
                fileProperty: "Файл",
                multiselect: true
            }
        }); // super()
	},
});
export = BL;
