define("Lib/File/Attach/Test/FileTransfer", ["require", "exports", "Lib/File/Attach/SbisAttach", "Core/core-simpleExtend", "Lib/File/Attach/Option/Getters/FS", "Lib/File/Attach/Option/Getters/Rich", "Lib/File/Attach/Option/Getters/Scanner", "Lib/File/Attach/Option/Getters/PhotoCam", "Lib/File/Attach/Option/Getters/Clipboard", "Lib/File/Attach/Option/Getters/Dialogs", "Lib/File/Attach/Option/Sources/Fabric"], function (require, exports, SbisAttach, CoreExtend, FS, Rich, Scanner, PhotoCam, Clipboard, Dialogs, Fabric) {
    "use strict";
    /**
     * Тестовый класс, наследник SbisAttach, с предустановленными параметрами, позволяющий загружать данные на TransferAttach
     * @public
     * @class Lib/File/Attach/TestFileTransferAttach
     * @extends Lib/File/Attach/SbisAttach
     * @author Заляев А.В.
     */
    var TestFileTransferAttach = CoreExtend.extend(SbisAttach, /** @lends Lib/File/Attach/TestFileTransferAttach.prototype*/ {
        constructor: function (opt) {
            SbisAttach.call(this, {
                sourceOptions: Fabric.getFileTransferSourceOptions(opt.sourceOptions),
                /**
                 * sourceOptions: [
                 *   new FileTransferPlugin(opt.sourceOptions), // Lib/File/Attach/Option/Sources/FileTransferPlugin
                 * ]
                 */
                getterOptions: [
                    new FS(),
                    new Rich(),
                    new Scanner(),
                    new PhotoCam(),
                    new Clipboard(),
                    new Dialogs()
                ],
                attachOptions: {
                    fileProperty: "Файл",
                    multiselect: true
                }
            }); // super()
        }
    });
    return TestFileTransferAttach;
});
