/// <amd-module name="Lib/File/Attach/Test/FileTransfer" />
import SbisAttach = require("lib/File/Attach/SbisAttach");
import CoreExtend = require('Core/core-simpleExtend');
// Getter options
import FS = require("Lib/File/Attach/Option/Getters/FS");
import Rich = require("Lib/File/Attach/Option/Getters/Rich");
import Scanner = require("Lib/File/Attach/Option/Getters/Scanner");
import PhotoCam = require("Lib/File/Attach/Option/Getters/PhotoCam");
import Clipboard = require("Lib/File/Attach/Option/Getters/Clipboard");
import Dialogs = require("Lib/File/Attach/Option/Getters/Dialogs");
// Source options fabric
import Fabric = require("Lib/File/Attach/Option/Sources/Fabric");


type Options = {
    sourceOptions: any,
    resourceOptions: any
}

/**
 * Тестовый класс, наследник SbisAttach, с предустановленными параметрами, позволяющий загружать данные на TransferAttach
 * @public
 * @class Lib/File/Attach/TestFileTransferAttach
 * @extends Lib/File/Attach/SbisAttach
 * @author Заляев А.В.
 */

let TestFileTransferAttach = CoreExtend.extend(SbisAttach,/** @lends Lib/File/Attach/TestFileTransferAttach.prototype*/ {
    constructor(opt: Options){
        SbisAttach.call(this, {
            sourceOptions: Fabric.getFileTransferSourceOptions(opt.sourceOptions),
            /**
             * sourceOptions: [
             *   new FileTransferPlugin(opt.sourceOptions), // Lib/File/Attach/Option/Sources/FileTransferPlugin
             * ]
             */
            getterOptions: [
                new FS(/* Объект конфигурации окна выбора файлов */),
                new Rich(/* Объект конфигурации "богатого" окна выбора файлов */),
                new Scanner(/* Объект конфигурации сканера */),
                new PhotoCam(/* Объект конфигурации веб-камеры */),
                new Clipboard(/* Объект конфигурации выбора через буфер обмена */),
                new Dialogs(/* Объект конфигурации окна выбора файлов через СБИС Плагин */)
            ],
            attachOptions: {
                fileProperty: "Файл",
                multiselect: true
            }
        }); // super()
    }
});

export = TestFileTransferAttach;
