define("Lib/File/Attach/Test/SBISDisk", ["require", "exports", "Lib/File/Attach/SbisAttach", "Core/core-simpleExtend", "Lib/File/Attach/Option/Getters/FS", "Lib/File/Attach/Option/Getters/Rich", "Lib/File/Attach/Option/Getters/Scanner", "Lib/File/Attach/Option/Getters/PhotoCam", "Lib/File/Attach/Option/Getters/Clipboard", "Lib/File/Attach/Option/Getters/Dialogs", "Lib/File/Attach/Option/Sources/Fabric"], function (require, exports, SbisAttach, CoreExtend, FS, Rich, Scanner, PhotoCam, Clipboard, Dialogs, Fabric) {
    "use strict";
    /**
     * Тестовый класс, наследник SbisAttach, с предустановленными параметрами, позволяющий загружать данные на СБИС Диск
     * @public
     * @class Lib/File/Attach/TestSBISDiskAttach
     * @extends Lib/File/Attach/SbisAttach
     * @author Заляев А.В.
     */
    var TestSBISDiskAttach = CoreExtend.extend(SbisAttach, /** @lends Lib/File/Attach/TestSBISDiskAttach.prototype*/ {
        constructor: function (opt) {
            SbisAttach.call(this, {
                sourceOptions: Fabric.getSbisDiskSourceOptions(opt.sourceOptions),
                /**
                 * sourceOptions: [
                 *   new SbisDiskPlugin(opt.sourceOptions), // Lib/File/Attach/Option/Sources/SbisDiskPlugin
                 * ]
                 */
                getterOptions: [
                    new FS(),
                    new Rich(),
                    new Scanner(),
                    new PhotoCam(),
                    new Clipboard(),
                    new Dialogs()
                ],
                attachOptions: {
                    fileProperty: "Файл",
                    multiselect: true
                }
            }); // super()
        }
    });
    return TestSBISDiskAttach;
});
