define("Lib/File/HttpFileLink", ["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * Класс - обёртка над http-ссылкой на файл
     * @class
     * @name Lib/File/HttpFileLink
     * @implements ILocalFileLink, IFileData
     * @public
     * @author Заляев А.В.
     */
    var HttpFileLink = /** @class */ (function () {
        /**
         * @param {String} fileLink Ссылка на ресурс
         * @param {*} [meta] Дополнительные мета-данные
         * @constructor
         * @name Lib/File/HttpFileLink
         */
        function HttpFileLink(fileLink, meta) {
            this.fileLink = fileLink;
            this.meta = meta;
        }
        /**
         * Возвращает ссылку на удалённый ресурс
         * @return {String}
         * @method
         * @name Lib/File/HttpFileLink#getLink
         */
        HttpFileLink.prototype.getLink = function () {
            return this.fileLink;
        };
        /**
         * Возвращает дополнительную информацию по файлу
         * @return {*}
         * @method
         * @name Lib/File/HttpFileLink#getMeta
         */
        HttpFileLink.prototype.getMeta = function () {
            return this.meta;
        };
        return HttpFileLink;
    }());
    return HttpFileLink;
});
