/// <amd-module name="Lib/File/HttpFileLink" />
import {IHttpFileLink} from "Lib/File/Interface";
/**
 * Класс - обёртка над http-ссылкой на файл
 * @class
 * @name Lib/File/HttpFileLink
 * @implements ILocalFileLink, IFileData
 * @public
 * @author Заляев А.В.
 */
class HttpFileLink implements IHttpFileLink /** @lends Lib/File/HttpFileLink.prototype*/ {
    /**
     * @param {String} fileLink Ссылка на ресурс
     * @param {*} [meta] Дополнительные мета-данные
     * @constructor
     * @name Lib/File/HttpFileLink
     */
	constructor(private fileLink: string, private meta?: any) {}
    /**
     * Возвращает ссылку на удалённый ресурс
     * @return {String}
     * @method
     * @name Lib/File/HttpFileLink#getLink
     */
	getLink(): string {
		return this.fileLink;
	}
    /**
     * Возвращает дополнительную информацию по файлу
     * @return {*}
     * @method
     * @name Lib/File/HttpFileLink#getMeta
     */
    getMeta(): any {
        return this.meta;
    }
}
export  = HttpFileLink;
