define("Lib/File/LocalFileLink", ["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * Класс - обёртка над ссылкой на локальный файл
     * @class
     * @name Lib/File/LocalFileLink
     * @implements ILocalFileLink, IFileData
     * @public
     * @author Заляев А.В.
     */
    var LocalFileLink = /** @class */ (function () {
        /**
         * @param {String} fileLink Ссылка на файл
         * @param {*} [meta] Дополнительные мета-данные
         * @constructor
         * @name Lib/File/LocalFileLink
         */
        function LocalFileLink(fileLink, meta) {
            this.fileLink = fileLink;
            this.meta = meta;
        }
        /**
         * Возвращает ссылку на файл, находящийся на локальном устройстве
         * @return {String}
         * @method
         * @name Lib/File/LocalFileLink#getLink
         */
        LocalFileLink.prototype.getLink = function () {
            return this.fileLink;
        };
        /**
         * Возвращает дополнительную информацию по файлу
         * @return {*}
         * @method
         * @name Lib/File/LocalFileLink#getMeta
         */
        LocalFileLink.prototype.getMeta = function () {
            return this.meta;
        };
        return LocalFileLink;
    }());
    return LocalFileLink;
});
