/// <amd-module name="Lib/File/LocalFileLink" />
import {ILocalFileLink} from "Lib/File/Interface";
/**
 * Класс - обёртка над ссылкой на локальный файл
 * @class
 * @name Lib/File/LocalFileLink
 * @implements ILocalFileLink, IFileData
 * @public
 * @author Заляев А.В.
 */
class LocalFileLink implements ILocalFileLink /** @lends Lib/File/LocalFileLink.prototype*/ {
    /**
     * @param {String} fileLink Ссылка на файл
     * @param {*} [meta] Дополнительные мета-данные
     * @constructor
     * @name Lib/File/LocalFileLink
     */
	constructor(private fileLink: string, private meta?: any) {}
    /**
     * Возвращает ссылку на файл, находящийся на локальном устройстве
     * @return {String}
     * @method
     * @name Lib/File/LocalFileLink#getLink
     */
	getLink(): string {
		return this.fileLink;
	}
    /**
     * Возвращает дополнительную информацию по файлу
     * @return {*}
     * @method
     * @name Lib/File/LocalFileLink#getMeta
     */
    getMeta(): any {
        return this.meta;
    }
}
export  = LocalFileLink;
