/// <amd-module name="Lib/File/ResourceGetter/IResourceGetter" />
import Deferred = require("Core/Deferred");
import {IFileData} from "Lib/File/Interface";

/**
 * @author Заляев А.В.
 */
declare interface IResourceGetter {
    /**
     * Возможен ли выбор ресурса
     * @return {Core/Deferred<boolean>}
     */
    canExec(): Deferred<boolean>;
    /**
     * Осуществляет выбор ресурсов
     * @return {Core/Deferred<Array<IFileData>>}
     * @see Lib/File/LocalFile
     * @see Lib/File/LocalFileLink
     * @see Lib/File/HttpFileLink
     */
    getFiles(): Deferred<IFileData[]>;
    /**
     * Возвращает строку - тип ресурса
     * @return {String}
     */
    getType(): string;
}

export = IResourceGetter;
