/// <amd-module name="Lib/File/utils/ExtensionsError" />
define("Lib/File/utils/ExtensionsError", ["require", "exports", "tslib"], function (require, exports, tslib_1) {
    "use strict";
    var DEFAULT_MESSAGE = rk('Выбранный файл неверного типа');
    /**
     * @cfg {String} Имя файла, вызвавшего ошибку
     * @name Lib/File/utils/ExtensionsError#fileName
     */
    /**
     * Ошибка несоответствия типа выбранного файла
     * @class
     * @name Lib/File/utils/ExtensionsError
     * @public
     * @extends Error
     */
    var ExtensionsError = /** @class */ (function (_super) {
        tslib_1.__extends(ExtensionsError, _super);
        function ExtensionsError(message, fileName) {
            var _this = _super.call(this) || this;
            /*
             * Error реализован не как нормальный конструктор
             *
             * через наследование core/classic-extend
             * теряем .stack
             *
             *
             * без Object.setPrototypeOf(this, Class.prototype) получим поведение:
             * let e = new ExtensionsError("1.png");
             * e instanceof Error; // true
             * e instanceof ExtensionsError; // false
             */
            Object.setPrototypeOf(_this, ExtensionsError.prototype);
            if (!fileName) {
                fileName = message;
                message = DEFAULT_MESSAGE;
            }
            _this.message = message;
            _this.fileName = fileName;
            return _this;
        }
        return ExtensionsError;
    }(Error));
    return ExtensionsError;
});
