define("Lib/ServerEvent/DebugUtils", ["require", "exports", "Core/moduleStubs"], function (require, exports, moduleStubs) {
    /// <amd-module name="Lib/ServerEvent/DebugUtils" />
    "use strict";
    function addSharedBusLog() {
        if (typeof Promise !== "function") {
            return;
        }
        var beautyLog = function (item) {
            var channel = '';
            if (item["headers"] && item["headers"]["event-type"]) {
                channel = item["headers"]["event-type"];
            }
            console.log('[EventLog]', new Date(item.timestamp).toLocaleString(), channel, item);
        };
        var show = function (reader, filter) {
            reader.query(filter).then(function (d) {
                d.forEach(beautyLog);
            });
        };
        /**
         * @type {Lib/ServerEvent/native/EventStorage/Reader}
         */
        var reader;
        /**
         * Функция отображения собранны серверных событий
         * TODO использовать COnnectorIE и обрабатывать ошибки прилетающие от Connector::connect()
         * @param {string | RegExp} filter
         */
        window["sharedBusLog"] = function (filter) {
            if (reader) {
                show(reader, filter);
                return;
            }
            moduleStubs.require(["Lib/ServerEvent/native/EventStorage/Connector"])
                .addCallback(function (_a) {
                var Connector = _a[0];
                Connector.connect().then(function (connect) {
                    reader = connect.getReader();
                    show(reader, filter);
                });
            });
        };
    }
    var watcherEnable = false;
    function addSharedBusWatcher() {
        if (watcherEnable) {
            return;
        }
        watcherEnable = true;
        moduleStubs.require(["Lib/ServerEvent/Bus", "Lib/ServerEvent/class/logger/ConsoleWatchDog"])
            .addCallback(function (_a) {
            var seb = _a[0], wd = _a[1];
            seb["addWatchDog"](new wd());
        });
    }
    return {
        attachDebugFn: function () {
            if (!window) {
                return;
            }
            addSharedBusLog();
            window["sharedBusWatch"] = addSharedBusWatcher;
        }
    };
});
/**
 * Функция вывода последних 100 событий полученных браузером
 * @function window.sharedBusLog
 * @param filter {string|RegExp|null} Фильтр по названию канала
 */
