define("Lib/ServerEvent/class/creator/CreatorExclusiveSockJs", ["require", "exports", "tslib", "Core/Deferred", "Core/moduleStubs", "Lib/ServerEvent/class/creator/CreatorExclusive"], function (require, exports, tslib_1, Deferred, moduleStubs, CreatorExclusive) {
    "use strict";
    /**
     * @class Lib/ServerEvent/class/creator/CreatorExclusiveSockJs
     */
    var CreatorExclusiveSockJs = /** @class */ (function (_super) {
        tslib_1.__extends(CreatorExclusiveSockJs, _super);
        function CreatorExclusiveSockJs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CreatorExclusiveSockJs.prototype.getResources = function () {
            var _this = this;
            return moduleStubs.require([
                "Lib/ServerEvent/resources/stomp",
                "Lib/ServerEvent/resources/sockjs-1.0.3"
            ]).addCallback(function (r) {
                _this.SockJS = r[1];
                return r;
            });
        };
        CreatorExclusiveSockJs.prototype.getWebSocket = function (url) {
            var protocols = [
                /*'websocket',*/
                'xhr-streaming'
            ];
            try {
                return Deferred.success(new this.SockJS(url.replace('wss:', 'https:').replace('ws:', 'http:'), null, {
                    transports: protocols,
                    debug: function () {
                    },
                    stompLogger: function () {
                    }
                }));
            }
            catch (e) {
                return Deferred.fail(e);
            }
        };
        return CreatorExclusiveSockJs;
    }(CreatorExclusive));
    return CreatorExclusiveSockJs;
});
