define("Lib/ServerEvent/class/creator/CreatorSharedWorker", ["require", "exports", "tslib", "Lib/ServerEvent/class/creator/CreatorWorker", "Core/UserInfo", "Core/detection"], function (require, exports, tslib_1, CreatorWorker, UserInfo, detection) {
    "use strict";
    /**
     * Для тестирования бага на fix-online.sbis.ru
     * @type {number}
     */
    var GOOGLE_FIX_USER = 5996298;
    var isFix = window && window.location && window.location.host === 'fix-online.sbis.ru';
    var CreatorSharedWorker = /** @class */ (function (_super) {
        tslib_1.__extends(CreatorSharedWorker, _super);
        function CreatorSharedWorker() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CreatorSharedWorker.prototype.isAvailableInEnv = function (isExclusive) {
            if (isExclusive) {
                return false;
            }
            var accountId = parseInt(UserInfo.get('ИдентификаторКлиента'));
            var userId = parseInt(UserInfo.get('ИдентификаторПользователя'));
            var isGoogleFix = isFix && accountId === 3 && userId === GOOGLE_FIX_USER;
            return _super.prototype.isAvailableInEnv.call(this, isExclusive)
                && typeof SharedWorker != 'undefined'
                && (isGoogleFix || !detection.chrome);
        };
        CreatorSharedWorker.prototype.getWorkerType = function () {
            return 'SharedWorker';
        };
        return CreatorSharedWorker;
    }(CreatorWorker));
    return CreatorSharedWorker;
});
