/// <amd-module name="Lib/ServerEvent/class/creator/CreatorSharedWorker" />
import CreatorWorker = require('Lib/ServerEvent/class/creator/CreatorWorker');
import UserInfo = require('Core/UserInfo');
import detection = require('Core/detection');

declare let SharedWorker: ServiceWorker;

/**
 * Для тестирования бага на fix-online.sbis.ru
 * @type {number}
 */
const GOOGLE_FIX_USER = 5996298;
let isFix = window && window.location && window.location.host === 'fix-online.sbis.ru';

class CreatorSharedWorker extends CreatorWorker {
    isAvailableInEnv(isExclusive: boolean) {
        if (isExclusive) {
            return false;
        }
        let accountId: number = parseInt(UserInfo.get('ИдентификаторКлиента'));
        let userId: number = parseInt(UserInfo.get('ИдентификаторПользователя'));
        let isGoogleFix = isFix && accountId === 3 && userId === GOOGLE_FIX_USER;
        return super.isAvailableInEnv(isExclusive)
            && typeof SharedWorker != 'undefined'
            && (isGoogleFix || !detection.chrome);
    }

    protected getWorkerType(): string {
        return 'SharedWorker';
    }
}

export = CreatorSharedWorker;