define("Lib/ServerEvent/class/creator/CreatorSockJs", ["require", "exports", "tslib", "Core/Deferred", "Core/moduleStubs", "Lib/ServerEvent/class/creator/CreatorLocalWebSocket"], function (require, exports, tslib_1, Deferred, moduleStubs, CreatorLocalWebSocket) {
    "use strict";
    var CreatorSockJs = /** @class */ (function (_super) {
        tslib_1.__extends(CreatorSockJs, _super);
        function CreatorSockJs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        CreatorSockJs.prototype.getResources = function () {
            var _this = this;
            return moduleStubs.require([
                "Lib/ServerEvent/resources/stomp",
                "Lib/ServerEvent/resources/sockjs-1.0.3"
            ]).addCallback(function (r) {
                _this.SockJS = r[1];
                return r;
            });
        };
        CreatorSockJs.prototype.getWebSocket = function (url) {
            var protocols = [
                /*'websocket',*/
                'xhr-streaming'
            ];
            try {
                return Deferred.success(new this.SockJS(url.replace('wss:', 'https:').replace('ws:', 'http:'), null, {
                    transports: protocols,
                    debug: function () {
                    },
                    stompLogger: function () {
                    }
                }));
            }
            catch (e) {
                return Deferred.fail(e);
            }
        };
        return CreatorSockJs;
    }(CreatorLocalWebSocket));
    return CreatorSockJs;
});
