/// <amd-module name="Lib/ServerEvent/class/creator/CreatorSockJs" />
import Deferred = require('Core/Deferred');
import moduleStubs = require('Core/moduleStubs');
import CreatorLocalWebSocket = require('Lib/ServerEvent/class/creator/CreatorLocalWebSocket');

class CreatorSockJs extends CreatorLocalWebSocket {
    private SockJS;

    protected getResources(): Deferred<any[]> {
        return moduleStubs.require([
            "Lib/ServerEvent/resources/stomp",
            "Lib/ServerEvent/resources/sockjs-1.0.3"
        ]).addCallback((r) => {
            this.SockJS = r[1];
            return r;
        });
    }

    protected getWebSocket(url): Deferred<WebSocket> {
        let protocols = [
            /*'websocket',*/
            'xhr-streaming'];

        try {
            return Deferred.success(new this.SockJS(
                url.replace('wss:', 'https:').replace('ws:', 'http:'),
                null, {
                    transports: protocols,
                    debug: () => {
                    },
                    stompLogger: () => {
                    }
                })
            );
        } catch (e) {
            return Deferred.fail(e);
        }
    }
}

export = CreatorSockJs;