/// <amd-module name="Lib/ServerEvent/class/creator/CreatorWebSocket" />
import Deferred = require('Core/Deferred');
import moduleStubs = require('Core/moduleStubs');
import CreatorLocalWebSocket = require('Lib/ServerEvent/class/creator/CreatorLocalWebSocket');

/**
 * @class {Lib/ServerEvent/class/creator/CreatorLocalWebSocket}
 */
class CreatorWebSocket extends CreatorLocalWebSocket {
    protected getWebSocket(url): Deferred<WebSocket> {
        return moduleStubs.require("Lib/ServerEvent/native/SockjsEmulator").addCallback(([SockJSTransport]) => {
            return new SockJSTransport(url);
        }).createDependent();
    }

    protected getResources(): Deferred<any[]> {
        return moduleStubs.require("Lib/ServerEvent/resources/stomp");
    }
}

export = CreatorWebSocket;
