define("Lib/ServerEvent/class/creator/CreatorWorker", ["require", "exports", "Core/Deferred", "Core/detection", "Core/UserInfo", "Core/moduleStubs", "Core/LocalStorageNative"], function (require, exports, Deferred, detection, UserInfo, moduleStubs, LocalStorageNative) {
    "use strict";
    var CreatorWorker = /** @class */ (function () {
        function CreatorWorker(connectOptions) {
            this.connectOptions = connectOptions;
            this.sid = connectOptions.sid;
            var userName = UserInfo.get('ЛогинПользователя') || '';
            this.isGuestAccess = userName.indexOf('__сбис__гость__') > -1;
        }
        CreatorWorker.prototype.isAvailableInEnv = function (isExclusive) {
            if (isExclusive) {
                return false;
            }
            var isMobile = detection.isMobileAndroid || detection.isMobileIOS || detection.isIE12;
            return !isMobile && typeof Promise != 'undefined';
        };
        CreatorWorker.prototype.build = function (hash) {
            var _this = this;
            var def = new Deferred();
            moduleStubs.require([
                'Lib/ServerEvent/worker-connect/WorkerBuilder',
                'Lib/ServerEvent/class/transport/WorkerTransport'
            ])
                .addCallback(function (_a) {
                var Seb = _a[0], WorkerTransport = _a[1];
                _this.realBuild(hash, Seb, def, WorkerTransport);
                return Seb;
            });
            return def;
        };
        /**
         * @param hash {string}
         * @param Seb {Object}
         * @param def {Deferred}
         * @param WorkerTransport {SEB.ITrackedTransport}
         */
        CreatorWorker.prototype.realBuild = function (hash, Seb, def, WorkerTransport) {
            var isPersist = !this.isGuestAccess;
            var isAck = false;
            if ('true' == LocalStorageNative.getItem('shared-bus-ack')) {
                isAck = true;
            }
            Seb.createConnection(this.getWorkerType(), this.connectOptions.getWebSocketUrl(), this.connectOptions.exchange, this.sid, hash, isPersist, isAck).addCallback(function (connect) {
                def.callback(new WorkerTransport(connect));
            }).addErrback(function (e) {
                def.errback(e);
                console.warn(e);
            });
        };
        return CreatorWorker;
    }());
    return CreatorWorker;
});
