define("Lib/ServerEvent/class/deliver/DeliveryChooser", ["require", "exports", "Core/Deferred", "Lib/ServerEvent/class/Notifier", "Lib/ServerEvent/class/transport/LocalPageTransport", "Lib/ServerEvent/class/transport/WorkerTransport", "Lib/ServerEvent/class/deliver/LSEventDeliver", "Lib/ServerEvent/class/deliver/PageEventDeliver"], function (require, exports, Deferred, Notifier, LocalPageTransport, WorkerTransport, LSEventDeliver, PageEventDeliver) {
    "use strict";
    /**
     * Создаю один доставщик на страницу.
     * Как бы не менялись транспорты, канал остаётся один.
     * @type {Notifier}
     */
    var notifier = new Notifier();
    var DeliveryChooser = /** @class */ (function () {
        function DeliveryChooser(watcher) {
            this.watcher = watcher;
            notifier.setWatcher(watcher);
        }
        DeliveryChooser.prototype.choose = function (transport) {
            if (transport instanceof WorkerTransport || transport instanceof LocalPageTransport) {
                return Deferred.success(new PageEventDeliver(notifier));
            }
            return Deferred.success(new LSEventDeliver(notifier));
        };
        return DeliveryChooser;
    }());
    return DeliveryChooser;
});
