define("Lib/ServerEvent/class/deliver/LSEventDeliver", ["require", "exports", "Lib/TabMessage/TabMessage"], function (require, exports, TabMessage) {
    "use strict";
    var LSEventDeliver = /** @class */ (function () {
        function LSEventDeliver(notifier) {
            this.notifier = notifier;
            this.onmessageHandler = this.onmessageHandler.bind(this);
            this.taber = new TabMessage();
            this.taber.subscribe(LSEventDeliver.ON_MESSAGE, this.onmessageHandler);
        }
        LSEventDeliver.prototype.onmessageHandler = function (event, data) {
            this.notifier.fire(data.channelName, data.eventName, data.rawData);
        };
        LSEventDeliver.prototype.deliver = function (channelName, eventName, rawData) {
            this.notifier.fire(channelName, eventName, rawData);
            this.taber.notify(LSEventDeliver.ON_MESSAGE, {
                channelName: channelName,
                eventName: eventName,
                rawData: rawData
            });
        };
        LSEventDeliver.prototype.destroy = function () {
            this.taber.unsubscribe(LSEventDeliver.ON_MESSAGE, this.onmessageHandler);
        };
        LSEventDeliver.ON_MESSAGE = 'servereventbus_onmessage';
        return LSEventDeliver;
    }());
    return LSEventDeliver;
});
