/// <amd-module name="Lib/ServerEvent/class/deliver/PageEventDeliver" />
import Notifier = require('Lib/ServerEvent/class//Notifier');
import {SEB} from "../../interfaces";

/**
 * Доставщик событий только по текущей странице
 */
class PageEventDeliver implements SEB.IEventDeliver {
    constructor(private notifier: Notifier) {
    }

    deliver(channelName: string, eventName: string, rawData?: string) {
        this.notifier.fire(channelName, eventName, rawData);
    }

    destroy() {
    }
}

export = PageEventDeliver;