define("Lib/ServerEvent/class/logger/WatchDogAggregator", ["require", "exports"], function (require, exports) {
    /// <amd-module name="Lib/ServerEvent/class/logger/WatchDogAggregator" />
    /**
     * @author Санников К.А.
     */
    "use strict";
    var WatchDogAggregator = /** @class */ (function () {
        function WatchDogAggregator(container) {
            if (container === void 0) { container = []; }
            this.container = container;
        }
        WatchDogAggregator.prototype.reg = function (watcher) {
            this.container.push(watcher);
        };
        WatchDogAggregator.prototype.logStomp = function (message) {
            for (var _i = 0, _a = this.container; _i < _a.length; _i++) {
                var watcher = _a[_i];
                try {
                    watcher.logStomp(message);
                }
                catch (e) {
                    var name_1 = "name" in watcher.constructor ? watcher.constructor["name"] : '';
                    console.error("Error logStomp in watcher " + name_1 + ":", e.message);
                }
            }
        };
        WatchDogAggregator.prototype.logEvent = function (channelName, eventName, data) {
            for (var _i = 0, _a = this.container; _i < _a.length; _i++) {
                var watcher = _a[_i];
                try {
                    watcher.logEvent(channelName, eventName, data);
                }
                catch (e) {
                    var name_2 = "name" in watcher.constructor ? watcher.constructor["name"] : '';
                    console.error("Error logEvent in watcher " + name_2 + ":", e.message);
                }
            }
        };
        WatchDogAggregator.prototype.logConnect = function (data) {
            for (var _i = 0, _a = this.container; _i < _a.length; _i++) {
                var watcher = _a[_i];
                try {
                    if (!watcher["logConnect"]) {
                        continue;
                    }
                    watcher.logConnect(data);
                }
                catch (e) {
                    var name_3 = "name" in watcher.constructor ? watcher.constructor["name"] : '';
                    console.error("Error logConnect in watcher " + name_3 + ":", e.message);
                }
            }
        };
        WatchDogAggregator.prototype.logDisconnect = function (e) {
            for (var _i = 0, _a = this.container; _i < _a.length; _i++) {
                var watcher = _a[_i];
                try {
                    if (!watcher["logDisconnect"]) {
                        continue;
                    }
                    watcher.logDisconnect(e);
                }
                catch (e) {
                    var name_4 = "name" in watcher.constructor ? watcher.constructor["name"] : '';
                    console.error("Error logDisconnect in watcher " + name_4 + ":", e.message);
                }
            }
        };
        return WatchDogAggregator;
    }());
    return WatchDogAggregator;
});
