declare module Page {
    type PortMessageCommands = 'connect' | 'subscribe' | 'subscribe.channel' | 'unsubscribe' | 'unsubscribe.channel' | 'disconnect';
    class PortMessage {
        command: PortMessageCommands;
        constructor(command: PortMessageCommands);
    }
    class PmDisconnect extends PortMessage {
        constructor();
    }
    class PmConnect extends PortMessage {
        url: string;
        exchangeName: string;
        sid: string;
        hash: string;
        persist: boolean;
        ack: boolean;
        constructor(url: string, exchangeName: string, sid: string, hash: string, isPersist: boolean, isAck?: boolean);
    }
    class PmSubscribe extends PortMessage {
        eventName: string;
        constructor(eventName: string);
    }
    class PmSubChanneled extends PortMessage {
        eventName: string;
        person: string;
        constructor(eventName: string, person?: string);
    }
    class PmUnsubscribe extends PortMessage {
        eventName: string;
        constructor(eventName: string);
    }
    class PmUnsubChanneled extends PortMessage {
        eventName: string;
        person: string;
        constructor(eventName: string, person?: string);
    }
}
export = Page;
