/// <reference path="../resources/stomp.d.ts" />
/// <reference path="../native/AckSender.d.ts" />
/**
 * Класс ответственныйзп откртие STOMP протокола
 * @class Lib/ServerEvent/worker/WorkerStompConnect
 * @memberOf module:ServerEvent.worker
 */
declare class WorkerStompConnect {
    private url;
    private exchangeName;
    private hash;
    private persist;
    private static instance;
    private client;
    private websocket;
    private static STOMP_HEARTBEAT_OUT_TIME;
    private static STOMP_HEARTBEAT_IN_TIME;
    private static LOGIN;
    private static PASSWORD;
    private isCommonSubscribe;
    private channeledEvents;
    private ackSender;
    private isSendAck;
    onmessage: Function;
    onclose: Function;
    private constructor();
    static getConnect(url: string, exchangeName: string, hash: string, persist: boolean, ack: boolean): Promise<WorkerStompConnect>;
    private connect();
    private stompSubscribe();
    private stompSubscribeChannel(channel, person?);
    private stompUnsubscribeChannel(channel, person?);
    private messageHandler(message);
    subscribe(): void;
    subscribeChanneled(eventName: any, person?: string): void;
    unsubscribeChanneled(eventName: any, person?: string): void;
    close(): void;
}
export = WorkerStompConnect;
