import Subscribe = require("Lib/ServerEvent/worker/subscribe");
/**
 * Класс по хранению подписок в разрезе портов(страниц)
 * @class Lib/ServerEvent/worker/SubscribeController
 */
declare class SubscribeController {
    private portHasher;
    private common;
    private channeled;
    /**
     * Храним все порты соединений в одном экземпляре
     * @type {Array}
     */
    ports: MessagePort[];
    register(eventName: string, port: MessagePort): void;
    registerChanneled(eventName: string, port: MessagePort, person: string): void;
    unregisterChanneled(eventName: string, port: MessagePort, person: string): void;
    get(eventName: string): Subscribe[];
    getPorts(): MessagePort[];
    hasChanneled(eventName: string, person: string): boolean;
    removePort(port: MessagePort): void;
    private removeByPort(port, cont);
    /**
     * Очищаем и возвращаем очищенные подписки
     * @return {Subscribe[]}
     */
    clear(): Subscribe[];
}
export = SubscribeController;
