define('js!WSTests/unit/tmpl/compareMarkup', ['Core/markup/ParserUtilities'], function (PU) {
   function getNode(str) {
      var node = PU.parse(str);
      return node;
   }
   function compareMarkup(goodStr, checkStr, straight) {
      if (checkStr instanceof Error) {
         return false;
      }

      checkStr = checkStr.replace(/(\r)|(\n)/g, '');
      goodStr = goodStr.replace(/(\r)|(\n)/g, '');
      checkStr = checkStr.replace(/("ws-[\w]*")|("cfg-[\S]*")/g, '__id__');
      goodStr = goodStr.replace(/("ws-[\w]*")|("cfg-[\S]*")/g, '__id__');

      var getAttribute = PU.Node.prototype.getAttribute,
         setAttribute = PU.Node.prototype.setAttribute,
         innerHTML = PU.Node.prototype.innerHTML,
         outerHTML = PU.Node.prototype.outerHTML,
         getElementsByTagName = PU.Node.prototype.getElementsByTagName,
         hasAttribute = PU.Node.prototype.hasAttribute;

      delete PU.Node.prototype.getAttribute;
      delete PU.Node.prototype.setAttribute;
      delete PU.Node.prototype.innerHTML;
      delete PU.Node.prototype.outerHTML;
      delete PU.Node.prototype.getElementsByTagName;
      delete PU.Node.prototype.hasAttribute;

      PU.Node._forTest = true;

      try {
         goodStr = goodStr.replace(/(\r)|(\n)/g, '');
         goodStr = goodStr.replace(/("ws-[\w]*")|("cfg-[\S]*")/g, '__id__');

         if (straight) {
            assert.equal(checkStr, goodStr);
         } else {
            assert.deepEqual(getNode(checkStr), getNode(goodStr));
         }
      } finally {
         PU.Node.prototype.getAttribute = getAttribute;
         PU.Node.prototype.setAttribute = setAttribute;
         PU.Node.prototype.innerHTML = innerHTML;
         PU.Node.prototype.outerHTML = outerHTML;
         PU.Node.prototype.getElementsByTagName = getElementsByTagName;
         PU.Node.prototype.hasAttribute = hasAttribute;
         PU.Node._forTest = false;
      }
   }
   return compareMarkup;
});
