define('js!WSTests/unit/tmpl/sync-tests/textArea',
   [
      'Core/Control',
      'tmpl!WSTests/unit/tmpl/sync-tests/textArea',
      'WS.Data/Type/descriptor'
   ],
   function (Control,
             template,
             types) {
      'use strict';

      var textArea = Control.extend({
         _template: template
      });

      textArea.getOptionTypes =  function getOptionTypes() {
         return {
            text: types(String),
            editable: types(Boolean).required(),
            alignment: types(String).oneOf([
               'center',
               'left',
               'right'
            ]),
            fontSize: types(Number).required()
         }
      };
      textArea.getDefaultOptions = function getDefaultOptions() {
         return {
            text: 'Default text',
            alignment: 'left'
         };
      };

      return textArea;
   });