define('Transport/prepareGetRPCInvocationURL', [
   'Core/core-merge',
   'Core/constants',
   'Core/Context',
   'Core/helpers/string-helpers-min'
], function(coreMerge, constants, Context, strHelpersMin) {
   'use strict';
    /**
     * @class Transport/prepareGetRPCInvocationURL
     * @public
     * @author Мальцев А.А.
     */
   return function prepareGetRPCInvocationURL (object, method, args, context, serviceUrl, customId) {
        var
            baseUrl = serviceUrl || constants.defaultServiceUrl,
            rpcMethod = encodeURIComponent(object + '.' + method),
            filterParams = coreMerge({}, args || {}),
            id = customId || 0,
            complexKey,
            objName;

        for (var fName in filterParams) {
            if (filterParams.hasOwnProperty(fName)) {
                var param = filterParams[fName];
                if (param !== null && typeof param === 'object' && 'fieldName' in param) {
                    filterParams[fName] = (context || Context.global).getValue(param.fieldName);
                }
                if (fName === 'ИдО') {
                    var oN = filterParams[fName];
                    if (!oN) {
                        return '';
                    }
                    if (typeof oN === 'string') {
                        complexKey = String(oN).split(',');
                        if (complexKey.length === 1) {
                           complexKey = [complexKey[0], ''];
                        }
                        objName = complexKey[1] || object;

                        if (complexKey[0]) {
                            filterParams[fName] = complexKey[0];
                        }
                        rpcMethod = encodeURIComponent(objName + '.' + method);
                    }
                }
            }
        }

        return baseUrl +
            '?id=' + id +
            '&method=' + rpcMethod +
            '&protocol=' + constants.JSONRPC_PROOTOCOL_VERSION +
            '&params=' + encodeURIComponent(strHelpersMin.serializeURLData(filterParams));
    };
});